
/***************************************************
 * Verification of local epsilon contant conjectures
 ***************************************************/

SetLogFile("epsconj-example.log");
GetVersion();

AttachSpec("../magma/spec");
Zx<x> := PolynomialRing(Integers());

// extension with Galois group S3
// which is undecomposed at p=3
L := NumberField(x^6+3);
LECverify(L,3);

// the same computations, but saved in a record
lec := LECcreateRec(L, 3);
LECverify(~lec);
// now check the equivariant discriminant:
lec`dLK;


// another number field, again with group S3
// which is undecomposed at p=3
L := NumberField(x^6 + 3*x^5 - 18*x^4 + 9*x^3 + 24*x^2 - 15*x - 5);
lec := LECcreateRec(L,3);
// compute epsilon constants
LECepsilonConstant(~lec);
// the epsilon constants are actually rational
// so the number field E in the computation can be made smaller
// by replacing the field Q(zeta_m,zeta_p^t) by Q(zeta_m)
lec`Qmpt := CyclotomicField( Exponent(lec`G) );
lec`tLK := [* Rationals()!t  : t in lec`tLK*];
// verify conjecture without recompution epsilon constants
LECverify(~lec);


