
SetLogFile("gfc-example.log");
GetVersion();

Attach("../magma/brauer.m");
Attach("../magma/gfc.m");
Zx<x> := PolynomialRing(Integers());

/***************************************************
 *     Global fundamental class: cyclic case
 ***************************************************/

f := x^6 - 12*x^4 + 36*x^2 - 24;
L := NumberField(f);
time C, f1, gfc := gfcUndecomposed(L,3);
// --> 5 seconds

// Global fundamental class for a non-ablian extension
// with undecomposed place
SetVerbose("GFC", 1);
L := SplittingField(x^6 - 3*x^5 - 6*x^4 + 17*x^3 + 9*x^2 - 18*x + 4);
time gfcUndecomposed(L,3);
// --> 20 seconds



/***************************************************
 *     Global fundamental class: general case
 ***************************************************/

// Global fundamental class for a non-ablian extension
// without undecomposed place
f := x^3 - 4*x + 1;
L := SplittingField(f);
Factorization(Discriminant(RingOfIntegers(L)));
#Factorization(229*RingOfIntegers(L));

// L has subfield Q(sqrt(229))
// consider subfield of Q(zeta_229):
g := x^6 - 4580*x^5 + 517540*x^4 - 17136986*x^3 + 164417420*x^2 - 53936828*x + 229;
L1 := NumberField(g);
time gfcCompositum(L,L1);
// --> 23 minutes



