
SetLogFile("C6.log");
GetVersion();

AttachSpec("../magma/spec");

Zx<x> := PolynomialRing(Rationals());
G := CyclicGroup(6);


/***************************************************
 *     Verify conjecture for G=C6, p=2
 ***************************************************/

time pols := GlobalRepresentations( G, 2 : JR );
pols;
/*
pols := [
    [
        x^6 - 7*x^4 + 14*x^2 - 7,
        x^6 + 2*x^4 + x^2 - 7
    ],
    [
        x^6 - 6*x^4 + 9*x^2 - 3,
        x^6 - 2*x^4 + x^2 - 3
    ],
    [
        x^6 - 14*x^4 + 56*x^2 - 56,
        x^6 - 4*x^4 + 4*x^2 + 8
    ],
    [
        x^6 - 12*x^4 + 36*x^2 - 24,
        x^6 + 4*x^4 + 4*x^2 - 24
    ],
    [
        x^6 - 44*x^4 - 14*x^3 + 349*x^2 - 322*x - 41,
        x^6 - 4*x^4 + 4*x^2 + 24
    ],
    [
        x^6 - 10*x^4 + 24*x^2 - 8,
        x^6 + 4*x^4 + 4*x^2 - 8
    ],
    [   
        x^6 - x^5 - 7*x^4 + 2*x^3 + 7*x^2 - 2*x - 1,
        x^6 - x + 1
    ]
];
*/

// unramified extensions, which keep degree small
// from [KM]
polsUnram := [
    x^6 - x^5 - 7*x^4 + 2*x^3 + 7*x^2 - 2*x - 1,
    x^6 - 9*x^4 - 4*x^3 + 9*x^2 + 3*x - 1,
    x^6 - x^5 - 7*x^4 + 2*x^3 + 7*x^2 - 2*x - 1,
    x^6 - 9*x^4 - 4*x^3 + 9*x^2 + 3*x - 1,
    x^6 - x^5 - 7*x^4 + 2*x^3 + 7*x^2 - 2*x - 1,
    x^6 - x^5 - 7*x^4 + 2*x^3 + 7*x^2 - 2*x - 1,
    x^6 - x^5 - 7*x^4 + 2*x^3 + 7*x^2 - 2*x - 1
];


for i in [1..#pols] do
    L := OptimizedRepresentation(NumberField(pols[i,1]));
    N := NumberField(polsUnram[i]);
    setting := LECcreateRec(L, 2, N);
    LECverify(~setting);
end for;

