
SetLogFile("D4.log");
GetVersion();

AttachSpec("../magma/spec");
SetVerbose("CocycleLFC",1);

/***************************************************
 *     Verify conjecture for G=D4, p=2
 ***************************************************/

// get all extensions of degree 8 over Q_2 by using the
// database of Jones and Roberts
Zy<y> := PolynomialRing(Integers());
Zt<t> := PolynomialRing(Integers());
Zx<x> := PolynomialRing(Integers());
load "JR-Q2deg8.m";
// find global representations for all extensions of degree 8
time pols := GlobalRepresentationsJR(pols, 2);

// select D4-extensions
pols := pols[4];
assert IdentifyGroup(GaloisGroup(pols[1,1])) cmpeq IdentifyGroup(DihedralGroup(4));
pols;
/*
pols := [
    [
        x^8 - 2*x^7 - 20*x^6 + 16*x^5 + 63*x^4 - 16*x^3 - 20*x^2 + 2*x + 1,
        x^8 + 12*x^4 + 16
    ],
    [
        x^8 + 4*x^7 - 12*x^6 - 74*x^5 - 85*x^4 + 50*x^3 + 142*x^2 + 78*x + 13,
        x^8 + 12*x^4 + 144
    ],
    [
        x^8 - 40*x^6 + 84*x^5 + 285*x^4 - 1176*x^3 + 1418*x^2 - 672*x + 109,
        x^8 + 6*x^6 + 6*x^4 + 8*x^3 + 4*x^2 + 8*x + 20
    ],
    [
        x^8 - 16*x^6 + 75*x^4 - 88*x^2 + 1,
        x^8 + 4*x^6 + 40*x^2 + 4
    ],
    [
        x^8 + 4*x^7 - 22*x^6 - 80*x^5 + 139*x^4 + 416*x^3 - 262*x^2 - 484*x + 139,
        x^8 + 8*x^5 + 6*x^4 + 16*x^3 + 8*x^2 + 12
    ],
    [
        x^8 - 4*x^7 - 22*x^6 + 80*x^5 + 91*x^4 - 320*x^3 - 118*x^2 + 292*x - 29,
        x^8 + 12*x^6 + 10*x^4 + 8*x^2 + 36
    ],
    [
        x^8 + 4*x^7 - 28*x^6 - 68*x^5 + 292*x^4 + 212*x^3 - 940*x^2 + 92*x + 529,
        x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 14
    ],
    [
        x^8 - 4*x^7 - 4*x^6 + 20*x^5 + 4*x^4 - 20*x^3 - 4*x^2 + 4*x + 1,
        x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 14
    ],
    [
        0,
        x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 6
    ],
    [
        x^8 + 38*x^4 + 1,
        x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 10
    ],
    [
        x^8 - 4*x^7 - 20*x^6 + 32*x^5 + 162*x^4 + 136*x^3 - 20*x^2 - 56*x - 14,
        x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 2
    ],
    [
        x^8 + 16*x^6 + 52*x^4 + 64*x^2 + 36,
        x^8 + 152*x^4 + 16
    ],
    [
        0,
        x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 6
    ],
    [
        x^8 - 4*x^7 - 8*x^6 + 24*x^5 + 30*x^4 - 16*x^3 - 20*x^2 + 2,
        x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 2
    ],
    [
        x^8 - 12*x^6 + 24*x^4 - 12*x^2 + 1,
        x^8 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 18
    ],
    [
        x^8 - 20*x^6 + 48*x^4 - 20*x^2 + 1,
        x^8 + 44*x^4 + 100
    ],
    [
        x^8 - 64*x^6 + 168*x^5 + 886*x^4 - 5040*x^3 + 9120*x^2 - 6552*x + 1233,
        x^8 + 12*x^6 + 6*x^4 + 4*x^2 + 8*x + 2
    ],
    [
        0,
        x^8 + 52*x^4 + 36
    ]
];
*/

// the other three extensions were found by
// class field techniques

pols := [
    x^8 - 2*x^7 - 20*x^6 + 16*x^5 + 63*x^4 - 16*x^3 - 20*x^2 + 2*x + 1,
    x^8 + 4*x^7 - 12*x^6 - 74*x^5 - 85*x^4 + 50*x^3 + 142*x^2 + 78*x + 13,
    x^8 - 40*x^6 + 84*x^5 + 285*x^4 - 1176*x^3 + 1418*x^2 - 672*x + 109,
    x^8 - 16*x^6 + 75*x^4 - 88*x^2 + 1,
    x^8 + 4*x^7 - 22*x^6 - 80*x^5 + 139*x^4 + 416*x^3 - 262*x^2 - 484*x + 139,
    x^8 - 4*x^7 - 22*x^6 + 80*x^5 + 91*x^4 - 320*x^3 - 118*x^2 + 292*x - 29,
    x^8 + 4*x^7 - 28*x^6 - 68*x^5 + 292*x^4 + 212*x^3 - 940*x^2 + 92*x + 529,
    x^8 - 4*x^7 - 4*x^6 + 20*x^5 + 4*x^4 - 20*x^3 - 4*x^2 + 4*x + 1,
    x^8 - 20*x^6 + 160*x^4 - 600*x^2 + 4356,
    x^8 + 38*x^4 + 1,
    x^8 - 4*x^7 - 20*x^6 + 32*x^5 + 162*x^4 + 136*x^3 - 20*x^2 - 56*x - 14,
    x^8 + 16*x^6 + 52*x^4 + 64*x^2 + 36,
    x^8 + 20*x^6 + 160*x^4 + 600*x^2 + 4356,
    x^8 - 4*x^7 - 8*x^6 + 24*x^5 + 30*x^4 - 16*x^3 - 20*x^2 + 2,
    x^8 - 12*x^6 + 24*x^4 - 12*x^2 + 1,
    x^8 - 20*x^6 + 48*x^4 - 20*x^2 + 1,
    x^8 - 64*x^6 + 168*x^5 + 886*x^4 - 5040*x^3 + 9120*x^2 - 6552*x + 1233,
    x^8 - 80*x^6 + 1972*x^4 - 14880*x^2 + 36
];


for f in pols do
    L := NumberField(f);
    lec := LECcreateRec(L, 2);
    LECverify(~lec);
end for;

