
SetLogFile("D5.log");
GetVersion();

AttachSpec("../magma/spec");

Zx<x> := PolynomialRing(Rationals());
G := DihedralGroup(5);


/***************************************************
 *     Verify conjecture for G=D5, p=2
 ***************************************************/

time pols := GlobalRepresentations( G, 2 );
pols;
// --> no extensions


/***************************************************
 *     Verify conjecture for G=D5, p=5
 ***************************************************/

time pols := GlobalRepresentations( G, 5 );
pols;

/*
pols := [
    x^10 + 10*x^9 - 55*x^8 - 350*x^7 + 640*x^6 + 2350*x^5 - 2315*x^4 - 4250*x^3 + 825*x^2 + 1800*x + 320,
    x^10 - 5*x^9 - 20*x^8 + 110*x^7 + 50*x^6 - 556*x^5 + 245*x^4 + 575*x^3 - 260*x^2 - 140*x + 49,
    x^10 - 10*x^8 + 30*x^7 + 90*x^6 - 162*x^5 + 125*x^4 + 90*x^3 - 80*x^2 - 120*x + 144
];
*/
SetVerbose("CocycleLFC",1);
for f in pols do
    L := NumberField(f);
    lec := LECcreateRec(L, 5);
    LECverify(~lec);
end for;


