
SetLogFile("D6.log");
GetVersion();

AttachSpec("../magma/spec");

Zx<x> := PolynomialRing(Rationals());

/***************************************************
 *     Verify conjecture for G=D6, p=2
 ***************************************************/

// polynomials were computed separately, see
// deg12-polynomials.m
pols := [
    x^12 - 6*x^11 - 3*x^10 + 64*x^9 - 30*x^8 - 234*x^7 + 121*x^6 + 354*x^5 - 132*x^4 - 192*x^3 + 51*x^2 +18*x-3,
    x^12 - 22*x^10 + 120*x^8 - 252*x^6 + 220*x^4 - 72*x^2 + 4,
    x^12 - 24*x^10 + 192*x^8 - 628*x^6 + 864*x^4 - 408*x^2 + 4
];

for f in pols do
    L := NumberField(f);
    lec := LECcreateRec(L, 2);
    LECverify(~lec);
end for;



/***************************************************
 *     Verify conjecture for G=D6, p=3
 ***************************************************/

// polynomials were computed separately, see
// deg12-polynomials.m
pols := [
    x^12 - 27*x^10 - 20*x^9 + 210*x^8 + 240*x^7 - 525*x^6 - 750*x^5 + 255*x^4 + 670*x^3 + 318*x^2 + 60*x + 4,
    x^12 + 6*x^11 - 15*x^10 - 130*x^9 - 6*x^8 + 822*x^7 + 665*x^6 - 1494*x^5 - 1305*x^4 + 1132*x^3 + 612*x^2 - 384*x + 4,
    x^12 - 72*x^10 + 40*x^9 + 1581*x^8 - 1800*x^7 - 11068*x^6 + 20280*x^5 + 12636*x^4 - 47920*x^3 + 33168*x^2 - 8640*x + 736,
    x^12 - 6*x^11 + 21*x^10 - 50*x^9 + 90*x^8 - 126*x^7 + 135*x^6 - 108*x^5 + 135*x^4 - 170*x^3 + 66*x^2 + 12*x + 4,
    x^12 - 36*x^10 + 24*x^9 + 324*x^8 - 180*x^7 - 1134*x^6 + 324*x^5 + 1593*x^4 + 108*x^3 - 810*x^2 - 324*x - 18,
    x^12 + 6*x^11 - 27*x^10 - 196*x^9 - 57*x^8 + 780*x^7 + 230*x^6 - 1032*x^5 + 87*x^4 + 430*x^3 - 171*x^2 + 12*x + 1
];

for f in pols do
    L := NumberField(f);
    lec := LECcreateRec(L, 3);
    LECverify(~lec);
end for;

