
SetLogFile("Q12.log");
GetVersion();

AttachSpec("../magma/spec");

Zx<x> := PolynomialRing(Rationals());

/***************************************************
 *     Verify conjecture for G=Q12, p=2
 ***************************************************/

// polynomials were computed separately, see
// deg12-polynomials.m
pols := [
    x^12 - 42*x^10 - 28*x^9 + 594*x^8 + 612*x^7 - 3584*x^6 - 4356*x^5 + 9552*x^4 + 12264*x^3 - 9684*x^2 - 11664*x + 1516,
    x^12 + 130*x^10 + 5240*x^8 + 83100*x^6 + 481900*x^4 + 775000*x^2 + 312500,
    x^12 - 74*x^10 + 2072*x^8 - 27380*x^6 + 169756*x^4 - 405224*x^2 + 202612,
    x^12 - 24*x^10 - 10*x^9 + 216*x^8 + 180*x^7 - 844*x^6 - 1080*x^5 + 1056*x^4 + 2200*x^3 + 720*x^2 - 240*x - 80
];

for f in pols do
    L := NumberField(f);
    lec := LECcreateRec(L, 2);
    LECverify(~lec);
end for;



/***************************************************
 *     Verify conjecture for G=Q12, p=3
 ***************************************************/

// polynomials were computed separately, see
// deg12-polynomials.m
pols := [ 
    x^12 - 24*x^10 - 10*x^9 + 216*x^8 + 180*x^7 - 844*x^6 - 1080*x^5 + 1056*x^4 + 2200*x^3 + 720*x^2 - 240*x - 80,
    x^12 - 42*x^10 - 28*x^9 + 594*x^8 + 612*x^7 - 3584*x^6 - 4356*x^5 + 9552*x^4 + 12264*x^3 - 9684*x^2 - 11664*x + 1516
];

for f in pols do
    L := NumberField(f);
    lec := LECcreateRec(L, 3);
    LECverify(~lec);
end for;

