
SetLogFile("Q8.log");
GetVersion();

AttachSpec("../magma/spec");
SetVerbose("CocycleLFC",1);

/***************************************************
 *     Verify conjecture for G=Q8, p=2
 ***************************************************/

// get all extensions of degree 8 over Q_2 by using the
// database of Jones and Roberts
Zy<y> := PolynomialRing(Integers());
Zt<t> := PolynomialRing(Integers());
Zx<x> := PolynomialRing(Integers());
load "JR-Q2deg8.m";
// find global representations for all extensions of degree 8
time pols := GlobalRepresentationsJR(pols, 2);

// select Q8-extensions
pols := pols[5];
assert IdentifyGroup(G) cmpne IdentifyGroup(DihedralGroup(4)) and not IsAbelian(G)
    where G := GaloisGroup(pols[1,1]);
pols;
/*
pols := [   
    [   
        x^8 - 60*x^6 + 810*x^4 - 1800*x^2 + 900,
        x^8 + 8*x^6 + 6*x^4 + 16*x^2 + 16*x + 4
    ],
    [   
        x^8 - 60*x^6 + 1170*x^4 - 9000*x^2 + 22500,
        x^8 + 8*x^7 + 8*x^5 + 6*x^4 + 24*x^2 + 12
    ],
    [   
        x^8 - 12*x^6 + 36*x^4 - 36*x^2 + 9,
        x^8 + 14*x^4 + 8*x^3 + 12*x^2 + 8*x + 14
    ],
    [   
        x^8 - 96*x^6 + 168*x^5 + 1566*x^4 - 504*x^3 - 10188*x^2 - 14616*x - 6282,
        x^8 + 8*x^7 + 14*x^4 + 8*x^3 + 12*x^2 + 8*x + 22
    ],
    [   
        x^8 - 80*x^6 + 264*x^5 + 396*x^4 - 2040*x^3 + 184*x^2 + 2832*x + 409,
        x^8 + 14*x^4 + 8*x^3 + 12*x^2 + 8*x + 30
    ],
    [   
        x^8 - 84*x^6 + 2268*x^4 - 19404*x^2 + 441,
        x^8 + 4*x^6 + 2*x^4 + 4*x^2 + 8*x + 6
    ]
];
*/

for f in pols do
    L := NumberField(f[1]);
    lec := LECcreateRec(L, 2);
    LECverify(~lec);
end for;


