
SetLogFile("S3.log");
GetVersion();

AttachSpec("../magma/spec");

Zx<x> := PolynomialRing(Rationals());
G := SymmetricGroup(3);


/***************************************************
 *     Verify conjecture for G=S3, p=2
 ***************************************************/

time pols := GlobalRepresentations( G, 2 : JR );
pols;
/*
pols := [
    [
        x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1,
        x^6 + 3*x^5 + 6*x^4 + 3*x^3 + 9*x + 9
    ]
];
*/
f := pols[1,1];
L := NumberField(f);
Decomposition(L,2);
// --> tamely ramified



/***************************************************
 *     Verify conjecture for G=S3, p=3
 ***************************************************/

time pols := GlobalRepresentations( G, 3 : JR );
pols;
/*
pols := [
    [
        x^6 - 3*x^5 - 6*x^4 + 17*x^3 + 9*x^2 - 18*x + 4,
        x^6 + 3*x^2 + 3
    ],
    [
        x^6 + 3,
        x^6 + 3
    ],
    [
        x^6 - 18*x^4 - 24*x^3 + 27*x^2 + 36*x - 6,
        x^6 + 12
    ],
    [
        x^6 - 36*x^4 + 12*x^3 + 27*x^2 - 18*x + 3,
        x^6 + 21
    ],
    [
        x^6 - 3*x^5 - 6*x^4 + 17*x^3 - 6*x^2 - 3*x + 1,
        x^6 + 6*x^2 + 6
    ],
    [
        x^6 + 3*x^5 - 18*x^4 + 9*x^3 + 24*x^2 - 15*x - 5,
        x^6 + 9*x^2 + 9
    ]
];
*/
for f in pols do
    L := NumberField(f[1]);
    lec := LECcreateRec(L, 3);
    LECverify(~lec);
end for;


