
/*

We compute Global representations for degree 12
extensions of Q_2 and Q_3.

This is done separately because the computation
of all extensions of this degree takes a long time
and should only be done once for each prime.

*/

SetLogFile("deg12-polynomials.log");
GetVersion();

AttachSpec("../magma/spec");

// group Q12 has id <12, 1>
// group A4  has id <12, 3>
// group D6  has id <12, 4>


/***************************************************
 *     Extensions of Q_2
 ***************************************************/

groups := [ <SmallGroup(12,i), 2> : i in [1..NumberOfSmallGroups(12)] | not IsAbelian(SmallGroup(12,i))];

time pols := GlobalRepresentations(groups);
pols;

/***************************************************
 *     Extensions of Q_3
 ***************************************************/

groups := [ <SmallGroup(12,i), 3> : i in [1..NumberOfSmallGroups(12)] | not IsAbelian(SmallGroup(12,i))];

time pols := GlobalRepresentations(groups);
pols;



