/*
The following data was obtained from the Jones/Roberts database
for local fields. It can be downloaded from
http://math.la.asu.edu/~jj/localfields/

It was transformed into a Magma-readable format and
contains information of all degree 8 extensions of Q_2.
*/
pols := [*[*2, 0, 1, 8, 8, x^8 + x^4 + x^3 + x + 1, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*1, "e", [**], "&lt;<i>e</i>&gt;"*], [**], [*1, 8*], [*t^8 + t^4 - t^3 + t^2 + 1, y - 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, -1, 0, 8*], [*2, 8, 2, 4, 8, x^8 + 28*x^4 + 144, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*2, "i", [*2, 1*], "<i>C</i><sub>2</sub>"*], [*2*], [*1, 4*], [*t^4 - t + 1, y^2 + (2*t^3 + 2*t^2 + 2*t + 2)*y + (2*t^3 + 2*t)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 - x + 1, x^4 + 8*x^2 + 4, x^4 - x^2 + 5*]*]*], 0, -1, 1, 8*], [*2, 8, 2, 4, 8, x^8 + 2*x^7 + 8*x^2 + 48, [*16, "t", [*8, 10*]*], 16, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^3 + 4*t^2 + 2*t)*y + (4*t^3 + 2*t^2 + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1, x^4 + 2*x^2 + 4*x + 4, x^4 - 5*]*]*], 0, [*x^2 + 2*x + 2, x^2 + 2*x - 2, x^4 - x^2 + 5*], 3/2, 4*], [*2, 8, 2, 4, 8, x^8 + 2*x^7 + 2*x^6 + 16, [*32, "t", [*8, 20*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^3 + 4*t^2 + 2*t + 6)*y + (6*t^3 + 4*t^2 + 2*t + 6)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^4 + 2*x^3 + 2, x^4 + 2*x^3 + 6*], 7/4, 2*], [*2, 8, 2, 4, 8, x^8 + 2*x^7 + 2*x^6 + 8*x^3 + 48, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*2, "i", [*2, 1*], "<i>C</i><sub>2</sub>"*], [*2*], [*1, 4*], [*t^4 - t + 1, y^2 + (2*t^3 + 2*t^2 + 2*t)*y + (2*t^3 + 2*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, -1, 1, 8*], [*2, 8, 2, 4, 8, x^8 + 2*x^7 + 8*x^2 + 16, [*16, "t", [*8, 7*]*], 16, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + (2*t^3 + 2*t)*y + (2*t^2 + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 28*x^4 + 144*], 3/2, 4*], [*2, 8, 2, 4, 8, x^8 + 2*x^7 + 2*x^6 + 16*x^2 + 16, [*32, "t", [*8, 16*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + (2*t^3 + 2*t + 2)*y + (2*t^3 + 2*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 7/4, 2*], [*2, 8, 2, 4, 8, x^8 + 2*x^6 + 4*x^5 + 16, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + (4*t^2 + 2)*y + (6*t^3 + 4*t^2 + 2*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 4*], 15/8, 2*], [*2, 8, 2, 4, 8, x^8 + 4*x^5 + 8*x^2 + 48, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^2 + 4*t)*y + (2*t + 4)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 4*], 15/8, 2*], [*2, 8, 2, 4, 8, x^8 + 6*x^6 + 4*x^5 + 16, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + 2*y + (2*t^3 + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^7 + 8*x^2 + 4*], 15/8, 2*], [*2, 8, 2, 4, 8, x^8 + 2*x^6 + 8*x^3 + 16, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^2 + 2)*y + (6*t^3 + 4*t^2 + 2*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^7 + 8*x^2 + 4*], 15/8, 2*], [*2, 8, 4, 2, 8, x^8 + 20*x^2 + 4, [*24, "t", [*8, 14*], "<i>S</i><sub>4</sub>"*], 24, [*12, "i", [*4, 4*], "<i>A</i><sub>4</sub>"*], [*4/3, 4/3*], [*3, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^3 + 2*y^2 + (4*t + 6)*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 7/6, 2*], [*2, 8, 4, 2, 8, x^8 + 2*x^5 + 2*x^4 + 4, [*288, "t", [*8, 42*]*], 288, [*48, "i", [*12, 32*], "12T32"*], [*4/3, 4/3, 4/3, 4/3*], [*3, 6*], [*t^2 - t + 1, y^4 + 2*y^3 + 2*y^2 + (2*t + 2)*y + (2*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 31/24, 1*], [*2, 8, 8, 1, 8, x^8 + 2*x + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*8/7, 8/7, 8/7*], [*7, 3*], [*t + 1, y^8 + 2*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 31/28, 1*], [*2, 10, 8, 1, 8, x^8 + 2*x^3 + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*10/7, 10/7, 10/7*], [*7, 3*], [*t + 1, y^8 + 2*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 19/14, 1*], [*2, 10, 8, 1, 8, x^8 + 20*x^2 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 3/2*], [*3, 2*], [*t + 1, y^8 + 26*y^7 + 412*y^6 + 4188*y^5 + 25300*y^4 + 88302*y^3 + 166662*y^2 + 135904*y + 54766*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 4/3, 2*], [*2, 10, 8, 1, 8, x^8 + 4*x^2 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 3/2*], [*3, 2*], [*t + 1, y^8 - 12*y^7 + 104*y^6 + 214*y^5 - 2658*y^4 + 6018*y^3 + 18382*y^2 - 67796*y + 91970*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 4/3, 2*], [*2, 12, 2, 4, 8, x^8 + 6*x^6 + 8*x^5 + 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*2, "i", [*2, 1*], "<i>C</i><sub>2</sub>"*], [*3*], [*1, 4*], [*t^4 - t + 1, y^2 + 4*y + (2*t^3 + 4*t^2 + 6*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - x + 1, x^4 - 6*x^2 + 4, x^4 + 2*x^2 + 20*]*]*], 0, -1, 3/2, 8*], [*2, 12, 2, 4, 8, x^8 + 2*x^6 + 8*x^4 + 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*2, "i", [*2, 1*], "<i>C</i><sub>2</sub>"*], [*3*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^3 + 6*t^2 + 6*t)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - x + 1, x^4 - 2*x^2 + 4, x^4 - 2*x^2 + 20*]*]*], 0, -1, 3/2, 8*], [*2, 12, 2, 4, 8, x^8 + 2*x^6 + 16*x^2 + 16, [*16, "t", [*8, 10*]*], 16, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^3 + 4*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1, x^4 + 2*x^2 - 4, x^4 - 20*]*]*], 0, [*x^2 + 2*x + 2, x^2 + 2*x - 2, x^4 - x^2 + 5*], 2, 4*], [*2, 12, 2, 4, 8, x^8 + 2*x^6 + 16, [*32, "t", [*8, 20*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^3 + 6*t^2 + 6*t + 4)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^4 + 2*x^3 + 2, x^4 + 2*x^3 + 6*], 9/4, 2*], [*2, 12, 2, 4, 8, x^8 + 6*x^6 + 8*x^5 + 80, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*2, "i", [*2, 1*], "<i>C</i><sub>2</sub>"*], [*3*], [*1, 4*], [*t^4 - t + 1, y^2 + 4*y + (10*t^3 + 12*t^2 + 6*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, -1, 3/2, 8*], [*2, 12, 2, 4, 8, x^8 + 2*x^6 + 8*x^4 + 80, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*2, "i", [*2, 1*], "<i>C</i><sub>2</sub>"*], [*3*], [*1, 4*], [*t^4 - t + 1, y^2 + (14*t^3 + 12*t^2 + 2*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, -1, 3/2, 8*], [*2, 12, 2, 4, 8, x^8 + 4*x^6 + 8*x^2 + 80, [*16, "t", [*8, 7*]*], 16, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (4*t^3 + 2*t^2 + 4*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 28*x^4 + 144*], 2, 4*], [*2, 12, 2, 4, 8, x^8 + 2*x^6 + 80, [*32, "t", [*8, 16*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (14*t^3 + 4*t^2 + 2*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 9/4, 2*], [*2, 12, 2, 4, 8, x^8 + 6*x^6 + 112, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (2*t^3 + 2*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 4*], 19/8, 2*], [*2, 12, 2, 4, 8, x^8 + 2*x^6 + 112, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (14*t^3 + 12*t^2 + 8*t + 2)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 4*], 19/8, 2*], [*2, 12, 2, 4, 8, x^8 + 6*x^6 + 48, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (2*t^3 + 4*t^2 + 2*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^7 + 8*x^2 + 4*], 19/8, 2*], [*2, 12, 2, 4, 8, x^8 + 2*x^6 + 48, [*64, "t", [*8, 27*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^4 - t + 1, y^2 + (6*t^3 + 4*t^2 + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x + 1*]*]*], 0, [*x^8 + 4*x^7 + 8*x^2 + 4*], 19/8, 2*], [*2, 12, 4, 2, 8, x^8 + 12*x^4 + 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 6)*y^3 + (4*t + 4)*y + (2*t + 6)*], [*x^4 + 2*x^3 + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 + 2*x^2 + 4*x + 4, x^4 + 2*x^3 + 2*]*]*], 0, -1, 3/2, 8*], [*2, 12, 4, 2, 8, x^8 + 12*x^4 + 144, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 6)*y^3 + (4*t + 4)*y^2 + 4*y + (6*t + 2)*], [*x^4 + 2*x^3 + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 - 5, x^4 + 2*x^3 + 6*]*]*], 0, -1, 3/2, 8*], [*2, 12, 4, 2, 8, x^8 + 2*x^7 + 2*x^4 + 12, [*16, "t", [*8, 10*]*], 16, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 2*], [*1, 4*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^3 + (2*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5, x^4 + 2*x^2 + 4*x + 4, x^4 - 5*]*]*], 0, [*x^2 + 2*x - 2, x^2 + 2*x + 2, x^4 + x + 1*], 3/2, 4*], [*2, 12, 4, 2, 8, x^8 + 24*x^2 + 4, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], 24, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 2*], [*1, 6*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^3 + 2*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 3/2, 2*], [*2, 12, 4, 2, 8, x^8 + 2*x^7 + 2*x^6 + 2*x^4 + 4, [*96, "t", [*8, 33*]*], 96, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 6*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^3 + (2*t + 2)*y^2 + (2*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 15/8, 1*], [*2, 12, 4, 2, 8, x^8 + 8*x^7 + 48, [*96, "t", [*8, 33*]*], 96, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 6*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 15/8, 1*], [*2, 12, 4, 2, 8, x^8 + 12*x^4 + 80, [*32, "t", [*8, 16*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 4*], [*t^2 - t + 1, y^4 + 2*y^3 + (2*t + 2)*y^2 + (2*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 2*x^7 + 8*x^2 + 48*], 7/4, 2*], [*2, 12, 4, 2, 8, x^8 + 8*x^6 + 12*x^4 + 80, [*32, "t", [*8, 21*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 4*], [*t^2 - t + 1, y^4 + 6*t*y^3 + (4*t + 2)*y^2 + 4*t*y + (6*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 2*x^7 + 8*x^2 + 48*], 7/4, 2*], [*2, 12, 4, 2, 8, x^8 + 12*x^6 + 12*x^4 + 80, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^2 - t + 1, y^4 + 2*t*y^3 + (2*t + 2)*y^2 + (2*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 15/8, 2*], [*2, 12, 4, 2, 8, x^8 + 4*x^7 + 16*x^3 + 48, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^2 - t + 1, y^4 + (2*t + 6)*y^3 + (4*t + 6)*y^2 + 4*y + (4*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 15/8, 2*], [*2, 12, 4, 2, 8, x^8 + 8*x^5 + 4*x^4 + 48, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^3 + 2*y^2 + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 15/8, 2*], [*2, 12, 4, 2, 8, x^8 + 4*x^6 + 28*x^4 + 80, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 2*], [*1, 4*], [*t^2 - t + 1, y^4 + 2*y^3 + 2*y^2 + (2*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 15/8, 2*], [*2, 12, 8, 1, 8, x^8 + 28*x^2 + 4, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*4/3, 4/3, 2*], [*3, 2*], [*t + 1, y^8 - 8*y^7 - 148*y^6 - 2246*y^5 + 16022*y^4 + 236116*y^3 + 3250242*y^2 - 5499172*y + 3214706*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 19/12, 2*], [*2, 12, 8, 1, 8, x^8 + 12*x^2 + 4, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*4/3, 4/3, 2*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 36*y^6 - 254*y^5 + 1814*y^4 - 3772*y^3 + 15366*y^2 - 20980*y + 13726*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 19/12, 2*], [*2, 12, 8, 1, 8, x^8 + 4*x^5 + 4, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*12/7, 12/7, 12/7*], [*7, 3*], [*t + 1, y^8 + 2*y^6 + 2*y^5 - 14*y^4 - 16*y^3 - 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 45/28, 1*], [*2, 12, 8, 1, 8, x^8 + 2*x^5 + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*12/7, 12/7, 12/7*], [*7, 3*], [*t + 1, y^8 + 2*y^5 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 45/28, 1*], [*2, 12, 8, 1, 8, x^8 + 28*x^2 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 2*], [*3, 2*], [*t + 1, y^8 - 8*y^7 - 264*y^6 + 182*y^5 + 33688*y^4 + 24160*y^3 + 2882206*y^2 - 3689392*y + 2598862*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 19/12, 2*], [*2, 12, 8, 1, 8, x^8 + 12*x^2 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 2*], [*3, 2*], [*t + 1, y^8 + 150*y^6 + 762*y^5 + 4030*y^4 + 32040*y^3 + 136386*y^2 + 365580*y + 517590*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 19/12, 2*], [*2, 14, 8, 1, 8, x^8 + 2*x^7 + 6, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], 24, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 3*], [*t + 1, y^8 + 2*y^7 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 7/4, 2*], [*2, 14, 8, 1, 8, x^8 + 2*x^7 + 2, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], 24, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 3*], [*t + 1, y^8 + 2*y^7 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 7/4, 2*], [*2, 14, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 4, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 4*], [*t + 1, y^8 + 10*y^7 + 50*y^6 + 176*y^5 + 526*y^4 + 796*y^3 + 1236*y^2 + 1276*y + 706*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^4 + x + 1, x^4 + 2*x^3 + 6*], 7/4, 2*], [*2, 14, 8, 1, 8, x^8 + 4*x^7 + 8*x^2 + 4, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 4*], [*t + 1, y^8 + 4354*y^7 - 8802*y^6 - 44264*y^5 + 221986*y^4 - 505128*y^3 + 710608*y^2 - 547584*y + 168902*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^4 + x + 1, x^4 + 2*x^3 + 2*], 7/4, 2*], [*2, 14, 8, 1, 8, x^8 + 2*x^7 + 2*x^6 + 2, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], 56, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 7*], [*t + 1, y^8 + 2*y^7 + 2*y^6 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 7/4, 1*], [*2, 14, 8, 1, 8, x^8 + 4*x^7 + 4, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], 56, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 2*], [*1, 7*], [*t + 1, y^8 + 1618*y^7 - 6460*y^6 + 10736*y^5 - 4806*y^4 + 92*y^3 + 14840*y^2 - 8760*y + 4798*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 7/4, 1*], [*2, 14, 8, 1, 8, x^8 + 28*x^2 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 + 2*y^7 - 154*y^6 - 56*y^5 + 36428*y^4 - 197540*y^3 + 918386*y^2 - 1564316*y + 840522*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 14, 8, 1, 8, x^8 + 20*x^2 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 + 22*y^7 + 414*y^6 + 3732*y^5 + 14858*y^4 + 65516*y^3 + 305422*y^2 + 514740*y + 1906866*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 14, 8, 1, 8, x^8 + 12*x^2 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 + 10*y^7 + 192*y^6 + 928*y^5 - 1648*y^4 + 6428*y^3 + 168106*y^2 + 623112*y + 1040518*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 14, 8, 1, 8, x^8 + 4*x^2 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 - 2*y^7 + 38*y^6 + 92*y^5 - 400*y^4 - 4360*y^3 + 14054*y^2 + 83688*y + 429550*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 14, 8, 1, 8, x^8 + 20*x^2 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 + 30*y^7 + 522*y^6 + 5568*y^5 + 39960*y^4 + 177336*y^3 + 458226*y^2 + 330048*y + 207846*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 14, 8, 1, 8, x^8 + 12*x^2 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 + 10*y^7 + 160*y^6 + 796*y^5 + 2296*y^4 + 9292*y^3 + 18598*y^2 + 8224*y + 79810*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 14, 8, 1, 8, x^8 + 28*x^2 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 + 42*y^7 + 936*y^6 + 12624*y^5 + 110646*y^4 + 587952*y^3 + 1672686*y^2 + 780948*y + 326430*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 14, 8, 1, 8, x^8 + 4*x^2 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 5/2*], [*3, 2*], [*t + 1, y^8 - 6*y^7 + 18*y^6 - 40*y^5 + 54*y^4 - 36*y^3 + 26*y^2 - 12*y + 18*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 223/96, 2*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 2*x^4 + 4*x^2 + 8*x + 12, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + 6*t*y^2 + 4*y + (2*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - x^2 + 5, x^4 - 2*x^2 + 4, x^4 + 2*x^2 + 20*]*]*], 0, -1, 2, 8*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 20, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (2*t + 4)*y^2 + 4*y + (6*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 + 2*x^2 + 20, x^4 - 2*x^2 + 20*]*]*], 0, -1, 2, 8*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 28, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + 2*t*y^2 + 4*y + (6*t + 14)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - x^2 + 5, x^4 - 6*x^2 + 4, x^4 - 2*x^2 + 20*]*]*], 0, -1, 2, 8*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 6*x^4 + 8*x^3 + 4*x^2 + 8*x + 20, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 6*t*y^2 + 4*y + (6*t + 2)*], [*x^4 + 6*x^2 + 4*x + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 + 2*x^2 - 4, x^4 + 6*x^2 + 4*x + 2*]*]*], 0, -1, 2, 8*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 40*x^2 + 4, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 2*y^2 + (8*t + 4)*y + 14*], [*x^4 + 6*x^2 + 4*x + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 - 20, x^4 + 2*x^2 + 4*x + 6*]*]*], 0, -1, 2, 8*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 8*x^2 + 4, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], 8, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + 10*y^2 + (8*t + 12)*y + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2, x^2 + 2, x^2 + 10, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 - 6*x^2 + 4, x^4 - 2*x^2 + 4, x^4 + 6*x^2 + 4*x + 6, x^4 + 6*x^2 + 4*x + 14, x^4 + 6*x^2 + 1, x^4 + 2*x^2 + 4*x + 10*]*]*], 0, -1, 2, 8*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 6*x^4 + 12*x^2 + 8*x + 12, [*16, "t", [*8, 10*]*], 16, [*4, "i", [*4, 2*], "<i>V</i><sub>4</sub>"*], [*2, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + 6*t*y^2 + 4*y + (6*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5, x^4 + 2*x^2 - 4, x^4 - 20*]*]*], 0, [*x^2 + 2*x - 2, x^2 + 2*x + 2, x^4 + x + 1*], 2, 4*], [*2, 16, 4, 2, 8, x^8 + 8*x^5 + 12, [*24, "t", [*8, 14*], "<i>S</i><sub>4</sub>"*], 24, [*12, "i", [*4, 4*], "<i>A</i><sub>4</sub>"*], [*8/3, 8/3*], [*3, 2*], [*t^2 - t + 1, y^4 + 4*y^2 + 4*y + (4*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 13/6, 2*], [*2, 16, 4, 2, 8, x^8 + 2*x^4 + 8*x + 12, [*24, "t", [*8, 14*], "<i>S</i><sub>4</sub>"*], 24, [*12, "i", [*4, 4*], "<i>A</i><sub>4</sub>"*], [*8/3, 8/3*], [*3, 2*], [*t^2 - t + 1, y^4 + 4*y + (6*t + 6)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 13/6, 2*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y^3 + (6*t + 14)*y^2 + (12*t + 12)*y + (6*t + 10)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 5, x^4 - 2*x^2 + 4, x^4 - 20*]*]*], 0, [*x^2 + 2*x - 2, x^4 - 5*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 4*x^7 + 2*x^6 + 4*x^5 + 2*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^3 + (6*t + 14)*y^2 + (12*t + 12)*y + (10*t + 6)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4, x^4 - 2*x^2 + 4, x^4 + 2*x^2 - 4*]*]*], 0, [*x^2 + 2*x + 2, x^4 + 2*x^2 + 4*x + 4*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 12, [*16, "t", [*8, 10*]*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 6)*y^2 + (4*t + 4)*y + (2*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5, x^4 + 2*x^2 + 20, x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 - 5, x^2 + x + 1, x^2 + 2*x + 2*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y^3 + (2*t + 10)*y^2 + (12*t + 12)*y + (10*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4, x^4 - 6*x^2 + 4, x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^2 + 2*x + 2*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^2 + 12, [*16, "t", [*8, 10*]*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 6)*y^2 + (4*t + 4)*y + (6*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 2*x^2 + 20, x^4 - 20*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^2 + x + 1, x^2 + 2*x - 2*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28, [*16, "t", [*8, 10*]*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + 2*y^2 + (4*t + 8)*y + (10*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4, x^4 - 2*x^2 + 20, x^4 - 20*]*]*], 0, [*x^2 + x + 1, x^2 + 2*x - 2, x^4 + 2*x^2 + 4*x + 4*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^3 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (6*t + 14)*y^2 + (4*t + 4)*y + (6*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 5, x^4 - 6*x^2 + 4, x^4 - 20*]*]*], 0, [*x^4 - 5, x^2 + 2*x - 2*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 20, [*16, "t", [*8, 10*]*], 16, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 6)*y^2 + (4*t + 4)*y + (6*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5, x^4 - 2*x^2 + 20, x^4 + 2*x^2 - 4*]*]*], 0, [*x^2 + x + 1, x^2 + 2*x + 2, x^4 - 5*], 9/4, 4*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 20*x^4 + 16, [*32, "t", [*8, 20*]*], 32, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + (2*t + 4)*y^2 + (4*t + 4)*y + (2*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 2*x^2 + 4*x + 6*], 5/2, 2*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 12, [*32, "t", [*8, 20*]*], 32, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + 2*t*y^2 + (4*t + 4)*y + (2*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 2*x^2 + 4*x + 6*], 5/2, 2*], [*2, 16, 4, 2, 8, x^8 + 2*x^4 + 8*x^2 + 8*x + 4, [*96, "t", [*8, 34*]*], 96, [*48, "i", [*12, 32*], "12T32"*], [*4/3, 4/3, 8/3, 8/3*], [*3, 2*], [*t^2 - t + 1, y^4 + 4*y^2 + 4*y + (6*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 55/24, 1*], [*2, 16, 4, 2, 8, x^8 + 12*x^7 + 20*x^5 + 16*x^4 + 40*x + 20, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*t*y^3 + (4*t + 6)*y^2 + (4*t + 4)*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 4*x^5 + 6*x^4 + 6, x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 10*], [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 4*x + 6*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 4*x^4 + 16, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + 6*t*y^2 + (4*t + 4)*y + (6*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 6, x^8 + 4*x^5 + 2*x^4 + 2*], [*x^4 + 6*x^2 + 1, x^4 + 6*x^2 + 4*x + 6*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 12*x^6 + 4*x^4 + 16, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (12*t + 6)*y^2 + (12*t + 4)*y + (8*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 4*x^5 + 2*x^4 + 10, x^8 + 8*x^6 + 64*x + 16*], [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 4*x + 14*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 10*x^4 + 8*x^3 + 12*x^2 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 4)*y^2 + (4*t + 4)*y + (2*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 4*x^5 + 6*x^4 + 14, x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 2*], [*x^4 + 6*x^2 + 1, x^4 + 6*x^2 + 4*x + 14*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 4*x^5 + 6*x^4 + 12, [*288, "t", [*8, 42*]*], 288, [*48, "i", [*12, 32*], "12T32"*], [*8/3, 8/3, 8/3, 8/3*], [*3, 6*], [*t^2 - t + 1, y^4 + (4*t + 4)*y + (2*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 61/24, 1*], [*2, 16, 4, 2, 8, x^8 + 4*x^5 + 24*x + 12, [*288, "t", [*8, 42*]*], 288, [*48, "i", [*12, 32*], "12T32"*], [*8/3, 8/3, 8/3, 8/3*], [*3, 6*], [*t^2 - t + 1, y^4 + 4*y^3 + 4*y^2 + (4*t + 4)*y + (4*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 61/24, 1*], [*2, 16, 4, 2, 8, x^8 + 4*x^5 + 8*x + 12, [*288, "t", [*8, 42*]*], 288, [*48, "i", [*12, 32*], "12T32"*], [*8/3, 8/3, 8/3, 8/3*], [*3, 6*], [*t^2 - t + 1, y^4 + 4*y^3 + 4*y^2 + 4*t*y + (4*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 61/24, 1*], [*2, 16, 4, 2, 8, x^8 + 4*x^5 + 6*x^4 + 4, [*288, "t", [*8, 42*]*], 288, [*48, "i", [*12, 32*], "12T32"*], [*8/3, 8/3, 8/3, 8/3*], [*3, 6*], [*t^2 - t + 1, y^4 + (4*t + 4)*y + (2*t + 6)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [**]*]*], 0, -1, 61/24, 1*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 2*x^4 + 4*x^2 + 8*x + 12, [*32, "t", [*8, 16*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + (2*t + 4)*y^2 + 4*y + (2*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 2*x^7 + 8*x^2 + 48*], 9/4, 2*], [*2, 16, 4, 2, 8, x^8 + 8*x^7 + 20, [*32, "t", [*8, 21*]*], 32, [*8, "i", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + (4*t + 2)*y^2 + 4*y + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 2*x^7 + 8*x^2 + 48*], 9/4, 2*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 8*x^3 + 4, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + (6*t + 6)*y^2 + (4*t + 4)*y + (2*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 19/8, 2*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 4*x^5 + 6*x^4 + 8*x^3 + 4, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + (2*t + 2)*y^2 + (4*t + 4)*y + (6*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 19/8, 2*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 4*x^5 + 6*x^4 + 4, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^2 + (4*t + 4)*y + (6*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 19/8, 2*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 4, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 2, 2, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + (6*t + 6)*y^2 + (4*t + 4)*y + (2*t + 6)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^7 + 2*x^6 + 16*], 19/8, 2*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 4*x^5 + 10*x^4 + 4*x^2 + 12, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + 6*t*y^2 + (4*t + 4)*y + (2*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 28*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 20*x^4 + 208, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + (14*t + 4)*y^2 + (4*t + 12)*y + (10*t + 10)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 6*x^6 + 2*x^4 + 4*x^2 + 8*x + 12*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 4*x^2 + 12, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + 6*t*y^2 + (4*t + 12)*y + (10*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 28*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 4*x^2 + 12, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (2*t + 4)*y^2 + (4*t + 4)*y + (2*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 6*x^6 + 2*x^4 + 4*x^2 + 8*x + 12*], 5/2, 4*], [*2, 16, 4, 2, 8, x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 4*x^2 + 4, [*32, "t", [*8, 21*]*], 32, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + 2*t*y^2 + (4*t + 4)*y + (2*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 6*x^6 + 6*x^4 + 12*x^2 + 8*x + 12*], 5/2, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 4*x^4 + 80, [*32, "t", [*8, 21*]*], 32, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + (2*t + 4)*y^2 + 4*t*y + (6*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 6*x^6 + 6*x^4 + 12*x^2 + 8*x + 12*], 5/2, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^7 + 2*x^6 + 8*x^4 + 4*x^2 + 4, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (14*t + 10)*y^2 + (8*t + 4)*y + 10*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 2*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^4 + 112, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 12)*y^3 + (14*t + 2)*y^2 + (4*t + 8)*y + (10*t + 6)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 10*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^4 + 240, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (6*t + 6)*y^2 + 4*t*y + (6*t + 6)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 2*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^4 + 16*x^2 + 112, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + 6*y^2 + 4*y + (2*t + 6)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 10*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 8*x^6 + 4*x^4 + 240, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (6*t + 6)*y^2 + (4*t + 8)*y + (10*t + 10)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 2*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 24*x^6 + 4*x^4 + 240, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + (6*t + 6)*y^2 + 4*t*y + (2*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 2*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 20*x^4 + 16*x^2 + 112, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 12*y^3 + (12*t + 6)*y^2 + (8*t + 12)*y + (14*t + 6)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 2*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 12*x^4 + 112, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 12*y^3 + (4*t + 10)*y^2 + (8*t + 4)*y + (14*t + 2)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 2*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 14*x^4 + 12*x^2 + 8*x + 4, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y^3 + (12*t + 10)*y^2 + (8*t + 12)*y + (14*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 6*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 48, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + (6*t + 2)*y^2 + 4*t*y + (2*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 168*x^4 + 912*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 3, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 12*y^3 + 6*y^2 + 12*y + (14*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 168*x^4 + 912*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^4 + 48, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (6*t + 6)*y^2 + 4*t*y + (6*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 6*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^6 + 28*x^4 + 48, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 12*t*y^3 + (2*t + 10)*y^2 + 12*y + (8*t + 10)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 6*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 16*x^5 + 20*x^4 + 112, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + (4*t + 8)*y^3 + (2*t + 2)*y^2 + 12*t*y + (10*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 6*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 4*x^7 + 10*x^6 + 20*x^2 + 4, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^3 + (14*t + 14)*y^2 + (8*t + 4)*y + 10*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 6*], 21/8, 2*], [*2, 16, 4, 2, 8, x^8 + 24*x^6 + 4*x^4 + 48, [*64, "t", [*8, 30*]*], 128, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 3*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + (6*t + 6)*y^2 + 4*t*y + (2*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^3 + 6*], 21/8, 2*], [*2, 16, 8, 1, 8, x^8 + 14*x^6 + 4, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 4952620*y^6 - 29715608*y^5 + 75113568*y^4 - 102350368*y^3 + 79357058*y^2 - 33254916*y + 5900054*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 2*x^6 + 4, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 72*y^4 - 64*y^3 + 38*y^2 - 12*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 6*x^6 + 4, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 8940*y^6 - 53528*y^5 + 136608*y^4 - 189728*y^3 + 152602*y^2 - 68404*y + 13598*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 10*x^6 + 4, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 419036*y^6 - 2514104*y^5 + 6375592*y^4 - 8741824*y^3 + 6850510*y^2 - 2921564*y + 532986*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 4*x + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*16/7, 16/7, 16/7*], [*7, 3*], [*t + 1, y^8 + 4*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 59/28, 1*], [*2, 16, 8, 1, 8, x^8 + 4*x + 6, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*16/7, 16/7, 16/7*], [*7, 3*], [*t + 1, y^8 + 4*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 59/28, 1*], [*2, 16, 8, 1, 8, x^8 + 8*x^5 + 20, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 2, 7/3, 7/3*], [*3, 2*], [*t + 1, y^8 - 12*y^7 + 56*y^6 - 132*y^5 + 150*y^4 - 64*y^3 - 32*y^2 + 36*y + 38*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 103/48, 1*], [*2, 16, 8, 1, 8, x^8 + 8*x^5 + 4, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 2, 7/3, 7/3*], [*3, 2*], [*t + 1, y^8 - 4*y^7 - 16*y^6 - 8*y^5 + 98*y^4 - 128*y^3 + 76*y^2 - 20*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 103/48, 1*], [*2, 16, 8, 1, 8, x^8 + 4*x^6 + 28*x^4 + 20, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 5/2*], [*1, 2*], [*t + 1, y^8 + 20*y^7 + 322*y^6 + 1100*y^5 + 6164*y^4 - 58028*y^3 + 217744*y^2 - 323732*y + 203114*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 12*x^4 + 16*], 2, 2*], [*2, 16, 8, 1, 8, x^8 + 8*x^4 + 336, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 5/2*], [*1, 2*], [*t + 1, y^8 + 14*y^6 + 144*y^5 + 1104*y^4 + 6408*y^3 + 22964*y^2 + 43020*y + 66070*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 12*x^4 + 144*], 2, 2*], [*2, 16, 8, 1, 8, x^8 + 8*x^4 + 80, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 5/2*], [*1, 4*], [*t + 1, y^8 + 2*y^6 + 20*y^5 + 96*y^4 + 200*y^3 + 456*y^2 + 1796*y + 2146*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 2, 4*], [*2, 16, 8, 1, 8, x^8 + 2*x^6 + 4*x + 6, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 5/2*], [*1, 4*], [*t + 1, y^8 + 2*y^6 + 4*y + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 2, 4*], [*2, 16, 8, 1, 8, x^8 + 12*x^6 + 28*x^4 + 52, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 5/2*], [*1, 4*], [*t + 1, y^8 + 36*y^7 + 75118*y^6 + 747624*y^5 + 37585564*y^4 - 52508352*y^3 + 584097072*y^2 - 334666332*y + 67193802*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 2, 4*], [*2, 16, 8, 1, 8, x^8 + 8*x^3 + 8*x^2 + 24, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 5/2*], [*1, 4*], [*t + 1, y^8 + 6*y^6 + 12*y^4 + 16*y^3 + 80*y^2 + 108*y + 54*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 2, 4*], [*2, 16, 8, 1, 8, x^8 + 6*x^6 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 7662*y^6 - 45860*y^5 + 164990*y^4 - 354376*y^3 + 553078*y^2 - 519612*y + 226930*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 10*x^6 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 410018*y^6 - 2459996*y^5 + 8178010*y^4 - 16312216*y^3 + 21379498*y^2 - 16694468*y + 6617806*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 2*x^6 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 20*y^6 - 8*y^5 + 340*y^4 - 1456*y^3 + 598*y^2 + 1780*y + 19858*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 14*x^6 + 20, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*4/3, 4/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 4920982*y^6 - 29525780*y^5 + 93230310*y^4 - 176082856*y^3 + 213964078*y^2 - 154497772*y + 56093690*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 25/12, 2*], [*2, 16, 8, 1, 8, x^8 + 8*x^2 + 52, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 5/2*], [*1, 6*], [*t + 1, y^8 - 8*y^7 + 10*y^6 - 344*y^5 + 2814*y^4 + 8384*y^3 + 54080*y^2 + 90204*y + 102662*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 35/16, 2*], [*2, 16, 8, 1, 8, x^8 + 8*x^2 + 20, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 5/2*], [*1, 6*], [*t + 1, y^8 - 8*y^7 + 22*y^6 - 8*y^5 + 494*y^4 + 288*y^3 + 1852*y^2 + 5412*y + 3322*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 35/16, 2*], [*2, 16, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 20, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 5/2*], [*1, 6*], [*t + 1, y^8 + 24*y^7 + 31754*y^6 - 7980*y^5 + 93242*y^4 + 131040*y^3 + 1983672*y^2 + 1922940*y + 5996430*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 35/16, 2*], [*2, 16, 8, 1, 8, x^8 + 56*x^2 + 52, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 5/2*], [*1, 6*], [*t + 1, y^8 - 282*y^6 + 1548*y^5 + 104690*y^4 + 1297344*y^3 + 7426012*y^2 + 14644188*y + 10277722*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 35/16, 2*], [*2, 16, 8, 1, 8, x^8 + 14*x^6 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 4913482*y^6 - 29480780*y^5 + 97533324*y^4 - 193594912*y^3 + 252665630*y^2 - 196756764*y + 77992930*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 16, 8, 1, 8, x^8 + 10*x^6 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 407550*y^6 - 2445188*y^5 + 8451768*y^4 - 17505968*y^3 + 25332114*y^2 - 22172708*y + 9774622*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 16, 8, 1, 8, x^8 + 2*x^6 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 16*y^6 + 16*y^5 + 1038*y^4 - 4408*y^3 + 2522*y^2 + 3900*y + 211298*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 16, 8, 1, 8, x^8 + 6*x^6 + 28, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 7250*y^6 - 43388*y^5 + 157764*y^4 - 341952*y^3 + 703638*y^2 - 838988*y + 367450*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 16, 8, 1, 8, x^8 + 10*x^6 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 416552*y^6 - 2499200*y^5 + 6309346*y^4 - 8576200*y^3 + 7047466*y^2 - 3606980*y + 945986*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 16, 8, 1, 8, x^8 + 14*x^6 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 4945104*y^6 - 29670512*y^5 + 75234682*y^4 - 103135464*y^3 + 82550110*y^2 - 37950572*y + 8140734*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 16, 8, 1, 8, x^8 + 2*x^6 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 24*y^6 - 32*y^5 + 82*y^4 - 264*y^3 + 130*y^2 + 268*y + 474*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 16, 8, 1, 8, x^8 + 6*x^6 + 12, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 2, 7/3, 7/3, 3*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 8512*y^6 - 50960*y^5 + 126826*y^4 - 167720*y^3 + 160822*y^2 - 122012*y + 52342*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 247/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^6 + 8, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 686*y^6 + 294*y^4 + 42*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 10*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^6 + 8, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 54*y^6 + 54*y^4 + 18*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 14*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^6 + 8, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^6 + 6*y^4 + 6*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 6*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^6 + 8, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 250*y^6 + 150*y^4 + 30*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 6*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 14*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^6 + 40, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^6 + 30*y^4 + 150*y^2 + 250*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 10*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^6 + 40, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 504*y^6 + 890*y^4 + 4870*y^2 + 490*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^6 + 40, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 160*y^6 + 370*y^4 + 2210*y^2 + 90*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^6 + 40, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 54*y^6 + 270*y^4 + 450*y^2 + 250*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^6 + 56, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 504*y^6 + 1246*y^4 + 7182*y^2 + 350*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 10*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^6 + 56, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 24*y^6 + 126*y^4 + 742*y^2 + 126*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^6 + 56, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 10758*y^6 + 21966*y^4 - 182966*y^2 + 270494*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 6*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 14*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^6 + 56, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^6 + 42*y^4 + 294*y^2 + 686*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 14*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 14*x^6 + 24, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 686*y^6 + 882*y^4 + 378*y^2 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 10*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 6*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 2*x^6 + 24, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 2*y^6 + 18*y^4 + 54*y^2 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 10*x^6 + 24, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 250*y^6 + 450*y^4 + 270*y^2 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 17, 8, 1, 8, x^8 + 6*x^6 + 24, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*4/3, 4/3, 3, 19/6, 19/6, 13/4*], [*3, 2*], [*t + 1, y^8 + 54*y^6 + 162*y^4 + 162*y^2 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x + 2*]*]*], 0, -1, 295/96, 2*], [*2, 18, 4, 2, 8, x^8 + 14*x^6 + 10*x^4 + 12*x^2 + 16*x + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y^3 + 14*t*y^2 + 8*y + (10*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 - 2*x^2 + 2, x^4 + 6*x^2 + 2*]*]*], 0, [*x^2 + 14, x^2 + 14, x^4 + 2*x^2 + 4*x + 10*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 24*x^4 + 36, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 + 2*x^2 + 6, x^4 - 2*x^2 + 6*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 6, x^2 + 10, x^2 + 10*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 14*x^6 + 10*x^4 + 8*x^3 + 12*x^2 + 20, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (14*t + 8)*y^2 + (8*t + 8)*y + (10*t + 14)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 4*x^7 + 8*x^6 + 2*x^4 + 4, x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 2*], [*x^4 + 6*x^2 + 1, x^4 - 2*x^2 + 4*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 10*x^6 + 10*x^4 + 4*x^2 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 10*t*y^2 + (10*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 10, x^4 + 2*x^2 + 10*]*]*], 0, [*x^2 + 6, x^2 + 6, x^4 + 6*x^2 + 1*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 14*x^4 + 20*x^2 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (10*t + 4)*y^2 + (14*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 4*x^7 + 8*x^6 + 10*x^4 + 4, x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 8*x + 10*], [*x^4 - 2*x^2 + 4, x^4 + 2*x^2 + 4*x + 10*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 16*x^4 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 72*x^4 + 656, x^8 + 56*x^4 + 144*], [*x^4 + 6*x^2 + 4*x + 6, x^4 - 6*x^2 + 4*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 8*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 14)*y^2 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4, x^4 + 2*x^2 - 2, x^4 - 2*x^2 - 2*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 14, x^2 + 2, x^2 + 2*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 36, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 14)*y^2 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], [*x^8 + 72*x^4 + 144, x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 8*x^3 + 12*x^2 + 14*], [*x^4 + 6*x^2 + 4*x + 14, x^4 - 6*x^2 + 4*], 11/4, 4*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 6*x^4 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 6)*y^2 + (6*t + 10)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^4 - 6*x^2 + 3, x^4 + 2*x^2 + 3*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 20*x^2 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^4 + 2*x^2 - 9, x^4 + 6*x^2 - 9*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^4 + 12*x^2 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + (10*t + 6)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^4 + 6*x^2 - 1, x^4 + 2*x^2 - 1*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 10*x^4 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^2 + (2*t + 14)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^4 + 2*x^2 - 9, x^4 + 6*x^2 - 9*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 2*x^4 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 6)*y^2 + (10*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^4 + 6*x^2 - 1, x^4 + 2*x^2 - 1*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 14*x^4 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 6)*y^2 + (14*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^4 + 6*x^2 + 3, x^4 - 2*x^2 + 3*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^4 + 4*x^2 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 14)*y^2 + (6*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^4 + 2*x^2 + 3, x^4 - 6*x^2 + 3*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 4*x^2 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (10*t + 6)*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^4 + 6*x^2 + 3, x^4 - 2*x^2 + 3*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 16*x^2 + 20, [*32, "t", [*8, 21*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + (8*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 20*], 23/8, 2*], [*2, 18, 4, 2, 8, x^8 + 8*x^6 + 52, [*32, "t", [*8, 21*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 14)*y^2 + (8*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 20*], 23/8, 2*], [*2, 18, 4, 2, 8, x^8 + 16*x^5 + 36, [*32, "t", [*8, 21*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (4*t + 6)*y^2 + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^2 + 12*], 23/8, 2*], [*2, 18, 4, 2, 8, x^8 + 4*x^7 + 2*x^6 + 10*x^4 + 20*x^2 + 4, [*32, "t", [*8, 21*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + 2*t*y^2 + (2*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2*x + 2, x^2 + 2*x - 2*]*], [*4, [*x^4 + 8*x^2 + 4*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^2 + 12*], 23/8, 2*], [*2, 18, 4, 2, 8, x^8 + 10*x^4 + 4*x^2 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 10)*y^2 + (2*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 2*x^4 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 14)*y^2 + (10*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 14*x^4 + 4*x^2 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + (14*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 6*x^4 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 10)*y^2 + (6*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 14*x^4 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 10)*y^2 + (14*t + 10)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 10*x^6 + 12*x^2 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 14)*y^2 + (8*t + 6)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 2*x^4 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 10)*y^2 + (10*t + 14)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 10*x^4 + 12*x^2 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + (2*t + 6)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 12*x^6 + 28*x^4 + 28, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 2)*y^2 + (12*t + 6)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 2*x^4 + 4*x^2 + 28, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 6*t*y^2 + (10*t + 2)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 20*x^4 + 16*x^3 + 24*x^2 + 60, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (12*t + 2)*y^2 + 8*y + (12*t + 14)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 12*x^6 + 12*x^4 + 28, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 10)*y^2 + (12*t + 14)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 14*x^4 + 28, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 10)*y^2 + (14*t + 6)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 12*x^2 + 10*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 8*x^5 + 6*x^4 + 28, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 10)*y^2 + (8*t + 8)*y + (6*t + 14)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 6*x^4 + 28, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 10)*y^2 + (6*t + 14)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 12*x^2 + 10*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 8*x^5 + 14*x^4 + 28, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 10)*y^2 + (8*t + 8)*y + (14*t + 6)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^4 + 4*x^2 + 28, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + (14*t + 6)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 2*x^4 + 28, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (10*t + 14)*y^2 + (10*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 14*x^4 + 4*x^2 + 28, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 14)*y^2 + (6*t + 14)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 2*x^4 + 28, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 10)*y^2 + (10*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 4*x^6 + 20*x^4 + 44, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + 10*y^2 + (4*t + 14)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 6*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 4*x^6 + 4*x^4 + 44, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + 2*y^2 + (4*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 6*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 12*x^4 + 8*x^2 + 44, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + (12*t + 2)*y^2 + (4*t + 6)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 6*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 12*x^6 + 4*x^4 + 12, [*64, "t", [*8, 27*]*], 64, [*16, "i", [*8, 10*], "T10"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + 6*y^2 + (4*t + 14)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - x^2 + 5*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 6*], 3, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^4 + 12*x^2 + 12, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 2)*y^2 + (14*t + 14)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 14*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 10*x^4 + 16*x^2 + 12, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 6)*y^2 + (2*t + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 8*x^7 + 48*x^5 + 80*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 4*x^7 + 2*x^6 + 8*x^5 + 2*x^4 + 28, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^3 + (14*t + 10)*y^2 + (8*t + 8)*y + (10*t + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 8*x^7 + 48*x^5 + 80*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 6*x^6 + 2*x^4 + 12, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 2)*y^2 + (2*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 5*]*]*], 0, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 14*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 10*x^4 + 4*x^2 + 12, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 2)*y^2 + (10*t + 10)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 6*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 10*x^4 + 12*x^2 + 12, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 6)*y^2 + (10*t + 10)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 6*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 14*x^4 + 12, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 2)*y^2 + (14*t + 14)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 6*], 51/16, 2*], [*2, 18, 4, 2, 8, x^8 + 2*x^6 + 6*x^4 + 12, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 2)*y^2 + (6*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 4*x + 4*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 6*], 51/16, 2*], [*2, 18, 8, 1, 8, x^8 + 2*x^6 + 4*x^3 + 2, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 4*y^3 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 2*x^3 + 2, x^4 + 6*x^2 + 1, x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^2 + x + 1, x^4 + 2*x^3 + 2*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 6*x^6 + 4*x^3 + 6, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 4*y^3 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 2*x^3 + 6, x^4 + 6*x^2 + 4*x + 6, x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^2 + x + 1, x^4 + 2*x^3 + 6*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 2*x^6 + 4*x^3 + 10, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 4*y^3 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^3 + 2, x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^2 + x + 1, x^4 + 2*x^3 + 2*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 168*x^4 + 912, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 2*], [*t + 1, y^8 + 16*y^7 + 358*y^6 + 2920*y^5 + 4048*y^4 - 7676*y^3 + 170080*y^2 - 258776*y + 561838*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 2*x^3 + 6, x^4 + 6*x^2 + 4*x + 14, x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^2 + x + 1, x^4 + 2*x^3 + 6*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 12*x^6 + 36, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], 24, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 3*], [*t + 1, y^8 + 300*y^7 + 21370*y^6 - 166860*y^5 + 792486*y^4 - 142188*y^3 - 3831572*y^2 - 2016792*y + 14122234*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 12*x^6 + 4, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], 24, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 3*], [*t + 1, y^8 + 828*y^7 + 2659814*y^6 - 22688336*y^5 + 93433510*y^4 - 214855732*y^3 + 290972776*y^2 - 285011656*y + 189043642*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 4*x^6 + 4, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], 24, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 3*], [*t + 1, y^8 - 16*y^7 + 170*y^6 - 1016*y^5 + 4094*y^4 - 10700*y^3 + 18944*y^2 - 20272*y + 11894*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 4*x^6 + 36, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], 24, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 3*], [*t + 1, y^8 - 4*y^7 + 86*y^6 - 168*y^5 + 2490*y^4 - 2340*y^3 + 34960*y^2 - 11248*y + 193262*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 6*x^6 + 4*x^3 + 2, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 4*], [*t + 1, y^8 + 6*y^6 + 4*y^3 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^4 + x + 1, x^4 + 2*x^3 + 6*], 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 2*x^6 + 4*x^3 + 6, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 3*], "<i>C</i><sub>2</sub><sup>3</sup>"*], [*2, 2, 3*], [*1, 4*], [*t + 1, y^8 + 2*y^6 + 4*y^3 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^4 + x + 1, x^4 + 2*x^3 + 2*], 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 2*x^4 + 4*x^3 + 6, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 8/3, 8/3*], [*3, 2*], [*t + 1, y^8 + 2*y^4 + 4*y^3 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 7/3, 2*], [*2, 18, 8, 1, 8, x^8 + 2*x^4 + 4*x^3 + 2, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 8/3, 8/3*], [*3, 2*], [*t + 1, y^8 + 2*y^4 + 4*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 7/3, 2*], [*2, 18, 8, 1, 8, x^8 + 6*x^4 + 4*x^3 + 6, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 8/3, 8/3*], [*3, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^3 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 7/3, 2*], [*2, 18, 8, 1, 8, x^8 + 6*x^4 + 4*x^3 + 2, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 8/3, 8/3*], [*3, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 7/3, 2*], [*2, 18, 8, 1, 8, x^8 + 4*x^3 + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*18/7, 18/7, 18/7*], [*7, 3*], [*t + 1, y^8 + 4*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 33/14, 1*], [*2, 18, 8, 1, 8, x^8 + 4*x^3 + 4*x^2 + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*18/7, 18/7, 18/7*], [*7, 3*], [*t + 1, y^8 + 4*y^3 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 33/14, 1*], [*2, 18, 8, 1, 8, x^8 + 4*x^4 + 4*x^3 + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*18/7, 18/7, 18/7*], [*7, 3*], [*t + 1, y^8 + 4*y^4 + 4*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 33/14, 1*], [*2, 18, 8, 1, 8, x^8 + 4*x^3 + 4*x^2 + 6, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*18/7, 18/7, 18/7*], [*7, 3*], [*t + 1, y^8 + 4*y^3 + 4*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 33/14, 1*], [*2, 18, 8, 1, 8, x^8 + 2*x^4 + 4*x^3 + 4*x^2 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 2, 8/3, 8/3*], [*3, 2*], [*t + 1, y^8 + 2*y^4 + 4*y^3 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 115/48, 1*], [*2, 18, 8, 1, 8, x^8 + 2*x^4 + 4*x^3 + 4*x^2 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 2, 8/3, 8/3*], [*3, 2*], [*t + 1, y^8 + 2*y^4 + 4*y^3 + 4*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 115/48, 1*], [*2, 18, 8, 1, 8, x^8 + 56*x^4 + 80, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 3*], [*1, 2*], [*t + 1, y^8 + 44*y^7 + 934*y^6 + 11176*y^5 + 40968*y^4 - 319572*y^3 + 835972*y^2 - 1057584*y + 609854*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 12*x^4 + 144*], 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 8*x^7 + 4, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 3*], [*1, 2*], [*t + 1, y^8 + 270480*y^7 + 121002*y^6 - 31680*y^5 + 1070964*y^4 + 17164*y^3 + 3837980*y^2 - 332136*y + 17658594*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 12*x^4 + 16*], 9/4, 2*], [*2, 18, 8, 1, 8, x^8 + 24*x^4 + 208, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 3*], [*1, 4*], [*t + 1, y^8 - 2*y^6 - 16*y^5 + 20*y^4 + 28*y^3 + 36*y^2 - 16*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 20, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 3*], [*1, 4*], [*t + 1, y^8 + 2068*y^7 + 1385678*y^6 - 10807580*y^5 + 40819280*y^4 - 64804180*y^3 + 53000520*y^2 - 21151400*y + 3708310*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 8*x^7 + 36, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 3*], [*1, 4*], [*t + 1, y^8 + 86004*y^7 - 1092250*y^6 + 5982716*y^5 - 14529012*y^4 + 17582140*y^3 - 42687824*y^2 - 9996120*y - 72328822*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 2*x^6 + 4*x^5 + 4*x^3 + 14, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 2, 3*], [*1, 4*], [*t + 1, y^8 + 2*y^6 + 4*y^5 + 4*y^3 + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 2*x^7 + 2*x^4 + 12*], 9/4, 4*], [*2, 18, 8, 1, 8, x^8 + 28*x^6 + 52, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 3*], [*1, 6*], [*t + 1, y^8 + 1660*y^7 + 733190*y^6 - 4510192*y^5 + 21994302*y^4 - 58070660*y^3 + 116125564*y^2 - 127448952*y + 86897806*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 39/16, 2*], [*2, 18, 8, 1, 8, x^8 + 12*x^6 + 20, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 3*], [*1, 6*], [*t + 1, y^8 - 64*y^7 + 8290*y^6 - 25996*y^5 + 91870*y^4 - 111268*y^3 + 111712*y^2 - 46000*y + 13278*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 39/16, 2*], [*2, 18, 8, 1, 8, x^8 + 28*x^6 + 20, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 3*], [*1, 6*], [*t + 1, y^8 + 10628*y^7 + 28991166*y^6 - 230896576*y^5 + 871805270*y^4 - 1755854884*y^3 + 1874369468*y^2 - 987092624*y + 205121194*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 39/16, 2*], [*2, 18, 8, 1, 8, x^8 + 4*x^6 + 20, [*192, "t", [*8, 38*]*], 192, [*32, "t", [*8, 22*]*], [*2, 2, 2, 2, 3*], [*1, 6*], [*t + 1, y^8 - 16*y^7 + 118*y^6 - 500*y^5 + 1290*y^4 - 2004*y^3 + 1784*y^2 - 832*y + 170*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 39/16, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 14*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (2*t + 14)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 6*x^2 - 9, x^4 + 2*x^2 - 1*]*]*], 0, [*x^2 + 2*x + 2, x^2 + 2*x + 2, x^4 + 6*x^2 + 4*x + 14*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 8*x^6 + 2*x^4 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (8*t + 8)*y^2 + (14*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], [*x^8 + 14*x^6 + 10*x^4 + 8*x^3 + 12*x^2 + 20, x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 2*], [*x^4 + 6*x^2 + 1, x^4 + 8*x^2 + 4*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 6*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (10*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 6*x^2 - 1, x^4 + 2*x^2 - 9*]*]*], 0, [*x^2 + 2*x + 2, x^2 + 2*x + 2, x^4 + 6*x^2 + 4*x + 6*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 72*x^4 + 656, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (4*t + 4)*y^2 + (4*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], [*x^8 + 16*x^4 + 4, x^8 + 56*x^4 + 144*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 4*x + 6*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 40*x^4 + 528, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 12*y^3 + 12*t*y^2 + (8*t + 8)*y + (12*t + 10)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4, x^4 + 6*x^2 + 3, x^4 - 6*x^2 + 3*]*]*], 0, [*x^2 + 2*x - 2, x^2 + 2*x - 2, x^4 + 2*x^2 + 4*x + 10*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 8*x^6 + 10*x^4 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (8*t + 8)*y^2 + (6*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], [*x^8 + 2*x^6 + 14*x^4 + 20*x^2 + 4, x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 8*x + 10*], [*x^4 + 2*x^2 + 4*x + 10, x^4 + 8*x^2 + 4*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 72*x^4 + 144, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 12*y^3 + (4*t + 4)*y^2 + 8*t*y + (4*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], [*x^8 + 36, x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 8*x^3 + 12*x^2 + 14*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 4*x + 14*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 10*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (6*t + 10)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4, x^4 + 2*x^2 + 3, x^4 - 2*x^2 + 3*]*]*], 0, [*x^4 + 6*x^2 + 1, x^2 + 2*x - 2, x^2 + 2*x - 2*], 11/4, 4*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 6*x^4 + 20, [*32, "t", [*8, 20*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + (2*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^4 + 2*x^3 + 2, x^4 + 2*x^2 + 4*x + 6*], 23/8, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 2*x^4 + 20, [*32, "t", [*8, 20*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + (6*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 2*x^3 + 6*], 23/8, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 24*x^2 + 20, [*32, "t", [*8, 20*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (4*t + 8)*y^2 + (10*t + 14)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 2*x^3 + 6*], 23/8, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20, [*32, "t", [*8, 20*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (12*t + 8)*y^2 + (14*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^4 + 2*x^3 + 2, x^4 + 2*x^2 + 4*x + 6*], 23/8, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 10*x^4 + 8*x^2 + 4, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (8*t + 12)*y^2 + (6*t + 10)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 12*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 8*x^6 + 10*x^4 + 12, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^3 + (8*t + 8)*y^2 + (14*t + 14)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^6 + 20*x^4 + 16*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 12*x^6 + 8*x^5 + 10*x^4 + 20, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^3 + (4*t + 4)*y^2 + (8*t + 8)*y + (6*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^6 + 20*x^4 + 16*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 2*x^4 + 28, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^3 + (6*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 12*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 10*x^4 + 28, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^3 + (14*t + 6)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 12*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^7 + 44, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + 8*y^2 + (12*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^6 + 20*x^4 + 16*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^7 + 12, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^3 + 8*y^2 + (12*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^6 + 20*x^4 + 16*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^6 + 16*x^3 + 12, [*64, "t", [*8, 28*]*], 64, [*16, "i", [**], "<i>C</i><sub>2</sub><sup>4</sup>"*], [*2, 3, 3, 7/2*], [*1, 4*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + 12*y^2 + (12*t + 10)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 12*], 3, 2*], [*2, 20, 4, 2, 8, x^8 + 10*x^4 + 8*x^3 + 20, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (6*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^2 + 100*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^6 + 10*x^4 + 8*x^3 + 28, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (8*t + 8)*y^2 + (14*t + 6)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 8*x^6 + 100*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 10*x^4 + 8*x^3 + 12, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (14*t + 14)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 16*x^2 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 40*x^6 + 240, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 12*t*y^3 + 4*y^2 + 8*y + (4*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 8*x^6 + 36*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 24*x^6 + 240, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + 4*t*y^2 + 6*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 8*x^6 + 36*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 24*x^6 + 112, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 8)*y^3 + 12*t*y^2 + (12*t + 10)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^2 + 36*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 40*x^6 + 112, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + (8*t + 4)*y^2 + 8*y + 2*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^2 + 36*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^6 + 240, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 8)*y^3 + (4*t + 8)*y^2 + 8*t*y + (8*t + 2)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 16*x^2 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 56*x^6 + 64*x^5 + 240, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + (4*t + 8)*y^2 + (8*t + 8)*y + (8*t + 14)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 16*x^2 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 2*x^4 + 8*x^3 + 28, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (6*t + 14)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 8*x^6 + 100*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 2*x^4 + 8*x^3 + 20, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (14*t + 10)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^2 + 100*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 24*x^6 + 496, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 8)*y^3 + (8*t + 4)*y^2 + 8*t*y + (10*t + 14)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 16*x^2 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^6 + 112, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*t*y^3 + 4*t*y^2 + (4*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 10*x^4 + 8*x^3 + 4, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (6*t + 10)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 12*x^6 + 6*x^4 + 8*x^3 + 28, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (4*t + 12)*y^2 + (2*t + 10)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^5 + 10*x^4 + 8*x^3 + 16*x + 4, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + 8*t*y + (6*t + 10)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 4*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 14*x^4 + 8*x^3 + 20, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (2*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 12*x^2 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 4, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (12*t + 12)*y^2 + (6*t + 10)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 16*x^5 + 20*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 6*x^4 + 8*x^3 + 20, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (10*t + 14)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 12*x^2 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 12*x^6 + 2*x^4 + 8*x^3 + 4, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^3 + (4*t + 4)*y^2 + (14*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 16*x^5 + 20*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 8*x^3 + 44, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*t*y^3 + 8*y^2 + (12*t + 10)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 16*x^5 + 84*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 16*x^7 + 8*x^6 + 240, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 12*y^3 + 4*t*y^2 + 8*y + (6*t + 10)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 12*x^4 + 12*x^2 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 12*x^7 + 24*x^6 + 24*x^4 + 8*x^3 + 32*x^2 + 28, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^3 + 4*y^2 + 8*y + (4*t + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 12*x^7 + 24*x^4 + 8*x^3 + 48*x^2 + 60, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 12)*y^3 + (8*t + 4)*y^2 + 8*y + (4*t + 10)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 6*x^4 + 8*x^3 + 28, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (2*t + 10)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 6*x^4 + 8*x^3 + 12, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^3 + (2*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 16*x^5 + 84*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 14*x^4 + 8*x^3 + 16*x^2 + 20, [*64, "t", [*8, 26*]*], 64, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*t*y^3 + 8*y^2 + (2*t + 6)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 12*x^4 + 12*x^2 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 4*x^7 + 4*x^6 + 14*x^4 + 8*x^3 + 20, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*t*y^3 + (4*t + 4)*y^2 + (2*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 6*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 6*x^4 + 8*x^3 + 4, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (10*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^5 + 52*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^5 + 6*x^4 + 8*x^3 + 4, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (8*t + 8)*y + (10*t + 6)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^5 + 52*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 14*x^4 + 8*x^3 + 4, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (2*t + 14)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^5 + 52*], 51/16, 2*], [*2, 20, 4, 2, 8, x^8 + 8*x^5 + 14*x^4 + 8*x^3 + 4, [*64, "t", [*8, 30*]*], 128, [*32, "i", [*16, 51*], "16T51"*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^3 + (8*t + 8)*y + (2*t + 14)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 16*x^5 + 52*], 51/16, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 2*x^4 + 2, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^5 + 2*y^4 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], [*x^8 + 4*x^6 + 4*x^4 + 16, x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 6*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 4*x + 6*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 6*x^4 + 14, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^5 + 6*y^4 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], [*x^8 + 2*x^6 + 4*x^5 + 10*x^4 + 8*x^3 + 12*x^2 + 4, x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 2*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 1*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 2, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^5 + 6*y^4 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], [*x^8 + 2*x^6 + 4*x^5 + 10*x^4 + 8*x^3 + 12*x^2 + 4, x^8 + 4*x^5 + 6*x^4 + 14*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 4*x + 14*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 10, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^5 + 6*y^4 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], [*x^8 + 12*x^7 + 20*x^5 + 16*x^4 + 40*x + 20, x^8 + 4*x^5 + 6*x^4 + 6*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 4*x + 6*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 6, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^5 + 2*y^4 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], [*x^8 + 4*x^6 + 4*x^4 + 16, x^8 + 4*x^5 + 2*x^4 + 2*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 1*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 8*x^6 + 64*x + 16, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 20*y^7 + 8644*y^6 - 58348*y^5 + 153742*y^4 - 49640*y^3 - 408288*y^2 + 682832*y - 297202*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], [*x^8 + 12*x^6 + 4*x^4 + 16, x^8 + 4*x^5 + 2*x^4 + 10*], [*x^4 + 8*x^2 + 4, x^4 + 2*x^2 + 4*x + 10*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 2*x^4 + 10, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^5 + 2*y^4 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], [*x^8 + 12*x^6 + 4*x^4 + 16, x^8 + 8*x^6 + 64*x + 16*], [*x^4 + 8*x^2 + 4, x^4 + 6*x^2 + 4*x + 14*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 6*x^4 + 6, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^5 + 6*y^4 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], [*x^8 + 12*x^7 + 20*x^5 + 16*x^4 + 40*x + 20, x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 10*], [*x^4 + 8*x^2 + 4, x^4 + 2*x^2 + 4*x + 10*], 5/2, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 4*x^5 + 6*x^4 + 6, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 4*], [*t + 1, y^8 + 4*y^6 + 4*y^5 + 6*y^4 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^4 - x^2 + 5, x^4 + 6*x^2 + 4*x + 2*], 5/2, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 2*x^4 + 6, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 4*], [*t + 1, y^8 + 4*y^5 + 2*y^4 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^4 - x^2 + 5, x^4 + 6*x^2 + 4*x + 2*], 5/2, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^2 + 10, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 4*y^5 + 4*y^2 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^2 + 2, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 4*y^5 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 24*x^6 + 20*x^4 + 36, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 16*y^7 + 104288*y^6 - 535532*y^5 + 1181972*y^4 - 1444544*y^3 + 1088812*y^2 - 527592*y + 138078*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^2 + 14, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 4*y^5 + 4*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^4 + 4*x^2 + 2, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 4*y^5 + 4*y^4 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^4 + 4*x^2 + 10, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 4*y^5 + 4*y^4 + 4*y^2 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^2 + 6, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 4*y^5 + 4*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^7 + 4*x^5 + 4*x^4 + 4*x^2 + 2, [*48, "t", [*8, 24*], "<i>S</i><sub>4</sub><i>C</i><sub>2</sub>"*], 48, [*24, "t", [*8, 13*], "<i>A</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*8/3, 8/3, 3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^5 + 4*y^4 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 31/12, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 6, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*20/7, 20/7, 20/7*], [*7, 3*], [*t + 1, y^8 + 4*y^5 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 73/28, 1*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^4 + 6, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*20/7, 20/7, 20/7*], [*7, 3*], [*t + 1, y^8 + 4*y^5 + 4*y^4 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 73/28, 1*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*20/7, 20/7, 20/7*], [*7, 3*], [*t + 1, y^8 + 4*y^5 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 73/28, 1*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 4*x^4 + 2, [*168, "t", [*8, 36*], "<i>C</i><sub>2</sub><sup>3</sup>:(<i>C</i><sub>7</sub>:<i>C</i><sub>3</sub>)"*], 168, [*56, "t", [*8, 25*], "<i>C</i><sub>2</sub><sup>3</sup>:<i>C</i><sub>7</sub>"*], [*20/7, 20/7, 20/7*], [*7, 3*], [*t + 1, y^8 + 4*y^5 + 4*y^4 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [**]*], [*4, [**]*]*], 0, -1, 73/28, 1*], [*2, 20, 8, 1, 8, x^8 + 8*x^6 + 16*x^5 + 80, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 - 88*y^7 + 2348*y^6 - 7156*y^5 + 16130*y^4 - 26256*y^3 + 28448*y^2 - 20048*y + 8746*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^4 - x^2 + 5, x^4 + 2*x^2 + 4*x + 6*], 5/2, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 6*x^4 + 2, [*32, "t", [*8, 19*]*], 32, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 3*], [*1, 2*], [*t + 1, y^8 + 4*y^5 + 6*y^4 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^4 - x^2 + 5, x^4 + 2*x^2 + 4*x + 6*], 5/2, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 2*x^4 + 4*x^2 + 6, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 2, 3, 3*], [*1, 3*], [*t + 1, y^8 + 4*y^5 + 2*y^4 + 4*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 43/16, 1*], [*2, 20, 8, 1, 8, x^8 + 8*x^7 + 80, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 2, 3, 3*], [*1, 3*], [*t + 1, y^8 + 4092*y^7 - 28272*y^6 + 81724*y^5 - 118910*y^4 + 80584*y^3 - 5492*y^2 - 20048*y + 7046*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 43/16, 1*], [*2, 20, 8, 1, 8, x^8 + 8*x^7 + 16, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 2, 3, 3*], [*1, 3*], [*t + 1, y^8 + 3340*y^7 + 56*y^6 + 4444*y^5 + 28418*y^4 + 27296*y^3 + 112852*y^2 - 42960*y + 104850*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 43/16, 1*], [*2, 20, 8, 1, 8, x^8 + 4*x^5 + 2*x^4 + 4*x^2 + 2, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 2, 3, 3*], [*1, 3*], [*t + 1, y^8 + 4*y^5 + 2*y^4 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 43/16, 1*], [*2, 20, 8, 1, 8, x^8 + 16*x^5 + 52, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 1474*y^6 + 543684*y^5 - 2421616*y^4 + 3286600*y^3 + 367288*y^2 - 3871448*y + 2170830*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 - 2*x^2 + 20*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 16*x^2 + 4, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 30*y^6 - 68*y^5 + 108*y^4 - 128*y^3 + 112*y^2 - 64*y + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 6, x^4 + 2*x^2 + 20*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 6*x^6 + 4*x^5 + 6, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 4*y^5 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 - 2*x^2 + 20*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 8*x^6 + 4, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 30074*y^6 - 180332*y^5 + 454212*y^4 - 614784*y^3 + 469612*y^2 - 190456*y + 31802*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 6, x^4 + 2*x^2 + 20*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 8*x^6 + 100, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 434*y^6 - 2492*y^5 + 8560*y^4 - 17776*y^3 + 31664*y^2 - 34336*y + 160642*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2, x^4 + 6*x^2 + 2, x^4 + 6*x^2 + 10*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^2 + 14, x^2 + 6*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 16*x^5 + 20, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 562*y^6 + 547092*y^5 - 2696940*y^4 + 5158344*y^3 - 4507884*y^2 + 1497208*y + 33478*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6, x^4 - 2*x^2 - 2, x^4 - 2*x^2 + 6*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 6, x^2 + 2, x^2 + 10*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 16*x^2 + 100, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 22*y^6 - 20*y^5 + 24*y^4 - 112*y^3 + 372*y^2 - 488*y + 378*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2, x^4 - 2*x^2 + 2, x^4 + 6*x^2 + 10*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^2 + 6, x^2 + 14*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 6*x^6 + 4*x^5 + 12*x^2 + 6, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 4*y^5 + 12*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6, x^4 + 2*x^2 - 2, x^4 - 2*x^2 + 6*]*]*], 0, [*x^2 + 2, x^2 + 10, x^4 + 2*x^2 + 4*x + 6*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 8*x^6 + 36, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 2050*y^6 - 12188*y^5 + 37072*y^4 - 67184*y^3 + 20880*y^2 + 60192*y + 15354*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2, x^4 - 2*x^2 + 2, x^4 + 2*x^2 + 10*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^2 + 14, x^2 + 6*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 16*x^2 + 36, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 26*y^6 - 44*y^5 + 52*y^4 - 64*y^3 + 52*y^2 - 8*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2, x^4 + 6*x^2 + 2, x^4 + 2*x^2 + 10*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^2 + 6, x^2 + 14*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 2*x^6 + 4*x^5 + 12*x^4 + 12*x^2 + 6, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 4*y^5 + 12*y^4 + 12*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6, x^4 - 2*x^2 - 2, x^4 + 2*x^2 + 6*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 6, x^2 + 2, x^2 + 10*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 16*x^5 + 84, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 3946*y^6 + 534212*y^5 - 2236120*y^4 + 4950320*y^3 - 3863196*y^2 + 785904*y + 120126*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6, x^4 + 2*x^2 - 2, x^4 + 2*x^2 + 6*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 6, x^2 + 2, x^2 + 10*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^7 + 6*x^6 + 4*x^5 + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^6 + 4*y^5 + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^7 + 2*x^6 + 4*x^5 + 2*x^4 + 4*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 52, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 106*y^6 - 524*y^5 + 3736*y^4 - 11600*y^3 + 49792*y^2 - 77696*y + 220286*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^3 + 4*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 20, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 58*y^6 - 236*y^5 + 860*y^4 - 2016*y^3 + 4228*y^2 - 4968*y + 5726*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^3 + 4*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 24*x^2 + 20, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 42*y^6 - 140*y^5 + 396*y^4 - 800*y^3 + 1040*y^2 - 768*y + 242*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^7 + 2*x^6 + 4*x^5 + 2*x^4 + 4*], 23/8, 2*], [*2, 20, 8, 1, 8, x^8 + 8*x^4 + 20, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 46*y^6 - 164*y^5 + 488*y^4 - 1008*y^3 + 1696*y^2 - 1728*y + 1522*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 8*x^4 + 52, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 106*y^6 - 524*y^5 + 2184*y^4 - 5392*y^3 + 2260*y^2 + 4952*y + 1022914*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 8*x^4 + 116, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 98*y^6 - 476*y^5 + 2208*y^4 - 5808*y^3 + 9636*y^2 - 8840*y + 276050*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^7 + 8*x^2 + 56, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 32*y^7 + 6*y^6 - 84*y^5 + 12*y^4 - 168*y^3 + 8*y^2 + 686*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 12*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 2*x^6 + 4*x^5 + 8*x^3 + 14, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 4*y^5 + 8*y^3 + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 12*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^7 + 2*x^6 + 4*x^5 + 6, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^6 + 4*y^5 + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 12*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 8*x^4 + 84, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 142*y^6 - 740*y^5 + 5232*y^4 - 16144*y^3 + 50800*y^2 - 71200*y + 1095042*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 2*x^6 + 4*x^5 + 12*x^2 + 6, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 4*y^5 + 12*y^2 + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 12*], 23/8, 4*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 28, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 462*y^6 - 2660*y^5 + 69258*y^4 - 259448*y^3 + 2010148*y^2 - 3508408*y + 19365102*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 12*x^6 + 60, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 7126*y^6 - 42644*y^5 + 235210*y^4 - 656696*y^3 + 1489948*y^2 - 1780136*y + 989134*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 60, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 74*y^6 - 332*y^5 + 1270*y^4 - 3016*y^3 + 3508*y^2 - 1784*y + 4622*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 12*x^6 + 28, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 7182*y^6 - 42980*y^5 + 167538*y^4 - 383768*y^3 + 604492*y^2 - 555976*y + 231302*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 24*x^2 + 60, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 46*y^6 - 164*y^5 + 886*y^4 - 2600*y^3 + 1528*y^2 + 1792*y + 23734*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 8*x^2 + 28, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 34*y^6 - 92*y^5 + 162*y^4 - 184*y^3 + 8*y^2 + 192*y + 454*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 24*x^2 + 28, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 - 298*y^6 + 1900*y^5 + 30978*y^4 - 136728*y^3 + 369784*y^2 - 460960*y + 291154*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 8*x^2 + 60, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 34*y^6 - 92*y^5 + 34*y^4 + 328*y^3 - 2456*y^2 + 4096*y + 14398*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 20*x^6 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 129582*y^6 - 777380*y^5 + 2227570*y^4 - 3727896*y^3 + 3853192*y^2 - 2323520*y + 623502*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 8*x^2 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 34*y^6 - 92*y^5 + 178*y^4 - 248*y^3 + 244*y^2 - 152*y + 70*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 24*x^2 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 46*y^6 - 164*y^5 + 550*y^4 - 1256*y^3 + 3868*y^2 - 5576*y + 2902*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 12*x^6 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 45502*y^6 - 272900*y^5 + 763306*y^4 - 1234040*y^3 + 987520*y^2 - 234608*y + 1775110*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 4*x^6 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 38*y^6 - 116*y^5 + 250*y^4 - 376*y^3 + 376*y^2 - 224*y + 62*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 28*x^6 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 794930*y^6 - 4769468*y^5 + 13178014*y^4 - 20915752*y^3 + 20164408*y^2 - 11215808*y + 2770886*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 40*x^2 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 262*y^6 - 1460*y^5 + 20178*y^4 - 71128*y^3 + 416876*y^2 - 695304*y + 331666*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 20, 8, 1, 8, x^8 + 56*x^2 + 12, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 2, 3, 3, 7/2*], [*1, 3*], [*t + 1, y^8 - 8*y^7 + 70*y^6 - 308*y^5 + 1870*y^4 - 5576*y^3 + 146908*y^2 - 283400*y + 148246*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 99/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 4*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 4*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 14*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 12*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 14*y^6 + 12*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 14*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^6 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 8*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 8*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 14*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 12*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^6 + 12*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 14*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 8*x^2 + 8, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 - 14*y^6 + 1556*y^4 + 1892*y^2 + 578*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 24*x^2 + 8, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 18*y^6 + 108*y^4 + 216*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 10*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 10*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 10*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 10*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 14*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 14*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 10*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 2*y^6 + 10*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 6*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 6*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 14*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 10*y^6 + 14*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 14*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 14*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 2*x^4 + 2, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 2*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 4*x^6 + 160, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 30*y^6 + 300*y^4 + 1000*y^2 + 6250*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 8*x^6 + 56*x^2 + 40, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 170*y^6 + 1068*y^4 + 3344*y^2 + 250*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 8*x^2 + 40, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 12*y^4 + 8*y^2 + 250*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 12*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 14*y^6 + 12*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 4*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 4*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 8*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 8*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^3 + 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 6*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 10*x^4 + 8*x^2 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 10*y^6 + 10*y^4 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 14*x^4 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 2*y^6 + 14*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 2*x^4 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 2*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 6*x^4 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 10*y^6 + 6*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 14*x^4 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 10*y^6 + 14*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 6*x^4 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 2*y^6 + 6*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 2*x^4 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 2*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 2*x^4 + 10, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 2*y^6 + 2*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 12*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^6 + 12*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 8*x^4 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 8*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 4*x^7 + 14*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 14*y^6 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 14*y^6 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 8*x^2 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 12*y^4 + 8*y^2 + 686*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 56*x^2 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 42*y^6 + 588*y^4 + 2744*y^2 + 686*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 4*x^7 + 6*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^6 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 2*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 2*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 10*y^6 + 2*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 6*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 6*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 6*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 10*y^6 + 6*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 10*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 10*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 6*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 6*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 2*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 2*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 2*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 2*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 14*x^4 + 14, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 14*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 56*x^2 + 24, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 42*y^6 + 588*y^4 + 2744*y^2 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 4*x^7 + 2*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^6 + 14*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 8*x^5 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 8*y^5 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^6 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 8*x^2 + 24, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^6 + 12*y^4 + 8*y^2 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 4*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 14*y^6 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 4*x^7 + 6*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^6 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^6 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^3 + 6*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 10*], 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 6*x^4 + 6, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 2*y^6 + 6*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 2*x^4 + 6, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 2*y^6 + 2*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 4*x^4 + 24*x^2 + 24, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 18*y^6 + 94*y^4 + 108*y^2 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 2*x^6 + 14*x^4 + 6, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 2*y^6 + 14*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 2*x^4 + 6, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 2*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 10*x^6 + 14*x^4 + 6, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 10*y^6 + 14*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 6*x^6 + 2*x^4 + 6, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 6*y^6 + 2*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 21, 8, 1, 8, x^8 + 14*x^6 + 14*x^4 + 6, [*192, "t", [*8, 38*]*], 192, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 3*], [*t + 1, y^8 + 14*y^6 + 14*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 2*x^3 + 2*x^2 + 2*]*]*], 0, -1, 111/32, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 6*x^4 + 16*x^3 + 8*x^2 + 12, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y^3 + (8*t + 4)*y^2 + (8*t + 8)*y + (2*t + 2)*], [*x^4 + 12*x^2 + 6*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4, x^4 + 4*x^2 + 14, x^4 + 12*x^2 + 6*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 10*x^4 + 16*x + 4, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y + (6*t + 10)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 12*x^2 + 18, x^4 + 12*x^2 + 2*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 8*x^6 + 6*x^4 + 16*x^2 + 16*x + 4, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 16*y^3 + (16*t + 28)*y^2 + (24*t + 8)*y + (26*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 8*x^7 + 8*x^5 + 6*x^4 + 24*x^2 + 12, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 8)*y^3 + (8*t + 12)*y^2 + (8*t + 8)*y + (2*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 10*x^4 + 16*x + 36, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (16*t + 24)*y + (22*t + 10)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 8*x + 6, x^4 + 4*x^2 + 10*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 16*x^3 + 24*x^2 + 36, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (16*t + 8)*y^3 + (20*t + 24)*y^2 + (10*t + 22)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 12*x^2 + 10, x^4 + 8*x^2 + 8*x + 22*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 16*x + 4, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (16*t + 24)*y + (30*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 4*x^2 + 18, x^4 + 8*x + 14*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 12*x^6 + 10*x^4 + 8*x^2 + 36, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 12*t*y^2 + (6*t + 26)*], [*x^4 + 4*x^2 + 6*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4, x^4 + 8*x + 10, x^4 + 4*x^2 + 6*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (30*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 30, x^4 + 14*]*]*], 0, [*x^2 + 2, x^2 + 2, x^4 + 6*x^2 + 4*x + 14*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 12*x^4 + 68, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 6*x^2 + 4*x + 6*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 2*x^4 + 8*x^2 + 36, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 8)*y^2 + (14*t + 2)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^4 + 6*x^2 + 1, x^4 + 2*x^2 + 4*x + 10*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 10*x^4 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^4 + 6*x^2 + 1, x^4 - 2*x^2 + 4*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 52*x^4 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^4 + 6*x^2 + 1, x^4 + 6*x^2 + 4*x + 6*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 10*x^4 + 36, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (22*t + 10)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4, x^4 + 6, x^4 + 22*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 6, x^2 + 10, x^2 + 10*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 36, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], [*x^8 + 14*x^4 + 36, x^8 + 12*x^6 + 8*x^4 + 12*x^2 + 9*], [*x^4 - 2*x^2 + 4, x^4 + 2*x^2 + 4*x + 10*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 14*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (32*t + 18)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4, x^4 + 2, x^4 + 18*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 6, x^2 + 14, x^2 + 14*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 16*x^3 + 16*x + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (16*t + 24)*y^3 + (16*t + 24)*y + (30*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 2*x^2 + 4*x + 10*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 14*x^4 + 36, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 14)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], [*x^8 + 2*x^4 + 36, x^8 + 12*x^6 + 8*x^4 + 12*x^2 + 9*], [*x^4 + 2*x^2 + 4*x + 10, x^4 - 6*x^2 + 4*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 6*x^4 + 36, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (26*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4, x^4 + 26, x^4 + 10*]*]*], 0, [*x^2 + 6, x^2 + 6, x^4 + 6*x^2 + 4*x + 14*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 6*x^4 + 4, [*16, "t", [*8, 11*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (10*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^4 - 6*x^2 + 4, x^4 + 6*x^2 + 1*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 16*x + 52, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^2 + 8*y + (10*t + 14)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^4 + 2*x^2 + 3, x^4 - 6*x^2 + 3*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^6 + 6*x^4 + 24*x^2 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^2 + (10*t + 6)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 + 2*x^2 - 9, x^4 + 2*x^2 - 1*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 14*x^4 + 8*x^2 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (24*t + 20)*y^2 + (2*t + 30)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 + 2*x^2 - 9, x^4 + 2*x^2 - 1*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 2*x^4 + 60, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 8)*y + (6*t + 14)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 + 6*x^2 - 9, x^4 + 6*x^2 - 1*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^7 + 12*x^6 + 2*x^4 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (24*t + 24)*y^3 + (4*t + 4)*y^2 + (14*t + 18)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^4 - 2*x^2 + 3, x^4 + 6*x^2 + 3*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 16*x^7 + 4*x^6 + 36*x^4 + 56*x^2 + 20, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 24*y^3 + (4*t + 16)*y^2 + (16*t + 24)*y + (24*t + 14)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 + 6*x^2 - 9, x^4 + 6*x^2 - 1*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 2*x^4 + 36, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^2 + (14*t + 2)*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^4 + 2*x^2 + 3, x^4 - 6*x^2 + 3*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 8*x^2 + 4, [*64, "t", [*8, 29*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^2 + (14*t + 18)*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^4 - 2*x^2 + 3, x^4 + 6*x^2 + 3*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 24*x^5 + 8*x^2 + 48*x + 12, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 16*y^3 + (4*t + 16)*y^2 + 24*t*y + (28*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 16*x^3 + 16*x + 52, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y^3 + 8*y + (14*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 12*x^6 + 6*x^4 + 8*x^2 + 52, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 8)*y^2 + (10*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 8*x^7 + 2*x^4 + 16*x^3 + 16*x + 20, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 16)*y^3 + (16*t + 24)*y + (14*t + 26)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, -1, 11/4, 8*], [*2, 22, 4, 2, 8, x^8 + 16*x^6 + 20*x^4 + 116, [*16, "t", [*8, 7*]*], 16, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 4*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^2 + (8*t + 14)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 8*x^4 + 16*], 11/4, 4*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 10*x^4 + 8*x^2 + 20, [*16, "t", [*8, 7*]*], 16, [*4, "i", [*4, 1*], "<i>C</i><sub>4</sub>"*], [*3, 4*], [*1, 4*], [*t^2 - t + 1, y^4 + (4*t + 8)*y^2 + (6*t + 2)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 8*x^4 + 16*], 11/4, 4*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 8*x^2 + 52, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*t*y^2 + (2*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 20*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 6*x^4 + 16*x + 52, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y + (10*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 28*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 12*x^6 + 2*x^4 + 8*x^2 + 52, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 12*t*y^2 + (14*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 28*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 16*x + 52, [*16, "t", [*8, 7*]*], 16, [*8, "i", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y + (14*t + 10)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*x^2 + 8*x + 20*], 3, 4*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 20, [*32, "t", [*8, 16*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (14*t + 26)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 6*x^4 + 20, [*32, "t", [*8, 16*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (10*t + 30)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^2 + 12*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 6*x^4 + 52, [*32, "t", [*8, 16*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^2 + 12*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 52, [*32, "t", [*8, 16*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 2)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 8*x^2 + 52, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^2 + (14*t + 10)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 2*x^4 + 12, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (24*t + 8)*y + (22*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 28)*y^2 + (26*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 2*x^4 + 44, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 8)*y + (6*t + 6)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 6*x^4 + 60, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 8)*y + (2*t + 10)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 12*x^6 + 2*x^4 + 20, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 20)*y^2 + (30*t + 10)*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 52, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 12)*y^2 + (10*t + 14)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 4*x^7 + 12*x^6 + 2*x^4 + 24*x^2 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 32*x^5 + 52*x^4 + 24*x^2 + 52, [*64, "t", [*8, 28*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (16*t + 24)*y^3 + (20*t + 24)*y^2 + 16*y + (24*t + 6)*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 20*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 14*x^4 + 60, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (10*t + 2)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 6*x^2 + 4*x + 2*], 3, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 60, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 14)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 6*x^2 + 4*x + 2*], 3, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 28, [*16, "t", [*8, 8*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (6*t + 30)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 6*x^6 + 6*x^4 + 8*x^3 + 4*x^2 + 8*x + 20*], 3, 2*], [*2, 22, 4, 2, 8, x^8 + 10*x^4 + 28, [*16, "t", [*8, 8*]*], 16, [*8, "i", [*4, 3*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (30*t + 6)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 6*x^6 + 6*x^4 + 8*x^3 + 4*x^2 + 8*x + 20*], 3, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 2*x^4 + 8*x^2 + 4, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^2 + (8*t + 8)*y + (14*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 16*x^5 + 12, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y + (12*t + 2)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 32*x + 44, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y + (12*t + 10)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^6 + 8*x^5 + 2*x^4 + 16*x^3 + 8*x^2 + 4, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 8*y^3 + 4*y^2 + (8*t + 8)*y + (14*t + 2)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 8*x^6 + 16*x^5 + 80*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 2*x^4 + 28, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (28*t + 20)*y^2 + (22*t + 14)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 6*x^4 + 20, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (24*t + 24)*y + (10*t + 30)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 2*x^4 + 8*x^2 + 20, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (24*t + 8)*y^3 + 12*t*y^2 + (24*t + 24)*y + (30*t + 10)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 10*x^4 + 4, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 8)*y + (6*t + 10)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 12*x^2 + 10*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 8*x^2 + 60, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^2 + (6*t + 14)*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 28, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (28*t + 20)*y^2 + (2*t + 26)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 12*x^2 + 10*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 60, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^2 + (2*t + 10)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1, x^2 + 14, x^2 + 6*]*], [*4, [*x^4 - 6*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 12*x^6 + 2*x^4 + 28, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (20*t + 28)*y^2 + (22*t + 14)*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 12, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (28*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 168*x^4 + 912*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 12, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (22*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 6*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 6*x^4 + 44, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (2*t + 18)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 6*x^6 + 4*x^3 + 6*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 192, [*32, "t", [*8, 15*]*], 32, [*16, "i", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 10)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 - 20*]*]*], 0, [*x^8 + 168*x^4 + 912*], 25/8, 2*], [*2, 22, 4, 2, 8, x^8 + 24*x^6 + 44, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 4*], [*t^2 - t + 1, y^4 + 12*y^2 + (12*t + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^5 + 2*x^4 + 6*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 16*x^2 + 44, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 4*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^2 + (12*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^5 + 2*x^4 + 6*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^6 + 44, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 4*], [*t^2 - t + 1, y^4 + 4*y^2 + (12*t + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^5 + 2*x^4 + 6*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 16*x^2 + 12, [*64, "t", [*8, 30*]*], 128, [*16, "i", [**], "<i>C</i><sub>4</sub><sup>2</sup>"*], [*2, 3, 3, 4*], [*1, 4*], [*t^2 - t + 1, y^4 + (8*t + 12)*y^2 + (12*t + 10)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 - 4*]*]*], 0, [*x^8 + 4*x^5 + 2*x^4 + 6*], 13/4, 2*], [*2, 22, 4, 2, 8, x^8 + 12*x^6 + 8*x^2 + 44, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 12)*y^2 + (12*t + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 8*x^5 + 10*x^4 + 20, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (24*t + 24)*y + (6*t + 18)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 8*x^3 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 6*x^4 + 8*x^2 + 44, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (24*t + 20)*y^2 + (18*t + 2)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 4*x^6 + 6*x^4 + 12, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (12*t + 4)*y^2 + (2*t + 2)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 8*x^3 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 8*x^2 + 44, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + 4*y^2 + (6*t + 6)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 8*x^3 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 2*x^4 + 24*x^2 + 44, [*64, "t", [*8, 27*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^2 + (6*t + 6)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1*]*], [*4, [*x^4 + 2*x^2 + 20*]*]*], 0, [*x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 8*x^3 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 12*x^6 + 10*x^4 + 12, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (4*t + 4)*y^2 + (6*t + 6)*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 4, 2, 8, x^8 + 14*x^4 + 8*x^2 + 44, [*64, "t", [*8, 31*]*], 64, [*32, "i", [*8, 18*], "T18"*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t^2 - t + 1, y^4 + (8*t + 4)*y^2 + (10*t + 10)*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 - x + 1, x^2 + 2, x^2 + 10*]*], [*4, [*x^4 - 2*x^2 + 4*]*]*], 0, [*x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 6*], 55/16, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 14, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 4*y^2 + 14*], [*x^4 + 2*x^2 + 6*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 2*x^2 + 6, x^4 + 6*x^2 + 3*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 14, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 10*y^4 + 4*y^2 + 14*], [*x^4 + 2*x^2 + 6*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 - 2*x^2 + 6, x^4 - 6*x^2 + 3*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 6, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 10*y^4 + 4*y^2 + 6*], [*x^4 - 2*x^2 + 3*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 - 2*x^2 - 2, x^4 + 2*x^2 + 3*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 10, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 14*y^4 + 12*y^2 + 10*], [*x^4 + 6*x^2 + 10*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 10, x^4 + 2*x^2 - 9*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 2, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 6*y^4 + 12*y^2 + 2*], [*x^4 + 6*x^2 + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 - 2*x^2 + 2, x^4 + 2*x^2 - 1*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 152*x^4 + 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 756*y^6 + 76432*y^5 + 2054178*y^4 - 9793880*y^3 + 16455612*y^2 - 11794856*y + 3080954*], [*x^4 + 6*x^2 + 10*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 2*x^2 + 10, x^4 + 6*x^2 - 1*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 6, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 4*y^2 + 6*], [*x^4 - 2*x^2 + 3*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 2*x^2 - 2, x^4 - 2*x^2 + 3*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 2, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 1*], [*t + 1, y^8 + 4*y^7 + 14*y^4 + 12*y^2 + 2*], [*x^4 + 6*x^2 + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 6*x^2 + 2, x^4 + 6*x^2 - 9*]*]*], 0, -1, 11/4, 8*], [*2, 22, 8, 1, 8, x^8 + 56*x^4 + 144, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 4*y^7 + 64*y^6 + 1080*y^5 + 27258*y^4 - 57336*y^3 + 44540*y^2 - 24200*y + 10406*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], [*x^8 + 16*x^4 + 4, x^8 + 72*x^4 + 656*], [*x^4 + 8*x^2 + 4, x^4 - 6*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 8*x + 10, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^4 + 12*y^2 + 8*y + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], [*x^8 + 2*x^6 + 14*x^4 + 20*x^2 + 4, x^8 + 4*x^7 + 8*x^6 + 10*x^4 + 4*], [*x^4 - 2*x^2 + 4, x^4 + 8*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 56*x^4 + 400, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 28*y^7 + 296*y^6 + 1496*y^5 + 4318*y^4 + 11904*y^3 + 31428*y^2 + 33624*y + 50634*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 3, x^4 - 6*x^2 + 3*]*]*], 0, [*x^2 + 2*x - 2, x^2 + 2*x - 2, x^4 - 2*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 8*x^3 + 12*x^2 + 14, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 6*y^4 + 8*y^3 + 12*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], [*x^8 + 36, x^8 + 72*x^4 + 144*], [*x^4 - 6*x^2 + 4, x^4 + 8*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 184*x^4 + 400, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 28*y^7 + 124*y^6 + 10568*y^5 + 231186*y^4 - 180640*y^3 + 1189508*y^2 + 188080*y + 9650*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 2*x^2 + 3, x^4 - 2*x^2 + 3*]*]*], 0, [*x^2 + 2*x - 2, x^2 + 2*x - 2, x^4 - 2*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 24*x^4 + 272, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 4*y^7 + 16*y^6 - 112*y^5 + 322*y^4 - 856*y^3 + 4852*y^2 - 12352*y + 61974*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 2*x^2 + 6, x^4 - 2*x^2 + 6*]*]*], 0, [*x^4 + 8*x^2 + 4, x^2 + 10, x^2 + 10*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 10, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^4 + 4*y^2 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 - 2*x^2 + 2, x^4 + 6*x^2 + 2*]*]*], 0, [*x^2 + 14, x^2 + 14, x^4 + 8*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 24*x^4 + 784, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 - 12*y^7 + 60*y^6 - 128*y^5 - 58*y^4 + 928*y^3 - 1468*y^2 - 1288*y + 4174*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 2*x^2 - 2, x^4 - 2*x^2 - 2*]*]*], 0, [*x^4 + 8*x^2 + 4, x^2 + 2, x^2 + 2*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 12*x^2 + 14, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 6*y^4 + 12*y^2 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 6*x^2 - 9, x^4 + 2*x^2 - 1*]*]*], 0, [*x^4 - 6*x^2 + 4, x^2 + 2*x + 2, x^2 + 2*x + 2*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 2, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 2*y^4 + 12*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], [*x^8 + 14*x^6 + 10*x^4 + 8*x^3 + 12*x^2 + 20, x^8 + 4*x^7 + 8*x^6 + 2*x^4 + 4*], [*x^4 - 2*x^2 + 4, x^4 + 8*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 8*x^3 + 4*x^2 + 6, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 6*y^4 + 8*y^3 + 4*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 6*x^2 - 1, x^4 + 2*x^2 - 9*]*]*], 0, [*x^4 - 6*x^2 + 4, x^2 + 2*x + 2, x^2 + 2*x + 2*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 144, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 58660*y^7 - 407784*y^6 + 2053392*y^5 - 4417338*y^4 - 3631744*y^3 + 34213604*y^2 - 214864768*y + 467060674*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 6*x^2 + 10, x^4 + 2*x^2 + 10*]*]*], 0, [*x^2 + 6, x^2 + 6, x^4 + 8*x^2 + 4*], 11/4, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 12*x^2 + 6, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 2*y^4 + 12*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^4 + 2*x^2 + 20, x^4 + 2*x^3 + 2*], 23/8, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 8*x^3 + 12*x^2 + 6, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 2*y^4 + 8*y^3 + 12*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^4 + 2*x^2 + 20, x^4 + 2*x^3 + 2*], 23/8, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 12*x^2 + 2, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 6*y^4 + 12*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^4 - 2*x^2 + 20, x^4 + 2*x^3 + 6*], 23/8, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 2, [*32, "t", [*8, 19*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 8*y^3 + 12*y^2 + 8*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^4 - 2*x^2 + 20, x^4 + 2*x^3 + 6*], 23/8, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 2, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2, x^4 - 2*x^2 + 2, x^4 + 2*x^2 + 10*]*]*], 0, [*x^2 + 14, x^2 + 6, x^4 + 2*x^3 + 2*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 6, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 14*y^4 + 12*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6, x^4 + 2*x^2 - 2, x^4 + 2*x^2 + 6*]*]*], 0, [*x^2 + 2, x^2 + 10, x^4 + 2*x^3 + 6*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 6, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^4 + 12*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6, x^4 - 2*x^2 - 2, x^4 - 2*x^2 + 6*]*]*], 0, [*x^2 + 2, x^2 + 10, x^4 + 2*x^3 + 6*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 12*x^2 + 10, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 12*y^2 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 6*x^2 + 2, x^4 + 2*x^2 + 10*]*]*], 0, [*x^2 + 14, x^2 + 6, x^4 + 2*x^3 + 2*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 10*y^4 + 12*y^2 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2, x^4 - 2*x^2 + 2, x^4 + 6*x^2 + 10*]*]*], 0, [*x^2 + 14, x^2 + 6, x^4 + 2*x^3 + 2*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 8*x^7 + 48*x^5 + 80, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 6012*y^7 - 112800*y^6 + 1121752*y^5 - 3479210*y^4 + 4996384*y^3 - 3738092*y^2 + 1445680*y - 203002*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6, x^4 - 2*x^2 - 2, x^4 + 2*x^2 + 6*]*]*], 0, [*x^2 + 10, x^2 + 2, x^4 + 2*x^3 + 6*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 2, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 10*y^4 + 4*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2, x^4 + 6*x^2 + 2, x^4 + 6*x^2 + 10*]*]*], 0, [*x^2 + 14, x^2 + 6, x^4 + 2*x^3 + 2*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 14, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 2, 3, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^4 + 4*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6, x^4 + 2*x^2 - 2, x^4 - 2*x^2 + 6*]*]*], 0, [*x^2 + 2, x^2 + 10, x^4 + 2*x^3 + 6*], 23/8, 4*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 10, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 14, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 14, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 10, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*4/3, 4/3, 3, 19/6, 19/6*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 139/48, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 2*y^4 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 8*x^2 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 8*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6*x^4 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^4 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 6*x^4 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 6*y^4 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 2*x^4 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 2*y^4 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 8*x^2 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 8*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 2*x^4 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*2, 8/3, 8/3, 10/3, 10/3*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 2*y^4 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [**]*]*], 0, -1, 37/12, 1*], [*2, 22, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 56, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 12*y^7 + 480*y^6 + 64*y^5 + 1512*y^4 + 1764*y^2 + 686*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 12*x^2 + 14, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 12*y^2 + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^2 + 10, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^2 + 10*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^2 + 2, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^2 + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^2 + 6, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^2 + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^2 + 14, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^2 + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 12*x^2 + 2, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 12*y^2 + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 12*x^2 + 10, [*48, "t", [*8, 23*], "<i>GL</i><sub>2</sub>(3)"*], 48, [*24, "t", [*8, 12*], "<i>SL</i><sub>2</sub>(3)"*], [*8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 12*y^2 + 10*], 0, [*1, 1*], 1, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 17/6, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^4 + 4*x^2 + 14, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^4 + 4*y^2 + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^4 + 12*x^2 + 2, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^4 + 12*y^2 + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^4 + 4*x^2 + 6, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^4 + 4*y^2 + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^6 + 4*x^4 + 4*x^2 + 2, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^6 + 4*y^4 + 4*y^2 + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^4 + 4*x^2 + 2, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^4 + 4*y^2 + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^4 + 12*x^2 + 10, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^4 + 12*y^2 + 10*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^4 + 16*x^2 + 116, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 12*y^7 + 212*y^6 + 1384*y^5 + 4868*y^4 + 139840*y^3 + 2738564*y^2 + 22294040*y + 63971506*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 22, 8, 1, 8, x^8 + 4*x^7 + 4*x^4 + 12*x^2 + 14, [*192, "t", [*8, 40*]*], 192, [*96, "t", [*8, 32*]*], [*4/3, 4/3, 8/3, 8/3, 7/2*], [*3, 2*], [*t + 1, y^8 + 4*y^7 + 4*y^4 + 12*y^2 + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 139/48, 2*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 4*x^2 + 8*x + 22, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 4*y^2 + 8*y + 22*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 4*x^2 + 10, x^4 + 8*x^2 + 8*x + 22*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 4*x^2 + 8*x + 6, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 4*y^2 + 8*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 8*x + 6, x^4 + 12*x^2 + 10*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 18, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 12*y^2 + 8*y + 18*], [*x^4 + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 14, x^4 + 18*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 12*x^2 + 8*x + 14, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], 8, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 12*y^2 + 8*y + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 - 15, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 70*y^4 - 56*y^3 + 28*y^2 - 8*y - 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 12*x^2 + 18, x^4 + 4*x^2 + 18*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 44*x^4 + 100, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 24*y^6 - 32*y^5 + 10*y^4 + 24*y^3 - 132*y^2 + 216*y + 522*], [*x^4 + 10*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6, x^4 + 10*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 10*x^4 + 8*x^3 + 4*x^2 + 8*x + 14, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 10*y^4 + 8*y^3 + 4*y^2 + 8*y + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 12*x^2 + 18, x^4 + 8*x + 14*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 14*x^4 + 8*x^3 + 12*x^2 + 8*x + 22, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], 8, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 14*y^4 + 8*y^3 + 12*y^2 + 8*y + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 14*x^4 + 4*x^2 + 8*x + 30, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 14*y^4 + 4*y^2 + 8*y + 30*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 4*x^2 + 18, x^4 + 12*x^2 + 2*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 24*y^5 + 50*y^4 + 64*y^3 + 428*y^2 + 776*y + 578*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 8*x + 14, x^4 + 12*x^2 + 2*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 2*x^4 + 12*x^2 + 8*x + 26, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 2*y^4 + 12*y^2 + 8*y + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 8*x + 6, x^4 + 8*x^2 + 8*x + 22*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 12*x^2 + 8*x + 30, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], 8, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 12*y^2 + 8*y + 30*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 28*x^4 + 36, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], 8, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 36*y^6 - 192*y^5 + 2574*y^4 - 456*y^3 + 5716*y^2 - 3000*y + 2250*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 12*x^2 + 10, x^4 + 4*x^2 + 10*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 12*x^6 + 6*x^4 + 4*x^2 + 8*x + 2, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 6*y^4 + 4*y^2 + 8*y + 2*], [*x^4 + 2*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 30, x^4 + 2*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 52*x^4 + 36, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], 8, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 - 24*y^6 + 120*y^5 + 1002*y^4 + 360*y^3 + 4564*y^2 + 3480*y + 666*], [*x^4 + 10*], [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 22, x^4 + 26*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 4*x^2 + 8*x + 6, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], 8, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 4*y^2 + 8*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], 0, -1, 3, 8*], [*2, 24, 8, 1, 8, x^8 + 16*x^4 + 16, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 74*y^4 - 72*y^3 + 52*y^2 - 24*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 12*x^2 + 6, x^4 + 4*x^2 + 6*]*]*], 0, [*x^4 + 6*x^2 + 1, x^2 + 10, x^2 + 10*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 4*x^2 + 8*x + 10, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 4*y^2 + 8*y + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], 0, [*x^4 + 6*x^2 + 1, x^4 + 6*x^2 + 4*x + 14*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^6 + 16, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 16908*y^6 - 101336*y^5 + 259702*y^4 - 363384*y^3 + 292356*y^2 - 128088*y + 24138*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], 0, [*x^4 + 6*x^2 + 1, x^4 - 2*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 10*x^4 + 8*x^3 + 4*x^2 + 8*x + 2, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y^3 + 4*y^2 + 8*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 4*x + 6*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 20*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 204*y^6 - 48*y^5 + 9302*y^4 + 24*y^3 + 14508*y^2 + 4344*y + 18730*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 8*x + 10, x^4 + 4*x^2 + 14*]*]*], 0, [*x^2 + 2, x^2 + 2, x^4 + 6*x^2 + 4*x + 14*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 36, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 120*y^6 + 808*y^5 + 5634*y^4 - 1536*y^3 + 43268*y^2 - 17640*y + 78642*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1, x^4 + 12*x^2 + 6, x^4 + 4*x^2 + 6*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 6, x^2 + 10, x^2 + 10*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 44*x^4 + 68, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 - 548*y^6 + 3400*y^5 + 2072378*y^4 - 8312328*y^3 + 17978140*y^2 - 19322472*y + 26359654*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], 0, [*x^4 + 6*x^2 + 1, x^4 - 6*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 4*x^2 + 8*x + 2, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 4*y^2 + 8*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 4*x + 14*], 3, 4*], [*2, 24, 8, 1, 8, x^8 - 7, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 70*y^4 - 56*y^3 + 28*y^2 - 8*y - 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], 0, [*x^4 - 6*x^2 + 4, x^4 + 6*x^2 + 4*x + 14*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 10*x^4 + 4*x^2 + 8*x + 14, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^5 + 10*y^4 + 4*y^2 + 8*y + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 26, x^4 + 10*]*]*], 0, [*x^4 - 2*x^2 + 4, x^2 + 6, x^2 + 6*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 28*x^4 + 4, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 24*y^6 - 32*y^5 + 14*y^4 + 8*y^3 + 4*y^2 - 24*y + 22*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 2, x^4 + 18*]*]*], 0, [*x^4 - 2*x^2 + 4, x^2 + 14, x^2 + 14*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 12*x^6 + 8*x^4 + 12*x^2 + 9, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 258*y^4 - 328*y^3 + 268*y^2 - 136*y + 42*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], [*x^8 + 14*x^4 + 36, x^8 + 2*x^4 + 36*], [*x^4 - 2*x^2 + 4, x^4 - 6*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 52*x^4 + 196, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 100*y^6 - 488*y^5 + 23354*y^4 - 90312*y^3 + 326020*y^2 - 472632*y + 2233206*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 14, x^4 - 2*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^7 + 16, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 131072*y^7 - 917212*y^6 + 2747632*y^5 - 4538898*y^4 + 4435976*y^3 - 2545348*y^2 + 786728*y - 98926*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 10, x^4 - 2*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 60*x^4 + 100, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 - 292*y^6 + 1864*y^5 + 349650*y^4 - 1411176*y^3 + 3037708*y^2 - 3248008*y + 22753486*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 10, x^4 - 6*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 20*x^4 + 164, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 40*y^6 - 8*y^5 + 330*y^4 + 840*y^3 - 284*y^2 + 6680*y + 13250*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], 0, [*x^4 - 6*x^2 + 4, x^4 - 2*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^4 + 144, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 74*y^4 - 72*y^3 + 52*y^2 - 24*y + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 6, x^4 - 2*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 32*x^4 + 144, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 78*y^4 - 88*y^3 + 76*y^2 - 40*y + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], 0, [*x^4 - 6*x^2 + 4, x^4 + 6*x^2 + 4*x + 6*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 10*x^4 + 4*x^2 + 8*x + 6, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 10*y^4 + 4*y^2 + 8*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], 0, [*x^4 + 6*x^2 + 1, x^4 + 2*x^2 + 4*x + 10*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 6*x^4 + 12*x^2 + 8*x + 10, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 6*y^4 + 12*y^2 + 8*y + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], 0, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 6*x^2 + 1*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 116*x^4 + 100, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 352*y^6 - 2000*y^5 + 175854*y^4 - 690232*y^3 + 1860292*y^2 - 2345368*y + 2031334*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6, x^4 + 6, x^4 + 22*]*]*], 0, [*x^4 - 6*x^2 + 4, x^2 + 10, x^2 + 10*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 4*x^2 + 8*x + 14, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 4*y^2 + 8*y + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 30, x^4 + 14*]*]*], 0, [*x^2 + 2, x^2 + 2, x^4 - 6*x^2 + 4*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 48*x^4 + 16, [*16, "t", [*8, 9*], "<i>D</i><sub>4</sub><i>C</i><sub>2</sub>"*], 16, [*8, "t", [*8, 2*], "<i>C</i><sub>4</sub><i>C</i><sub>2</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 18898*y^4 - 75368*y^3 + 112996*y^2 - 75320*y + 47390*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14, x^4 + 8*x + 10, x^4 + 4*x^2 + 14*]*]*], 0, [*x^2 + 2, x^2 + 2, x^4 + 2*x^2 + 4*x + 10*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 8*x^5 + 14*x^4 + 8*x^3 + 4*x^2 + 8*x + 14, [*16, "t", [*8, 11*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 14*y^4 + 8*y^3 + 4*y^2 + 8*y + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 10, x^4 + 6*x^2 + 1*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 8*x^2 + 8*x + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 8*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 2*x^2 - 1*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^4 + 8*x + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 8*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 6*x^2 - 1*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^3 + 8*x + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^3 + 8*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 6*x^2 - 9*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^3 + 8*x^2 + 8*x + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^3 + 8*y^2 + 8*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 6*x^2 - 9*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 8*x + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 8*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 + 6*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^6 + 16*x^3 + 8, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 128*y^6 + 384*y^5 + 480*y^4 + 320*y^3 + 120*y^2 + 24*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 - 6*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^2 + 8*x + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 8*y + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 2*x^2 - 9*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^2 + 8*x + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 8*y + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 - 2*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 - 6*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^3 + 8*x^2 + 8*x + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^3 + 8*y^2 + 8*y + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 + 2*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^3 + 8*x^2 + 8*x + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^3 + 8*y^2 + 8*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 + 6*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 8*x^2 + 8*x + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 8*y^2 + 8*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 6*x^2 - 1*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 2*x^2 - 9*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^4 + 2*x^2 + 4*x + 4, x^4 + 2*x^2 - 1*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 - 2*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^4 + 8*x + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 8*y + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^4 - 5, x^4 + 2*x^2 + 3*], 51/16, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 8*x + 14, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 8*y + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x^2 + 8*x + 2, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 8*y^2 + 8*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x + 6, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 8*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x + 2, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 8*y + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 8*x + 6, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 8*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 8*x + 6, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 8*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x + 14, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 8*y + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x + 10, [*96, "t", [*8, 33*]*], 96, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 7/2*], [*1, 3*], [*t + 1, y^8 + 4*y^6 + 8*y + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 51/16, 1*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 4*x^2 + 8*x + 2, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 4*y^2 + 8*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 - 316*x^6 + 2590132*x^4 - 3325908*x^2 + 1589725, [*x^4 + 2*x^2 - 4, x^4 + 2*x^2 - 4*], 3, 2*], [*2, 24, 8, 1, 8, x^8 + 20*x^4 + 52, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 - 56*y^6 + 448*y^5 + 762*y^4 - 6184*y^3 + 3772*y^2 + 6104*y + 2038*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 + 212*x^6 + 70656*x^4 - 503612*x^2 + 1155725, [*x^8 + 4*x^6 + 40*x^2 + 4*], 3, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 12*x^2 + 8*x + 2, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 2*y^4 + 12*y^2 + 8*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^4 + 2*x^2 - 4, x^4 + 2*x^2 - 4*], 3, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 84, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 136*y^6 - 704*y^5 + 1810*y^4 - 2696*y^3 + 56044*y^2 - 108488*y + 18099814*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 4*x^6 + 40*x^2 + 4*], 3, 2*], [*2, 24, 8, 1, 8, x^8 + 20*x^6 + 24*x^4 + 28*x^2 + 29, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 - 8*y^7 + 48*y^6 - 176*y^5 + 394*y^4 - 552*y^3 + 500*y^2 - 280*y + 102*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 + 19476*x^6 + 520371288*x^4 + 27530050716*x^2 + 1219318768125, [*x^8 + 2*x^6 + 16*x^2 + 16*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 60*x^4 + 148, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 - 8*y^7 - 2360*y^6 + 14272*y^5 + 1769974*y^4 - 7175192*y^3 + 8578996*y^2 - 2769464*y + 156139994*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 + 748884*x^6 + 207339454332*x^4 + 836726230692*x^2 + 1162128718125, [*x^8 + 6*x^6 + 6*x^4 + 12*x^2 + 8*x + 12*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 6*x^4 + 12*x^2 + 8*x + 22, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 6*y^4 + 12*y^2 + 8*y + 22*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 2*x^6 + 16*x^2 + 16*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 52*x^4 + 180, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 - 8*y^7 - 1496*y^6 + 9088*y^5 + 867542*y^4 - 3530904*y^3 + 10624660*y^2 - 14163192*y + 246942914*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 - 249628*x^6 + 23037717148*x^4 - 30989860396*x^2 + 14347268125, [*x^8 + 6*x^6 + 6*x^4 + 12*x^2 + 8*x + 12*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 2*x^4 + 8*x^3 + 4*x^2 + 8*x + 6, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 + 8*y^7 + 2*y^4 + 8*y^3 + 4*y^2 + 8*y + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 - 148*x^6 + 5856*x^4 - 22396*x^2 + 65125, [*x^8 + 2*x^6 + 16*x^2 + 16*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 4*x^2 + 8*x + 6, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 4*], "<i>D</i><sub>4</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 4*y^2 + 8*y + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 - 6492*x^6 + 57819032*x^4 - 1019631508*x^2 + 15053318125, [*x^8 + 2*x^6 + 16*x^2 + 16*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 20, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 + 16*y^6 + 8*y^5 + 54*y^4 + 24*y^3 + 76*y^2 + 40*y + 50*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 - 564*x^6 + 624852*x^4 + 2583468*x^2 + 3655125, [*x^8 + 6*x^6 + 6*x^4 + 12*x^2 + 8*x + 12*], 3, 4*], [*2, 24, 8, 1, 8, x^8 + 12*x^4 + 52, [*32, "t", [*8, 17*]*], 32, [*8, "t", [*8, 5*], "<i>Q</i><sub>8</sub>"*], [*2, 3, 4*], [*1, 4*], [*t + 1, y^8 + 24*y^6 - 8*y^5 + 142*y^4 + 120*y^3 + 172*y^2 + 584*y + 370*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 + 188*x^6 + 69428*x^4 - 95684*x^2 + 45125, [*x^8 + 6*x^6 + 6*x^4 + 12*x^2 + 8*x + 12*], 3, 4*], [*2, 24, 8, 1, 8, x^8 - 3, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 70*y^4 - 56*y^3 + 28*y^2 - 8*y - 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 + 24*x^6 + 320*x^4 + 728*x^2 + 1525, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^3 + 4*], 25/8, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 14*x^4 + 4*x^2 + 8*x + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 14*y^4 + 4*y^2 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 + 46256*x^6 + 571990332*x^4 - 827468952*x^2 + 484866125, [*x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 4*], 25/8, 2*], [*2, 24, 8, 1, 8, x^8 + 16*x^7 + 16*x^4 + 80, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 130928*y^7 - 909036*y^6 + 2515232*y^5 - 1790566*y^4 - 4391672*y^3 + 9655956*y^2 - 7531480*y + 13518082*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 - 56*x^6 + 1812*x^4 - 2608*x^2 + 1525, [*x^8 + 6*x^6 + 4*x^5 + 2*x^4 + 4*], 25/8, 2*], [*2, 24, 8, 1, 8, x^8 + 80, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 190*y^4 - 536*y^3 + 748*y^2 - 488*y + 12126*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 - 1744*x^6 + 2931128*x^4 - 63817056*x^2 + 352496125, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 8*x^3 + 4*], 25/8, 2*], [*2, 24, 8, 1, 8, x^8 + 48*x^4 + 464, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 2266*y^4 - 8840*y^3 + 13204*y^2 - 8792*y + 2226*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 20*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^4 + 464, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 - 40*y^3 + 28*y^2 + 40*y + 26*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 + 23544*x^6 + 138652812*x^4 + 647295192*x^2 + 1114813125, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 20*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^4 + 336, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 802*y^4 - 2984*y^3 + 4420*y^2 - 2936*y + 138514*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 - 7848*x^6 + 15405868*x^4 - 23973896*x^2 + 13763125, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 20*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^6 + 80, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 16828*y^6 - 100856*y^5 + 285790*y^4 - 470936*y^3 + 470468*y^2 - 267928*y + 69766*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 - 2760*x^6 + 1906056*x^4 - 2385504*x^2 + 1608913125, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 48*x^6 + 80, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 3994876*y^6 - 23969144*y^5 + 62438430*y^4 - 89959576*y^3 + 75402868*y^2 - 34804216*y + 7013814*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 + 920*x^6 + 211784*x^4 + 88352*x^2 + 19863125, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^7 + 464, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 131072*y^7 - 908252*y^6 + 2607856*y^5 - 3173226*y^4 - 8408*y^3 + 6373996*y^2 - 7787320*y + 4262102*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 + 31024*x^6 + 2310426368*x^4 - 189517054104*x^2 + 4591262028125, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 48*x^4 + 336, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 5578*y^4 - 22088*y^3 + 33076*y^2 - 22040*y + 7210*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], x^8 - 11094144*x^6 + 45799486330932*x^4 + 209249938672848*x^2 + 354449259028125, [*x^8 + 2*x^6 + 4*x^5 + 6*x^4 + 20*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 16*x^7 + 80, [*32, "t", [*8, 17*]*], 32, [*16, "t", [*8, 11*]*], [*2, 2, 3, 4*], [*1, 2*], [*t + 1, y^8 + 131072*y^7 - 915932*y^6 + 2727664*y^5 - 4343610*y^4 + 3828904*y^3 - 1707572*y^2 + 264392*y + 20606*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], x^8 - 93072*x^6 + 20793837312*x^4 + 5116960460808*x^2 + 371892224278125, [*x^8 + 4*x^6 + 4*x^5 + 2*x^4 + 12*x^2 + 8*x + 28*], 25/8, 4*], [*2, 24, 8, 1, 8, x^8 + 8*x^6 + 2*x^4 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 2*y^4 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 2*x^4 + 12*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 6*x^4 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 6*x^4 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 6*y^4 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 2*x^4 + 12*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 10*x^4 + 8*x + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y + 10*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 6*x^6 + 10*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 2*x^6 + 20*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y + 10*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 6*x^6 + 10*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^6 + 14*x^4 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 14*y^4 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 2*x^6 + 20*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 6*x^6 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 10*x^4 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 6*x^6 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 2*x^4 + 12*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^6 + 14*x^4 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 14*y^4 + 8*y + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 6*x^6 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 10*x^4 + 8*x^3 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y^3 + 8*y + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^6 + 14*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 2*x^6 + 2*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 8*y + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 20*x^6 + 40*x^2 + 84, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2056*y^7 + 1134736*y^6 + 295928*y^5 + 87297798*y^4 + 31094416*y^3 + 1592101368*y^2 + 2056862136*y + 1368278186*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 6*x^6 + 10*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^6 + 6*x^4 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 6*y^4 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 6*x^6 + 10*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 6*x^4 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 6*x^4 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^6 + 10*x^4 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 10*y^4 + 8*y + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^6 + 14*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 10*x^4 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^6 + 14*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^6 + 14*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 14*x^4 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 2*x^6 + 2*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 8*y + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 6*x^4 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 6*x^4 + 8*x + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y + 10*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 2*x^6 + 20*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 20*x^4 + 16*x^3 + 40, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 - 120*y^5 + 350*y^4 + 128*y^3 + 480*y^2 + 600*y + 250*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 2*x^4 + 12*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 10*x^4 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 10*y^4 + 8*y + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 6*x^6 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 2*x^4 + 8*x + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y + 10*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 2*x^6 + 2*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 8*y + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^4 + 16*x^3 + 8, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 - 72*y^5 + 90*y^4 + 128*y^3 + 96*y^2 + 24*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 2*x^6 + 20*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 6*x^4 + 4*x^2 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 14*x^4 + 8*x^3 + 8*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 14*y^4 + 8*y^3 + 8*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 2*x^6 + 2*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 6*x^4 + 8*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 7/2, 15/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 2*x^6 + 6*x^4 + 4*], 111/32, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^5 + 12*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 12*y^2 + 8*y + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 12*x^2 + 8*x + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^6 + 12*y^2 + 8*y + 30*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^6 + 12*x^2 + 8*x + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 12*y^2 + 8*y + 18*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^2 + 8*x + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 8*y + 18*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 8*x^3 + 4*x^2 + 8*x + 26, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 8*y^3 + 4*y^2 + 8*y + 26*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 12*x^2 + 8*x + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 12*y^4 + 8*y^3 + 12*y^2 + 8*y + 6*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^6 + 4*x^4 + 12*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 12*y^6 + 4*y^4 + 12*y^2 + 8*y + 2*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 4*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^2 + 8*y + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 4*x^2 + 8*x + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 4*y^2 + 8*y + 6*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^2 + 8*x + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 8*y + 10*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 12*y^2 + 8*y + 2*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^2 + 8*x + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 12*y^2 + 8*y + 10*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 8*x + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 8*y + 30*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 4*x^2 + 8*x + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 4*y^2 + 8*y + 22*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 8*x + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 8*y + 22*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 4*x^4 + 12*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 4*y^4 + 12*y^2 + 8*y + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 12*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 12*y^2 + 8*y + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 4*x^4 + 4*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^4 + 4*y^2 + 8*y + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^6 + 16*x^3 + 120, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^6 + 24*y^5 + 152*y^4 + 24*y^3 + 900*y^2 + 5640*y + 6030*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 4*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 4*y^2 + 8*y + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^2 + 8*x + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 8*y + 14*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 12*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 12*y^2 + 8*y + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 8*x^3 + 4*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^3 + 4*y^2 + 8*y + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^2 + 8*x + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 8*y + 30*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 24*x^6 + 8*x^4 + 48, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 - 8*y^7 + 117496*y^6 - 704864*y^5 + 1867212*y^4 - 2769904*y^3 + 2407108*y^2 - 1153960*y + 241026*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 12*x^2 + 8*x + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^2 + 8*y + 22*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^2 + 8*x + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 8*y + 6*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 12*x^2 + 8*x + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^2 + 8*y + 30*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 4*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 4*y^2 + 8*y + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 8*x^7 + 12*x^2 + 8*x + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^2 + 8*y + 14*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 4*x^4 + 12*x^2 + 8*x + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 12*y^2 + 8*y + 18*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 24, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 8*x + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*2, 8/3, 8/3, 10/3, 10/3, 4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 8*y + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 85/24, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^7 + 2*x^4 + 4*x^2 + 16*x + 2, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 2*y^4 + 4*y^2 + 16*y + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 + 2201331027421701496*x^6 + 137487879400168605274*x^4 - 1421804716661422198684*x^2 + 7999707965346, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 2*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 20*x^2 + 2, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 20*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 + 10*x^4 + 20*x^2 + 2, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 2*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 12*x^2 + 18, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 12*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 + 10*x^4 + 12*x^2 + 18, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 18*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 12*x^2 + 2, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 12*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 + 12*x^6 + 2056428*x^4 + 12338352*x^2 + 18507528, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 28*x^2 + 16*x + 2, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 28*y^2 + 16*y + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 + 12*x^6 + 60588*x^4 + 363312*x^2 + 544968, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 8, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 2*y^4 - 4*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 - 4*x^6 + 228492*x^4 - 456976*x^2 + 228488, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 28*x^2 + 18, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 28*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 + 10*x^4 + 28*x^2 + 18, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 18*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 4*x^2 + 18, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 4*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 2, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 1*]*]*], x^8 - 4*x^6 + 6732*x^4 - 13456*x^2 + 6728, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 12*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 12*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 20*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 20*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 6*x^4 + 28*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 6*y^4 + 28*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 16*x^5 + 28*x^4 + 60*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 14*x^4 + 28*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 28*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 16*x^5 + 28*x^4 + 60*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 4*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 14*x^4 + 12*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 12*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 16*x^5 + 28*x^4 + 60*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 14*x^4 + 12*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 12*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 16*x^5 + 28*x^4 + 60*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 4*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 12*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 12*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 12*x^2 + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 12*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 4*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 4*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 12*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 12*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^2 + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 72, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 432*y^6 + 1944*y^4 + 2916*y^2 + 1458*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 72, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^6 + 72*y^4 - 108*y^2 + 882*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 8, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 300*y^6 + 120*y^4 + 604*y^2 + 162*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^6 + 72, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 5488*y^6 + 10584*y^4 + 6804*y^2 + 1458*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^2 + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 4*x^2 + 18, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 4*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 8*x^3 + 12*x^2 + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 8*y^3 + 12*y^2 + 30*], 0, [*2, 0*], 2, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 2, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 12*x^2 + 10, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 12*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 + 18*x^4 - 108*x^2 + 810, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 4*x^2 + 26, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 4*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 + 53688*x^6 + 1346373162*x^4 + 1450259460612*x^2 + 901477077678810, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 14*x^4 + 4*x^2 + 26, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 14*y^4 + 4*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 - 17896*x^6 + 149597018*x^4 - 53713313356*x^2 + 11129346638010, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 12*x^2 + 10, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 12*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 + 456*x^6 + 54666*x^4 + 850068*x^2 + 96526890, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 12*x^4 + 8*x^3 + 8*x^2 + 6*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 28*x^2 + 10, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 28*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 - 152*x^6 + 6074*x^4 - 31484*x^2 + 1191690, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 12*x^4 + 8*x^3 + 8*x^2 + 6*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 28*x^2 + 10, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 28*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 + 2*x^4 + 4*x^2 + 10, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 20*x^6 + 20*x^4 + 40, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 1700*y^6 + 3350*y^4 + 1500*y^2 + 250*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 + 144*x^6 + 92066*x^4 - 6009964*x^2 + 93391290, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 6*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^6 + 20*x^4 + 40, [*32, "t", [*8, 21*]*], 32, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 5068*y^6 + 6230*y^4 + 2100*y^2 + 250*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2, x^2 + 10, x^2 + 6*]*], [*4, [*x^4 + 2*x^2 + 4*x + 10*]*]*], x^8 - 432*x^6 + 828594*x^4 + 162269028*x^2 + 7564694490, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 6*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 14*x^4 + 4*x^2 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 4*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 2*x^4 + 8*x^3 + 4*x^2 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 2*y^4 + 8*y^3 + 4*y^2 + 16*y + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 8*x^4 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 20*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 20*y^2 + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 4*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y^3 + 4*y^2 + 18*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 4*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 8*x^4 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 4*x^2 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 2*y^4 + 8*y^3 + 4*y^2 + 16*y + 2*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 8*x^4 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 12*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 12*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 8*x^4 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 14*x^4 + 12*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 12*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 4*x + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 20*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 20*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 104, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 432*y^6 + 2808*y^4 + 6084*y^2 + 4394*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 12*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 12*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 4*x^4 + 4*x^2 + 16*x + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^6 + 4*y^4 + 4*y^2 + 16*y + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 104, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^6 + 104*y^4 - 364*y^2 + 3146*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^2 + 26, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 28*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 28*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 40, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^6 + 40*y^4 + 20*y^2 + 90*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 40, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 432*y^6 + 1080*y^4 + 900*y^2 + 250*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 12*x^4 + 8*x^3 + 4*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 12*y^4 + 8*y^3 + 4*y^2 + 14*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^2 + 26, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 20*x^2 + 26, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 20*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 26, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 12*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 12*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 10, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 20*x^4 + 56, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 16*y^6 + 166*y^4 + 1372*y^2 + 3150*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 + 54*x^4 - 108*x^2 + 1134, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 28*x^2 + 30, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 28*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 + 1424*x^6 + 844390*x^4 + 61373940*x^2 + 1466253502, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 14*x^4 + 28*x^2 + 14, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 28*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 + 360*x^6 + 260190*x^4 + 21844404*x^2 + 544429998, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 2*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 14*x^4 + 4*x^2 + 30, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 4*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 - 272232*x^6 + 31447898046*x^4 + 27491920753860*x^2 + 57019456511525214, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 18*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 4*x^2 + 30, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 - 4272*x^6 + 7599510*x^4 - 1657096380*x^2 + 118766533662, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 4*x^2 + 14, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 + 6*x^4 + 4*x^2 + 14, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 4*x^2 + 16*x + 14, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 4*y^2 + 16*y + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 + 90744*x^6 + 3494210894*x^4 - 1018219287180*x^2 + 703943907549694, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 18*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^6 + 4*x^4 + 56, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 5404*y^6 + 8194*y^4 + 4116*y^2 + 686*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 10, x^2 + 14*]*], [*4, [*x^4 + 6*x^2 + 4*x + 14*]*]*], x^8 - 120*x^6 + 28910*x^4 - 809052*x^2 + 6721358, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 2*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 4*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 4*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 28*x^4 + 120, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 24*y^6 + 498*y^4 + 7020*y^2 + 21870*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 96*x^6 + 84*x^4 + 292*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^6 + 28*x^4 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4900*y^6 + 9310*y^4 + 4116*y^2 + 686*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 96*x^6 + 84*x^4 + 292*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^7 + 2*x^4 + 4*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 2*y^4 + 4*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 28*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 28*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 4*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 4*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 96*x^6 + 84*x^4 + 292*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 8*x^3 + 28*x^2 + 16*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 8*y^3 + 28*y^2 + 16*y + 6*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 4*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 4*y^2 + 6*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 96*x^6 + 84*x^4 + 292*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 20*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 20*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^6 + 24*x^4 + 120, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4276*y^6 + 14436*y^4 + 41580*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 20*x^6 + 120, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 2000*y^6 + 9000*y^4 + 13500*y^2 + 6750*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 20*x^2 + 16*x + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 20*y^2 + 16*y + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^6 + 120, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 5488*y^6 + 17640*y^4 + 18900*y^2 + 6750*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 20*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 20*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 56, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 432*y^6 + 1512*y^4 + 1764*y^2 + 686*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 12*x^2 + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 12*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 28*x^2 + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 28*y^2 + 22*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 120, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 432*y^6 + 3240*y^4 + 8100*y^2 + 6750*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 12*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 12*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 12*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 12*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 4*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 4*y^2 + 6*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 28*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^2 + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 4*x^2 + 6, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 + 6*x^4 + 4*x^2 + 6, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 26*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 12*x^2 + 6, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y^3 + 12*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 - 113640*x^6 + 6660809838*x^4 - 3378254796*x^2 + 7892558838, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 30*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 10*x^4 + 28*x^2 + 22, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 10*y^4 + 28*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 + 340920*x^6 + 59947288542*x^4 + 91212879492*x^2 + 639297265878, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 30*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 20*x^4 + 88, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 16*y^6 + 78*y^4 + 1980*y^2 + 7942*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 - 504*x^6 + 310014*x^4 + 1072116*x^2 + 1229094, [*x^8 + 4*x^6 + 4*x^4 + 8*x^3 + 10*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 4*x^2 + 6, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y^3 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 - 240*x^6 + 1093350*x^4 + 3505140*x^2 + 3120822, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 14*x^4 + 4*x^2 + 6, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 14*y^4 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 + 54*x^4 - 108*x^2 + 486, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 26*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 4*x^2 + 6, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 + 168*x^6 + 34446*x^4 - 39708*x^2 + 15174, [*x^8 + 4*x^6 + 4*x^4 + 8*x^3 + 10*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 6*x^4 + 4*x^2 + 22, [*64, "t", [*8, 31*]*], 64, [*32, "t", [*8, 21*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 4*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2, x^2 + 2, x^2 + 6*]*], [*4, [*x^4 + 6*x^2 + 4*x + 6*]*]*], x^8 + 720*x^6 + 9840150*x^4 - 94638780*x^2 + 252786582, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 61/16, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 10*x^4 + 20*x^2 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 10*y^4 + 20*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 4*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^4 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 4*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 28*x^2 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 28*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 4*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^4 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 10*x^4 + 20*x^2 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 20*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^4 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 4*x^2 + 16*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 4*y^2 + 16*y + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^4 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 2*x^4 + 4*x^2 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 31*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 4*y^2 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 4*x + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 123/32, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 4*x^2 + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 4*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 4*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^6 + 88, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^6 + 88*y^4 - 220*y^2 + 1782*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 28*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 28*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 28*x^2 + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 28*y^2 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^4 + 28*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 28*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 20*x^6 + 88, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 2000*y^6 + 6600*y^4 + 7260*y^2 + 2662*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 4*x^2 + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 4*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 4*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 4*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 20*x^2 + 6, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 20*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 28*x^2 + 14, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 28*y^2 + 14*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 20*x^6 + 24, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 1620*y^6 + 1272*y^4 + 6132*y^2 + 1350*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 20*x^2 + 30, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 20*y^2 + 30*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^4 + 12*x^2 + 22, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 12*y^4 + 12*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [**]*], [*4, [*x^4 + 4*x^2 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 25, 8, 1, 8, x^8 + 12*x^6 + 88, [*384, "t", [*8, 44*]*], 384, [*192, "t", [*8, 38*]*], [*8/3, 8/3, 3, 23/6, 23/6, 17/4*], [*3, 2*], [*t + 1, y^8 + 432*y^6 + 2376*y^4 + 4356*y^2 + 2662*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [**]*], [*4, [*x^4 + 4*x + 2*]*]*], 0, -1, 373/96, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 2, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 8*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9, x^4 + 8*x + 14, x^4 + 14*]*]*], 0, [*x^2 + 14, x^2 + 2, x^4 + 6*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 30, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 12*y^4 + 8*y^3 + 30*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1, x^4 + 4*x^2 + 18, x^4 + 14*]*]*], 0, [*x^2 + 2, x^2 + 14, x^4 + 2*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 2, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1, x^4 + 8*x + 14, x^4 + 30*]*]*], 0, [*x^2 + 2, x^2 + 14, x^4 + 2*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 2, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 8*y^5 + 8*y^4 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9, x^4 + 12*x^2 + 2, x^4 + 14*]*]*], 0, [*x^2 + 2, x^2 + 14, x^4 + 6*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 8*y^3 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1, x^4 + 12*x^2 + 18, x^4 + 14*]*]*], 0, [*x^2 + 2, x^2 + 14, x^4 + 2*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 12*x^4 + 8*x^3 + 8*x^2 + 6, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^5 + 12*y^4 + 8*y^3 + 8*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9, x^4 + 12*x^2 + 10, x^4 + 6*]*]*], 0, [*x^2 + 6, x^2 + 10, x^4 + 2*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 6, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9, x^4 + 8*x + 6, x^4 + 22*]*]*], 0, [*x^2 + 10, x^2 + 6, x^4 + 2*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^5 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1, x^4 + 12*x^2 + 2, x^4 + 30*]*]*], 0, [*x^2 + 2, x^2 + 14, x^4 + 2*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 6, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 4*y^4 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1, x^4 + 8*x + 6, x^4 + 6*]*]*], 0, [*x^2 + 10, x^2 + 6, x^4 + 6*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 22, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 12*y^4 + 8*y^3 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9, x^4 + 4*x^2 + 10, x^4 + 6*]*]*], 0, [*x^2 + 10, x^2 + 6, x^4 + 2*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 22, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 12*y^4 + 8*y^3 + 22*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9, x^4 + 8*x^2 + 8*x + 22, x^4 + 22*]*]*], 0, [*x^2 + 10, x^2 + 6, x^4 + 2*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 8*y^4 + 8*y^3 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1, x^4 + 8*x^2 + 8*x + 22, x^4 + 6*]*]*], 0, [*x^2 + 10, x^2 + 6, x^4 + 6*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^3 + 8*x^2 + 18, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 8*y^3 + 8*y^2 + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9, x^4 + 12*x^2 + 18, x^4 + 30*]*]*], 0, [*x^2 + 14, x^2 + 2, x^4 + 6*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^3 + 8*y^2 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1, x^4 + 12*x^2 + 10, x^4 + 22*]*]*], 0, [*x^2 + 10, x^2 + 6, x^4 + 6*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 18, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 8*y^2 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9, x^4 + 4*x^2 + 18, x^4 + 30*]*]*], 0, [*x^2 + 14, x^2 + 2, x^4 + 6*x^2 - 9*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 22, [*16, "t", [*8, 10*]*], 16, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 4*y^4 + 8*y^3 + 22*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1, x^4 + 4*x^2 + 10, x^4 + 22*]*]*], 0, [*x^2 + 10, x^2 + 6, x^4 + 6*x^2 - 1*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 4*x^4 + 8*x^3 + 2, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 4*y^4 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3, x^4 + 4*x^2 + 6, x^4 + 2*]*]*], 0, [*x^2 + 14, x^2 + 10, x^4 - 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 18, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 4*y^4 + 8*y^3 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3, x^4 + 4*x^2 + 6, x^4 + 18*]*]*], 0, [*x^2 + 14, x^2 + 10, x^4 - 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 10, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 12*y^4 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3, x^4 + 8*x + 10, x^4 + 26*]*]*], 0, [*x^2 + 6, x^2 + 2, x^4 + 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 8*x^3 + 10, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3, x^4 + 8*x + 10, x^4 + 10*]*]*], 0, [*x^2 + 6, x^2 + 2, x^4 - 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 14, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 8*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3, x^4 + 8*x + 10, x^4 + 10*]*]*], 0, [*x^2 + 2, x^2 + 6, x^4 + 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 12*x^4 + 8*x^3 + 2, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 12*y^4 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3, x^4 + 12*x^2 + 6, x^4 + 18*]*]*], 0, [*x^2 + 14, x^2 + 10, x^4 + 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 2, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3, x^4 + 4*x^2 + 6, x^4 + 18*]*]*], 0, [*x^2 + 14, x^2 + 10, x^4 + 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 26, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 8*y^3 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3, x^4 + 4*x^2 + 14, x^4 + 10*]*]*], 0, [*x^2 + 6, x^2 + 2, x^4 + 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 14, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3, x^4 + 4*x^2 + 14, x^4 + 26*]*]*], 0, [*x^2 + 6, x^2 + 2, x^4 - 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 18, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 8*y^3 + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3, x^4 + 4*x^2 + 6, x^4 + 2*]*]*], 0, [*x^2 + 14, x^2 + 10, x^4 + 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 14, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^4 + 8*y^3 + 8*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3, x^4 + 4*x^2 + 14, x^4 + 10*]*]*], 0, [*x^2 + 2, x^2 + 6, x^4 - 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 10, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3, x^4 + 4*x^2 + 14, x^4 + 26*]*]*], 0, [*x^2 + 6, x^2 + 2, x^4 + 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 30, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 8*y^3 + 30*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3, x^4 + 8*x + 10, x^4 + 26*]*]*], 0, [*x^2 + 6, x^2 + 2, x^4 - 6*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 8*y^5 + 8*y^3 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3, x^4 + 12*x^2 + 6, x^4 + 18*]*]*], 0, [*x^2 + 14, x^2 + 10, x^4 - 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^4 + 8*y^3 + 8*y^2 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3, x^4 + 12*x^2 + 6, x^4 + 2*]*]*], 0, [*x^2 + 10, x^2 + 14, x^4 - 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 6, [*32, "t", [*8, 18*]*], 32, [*16, "t", [*8, 10*]*], [*2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 8*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3, x^4 + 12*x^2 + 6, x^4 + 2*]*]*], 0, [*x^2 + 14, x^2 + 10, x^4 + 2*x^2 + 3*], 27/8, 4*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^3 + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 564*x^4 + 704*x^2 + 40932, [*x^4 - 20, x^4 - 6*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^3 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 2400*x^6 + 1343388*x^4 - 147750400*x^2 + 3171189636, [*x^4 + 2*x^2 - 4, x^4 + 2*x^2 - 1*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 64282359136*x^6 + 48837157461232*x^4 + 2194096296723200*x^2 + 15356822089000000, [*x^4 + 2*x^2 - 4, x^4 + 2*x^2 - 1*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^3 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 160*x^6 + 6892*x^4 - 14464*x^2 + 6692, [*x^4 + 2*x^2 - 4, x^4 + 2*x^2 - 9*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^4 + 8*x^3 + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^4 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 - 9616*x^6 + 22974468*x^4 - 48237664*x^2 + 18831556, [*x^4 - 20, x^4 + 2*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 149015594464*x^6 + 9552001077200*x^4 + 125995480356096*x^2 + 135037662705216, [*x^4 - 20, x^4 - 6*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 96*x^6 + 84*x^4 + 292, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 107776*y^7 + 2903982724*y^6 - 8027305112*y^5 + 10718313756*y^4 + 5074603944*y^3 + 9030834624*y^2 - 123858043056*y + 163635215074*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 - 8*x^6 + 428*x^4 - 944*x^2 + 79876, [*x^4 - 20, x^4 + 6*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 4*x^4 + 8*x^3 + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 4*y^4 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 17768*x^6 + 79263124*x^4 - 158597488*x^2 + 78959556, [*x^4 + 2*x^2 - 4, x^4 + 6*x^2 - 9*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 16*x^5 + 28*x^4 + 60, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 16*y^7 + 1188*y^6 - 10872*y^5 + 148464*y^4 - 450472*y^3 + 1221128*y^2 - 1401664*y + 1430866*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 61918916778085098204263788284655757741038555718015134157180*x^6 + 69841949263194458187523309552961929307542389586533082181636627026143800218487077161752274100310*x^4 + 28994403924860342222318634744302076325112035097093750871605256227038400832959108476920954432074391842645772*x^2 + 729786586295808524964240675191381357875194495218628638248586763807204277971742395247453901827734528921565724280873, [*x^4 + 2*x^2 - 4, x^4 + 6*x^2 - 1*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 74525487456*x^6 + 7594950616112*x^4 - 1886692876544*x^2 - 3562492352, [*x^4 + 2*x^2 - 4, x^4 + 2*x^2 - 9*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 8*y^3 + 8*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 39848*x^6 + 397893444*x^4 - 3156055600*x^2 + 1308153700, [*x^4 + 2*x^2 - 4, x^4 + 6*x^2 - 1*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 12*x^6 + 8*x^3 + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 9608*x^6 + 23221788*x^4 - 44118544*x^2 + 27532900, [*x^4 - 20, x^4 - 2*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 8*x^4 + 8*x^3 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 8*y^4 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 3051949039212909981344*x^6 + 806052677253921674224*x^4 + 5293527180217938617600*x^2 + 349362069250217000000, [*x^4 + 2*x^2 - 4, x^4 + 6*x^2 - 9*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 8*y^3 + 8*y^2 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 + 2340035306864*x^6 + 137851182764348400*x^4 + 5246012456333698176*x^2 + 79973178168318732864, [*x^4 - 20, x^4 + 2*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 8*y^3 + 8*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 + 2125395527664*x^6 + 12907296175229232*x^4 + 83618198044407424*x^2 + 5668818815237184, [*x^4 - 20, x^4 + 6*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^3 + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 18*]*], [*2, 2, 3, 7/2, 4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 128650607072*x^6 - 38310493009264*x^4 + 401823783009257728*x^2 + 461105201266721904704, [*x^4 - 20, x^4 - 2*x^2 + 3*], 55/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 8*x^3 + 8*x^2 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^3 + 8*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^3 + 10, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^3 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^3 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^3 + 14, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 8*x^3 + 14, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 8*x^3 + 8*x^2 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^3 + 8*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 8*x^3 + 2, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^5 + 8*x^3 + 8*x^2 + 14, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^5 + 8*y^3 + 8*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^3 + 8*x^2 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^3 + 8*y^2 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 8*x^3 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 4*x^4 + 8*x^3 + 6, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 4*y^4 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 8*x^3 + 10, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^3 + 8*x^2 + 10, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^3 + 8*y^2 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 8*x^3 + 14, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 8*x^3 + 8*x^2 + 14, [*192, "t", [*8, 41*]*], 192, [*96, "t", [*8, 33*]*], [*8/3, 8/3, 3, 23/6, 23/6*], [*3, 2*], [*t + 1, y^8 + 8*y^3 + 8*y^2 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [**]*]*], 0, -1, 169/48, 1*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 26, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 4*x^6 + 4*x^4 + 1, [*x^4 + 12*x^2 + 2, x^4 + 2*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 26, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 - 4*x^6 + 12*x^4 - 16*x^2 + 9, [*x^4 + 8*x + 14, x^4 + 18*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 2*y^4 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 12*x^6 + 108*x^4 + 432*x^2 + 1377, [*x^4 + 12*x^2 + 10, x^4 + 10*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 24*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 36*x^6 + 468*x^4 - 2592*x^2 + 9153, [*x^4 + 18, x^4 + 12*x^2 + 18*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^5 + 10*x^4 + 8*x^3 + 16*x^2 + 18, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 10*y^4 + 8*y^3 + 16*y^2 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 1180*x^6 + 795020*x^4 + 336832136*x^2 + 123309412993, [*x^4 + 10, x^4 + 8*x + 6*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 8*x^3 + 10, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 8*y^3 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 6108*x^6 + 10972764*x^4 + 66721104*x^2 + 133378569, [*x^4 + 2, x^4 + 4*x^2 + 18*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 16*x + 26, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 16*y + 26*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 + 12*x^6 + 52*x^4 + 96*x^2 + 113, [*x^4 + 12*x^2 + 18, x^4 + 18*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 2, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 - 4*x^6 + 12*x^4 - 16*x^2 + 17, [*x^4 + 12*x^2 + 10, x^4 + 10*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 16*x^2 + 2, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 16*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 - 84*x^6 + 3132*x^4 - 74952*x^2 + 999297, [*x^4 + 26, x^4 + 4*x^2 + 10*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 2, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 28*x^6 + 348*x^4 + 2776*x^2 + 12337, [*x^4 + 4*x^2 + 10, x^4 + 26*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 18, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 348*x^6 + 174492*x^4 + 48577104*x^2 + 13764515409, [*x^4 + 8*x^2 + 8*x + 22, x^4 + 26*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 2*y^4 + 8*y^3 + 24*y^2 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 - 116*x^6 + 19388*x^4 - 1799152*x^2 + 169932289, [*x^4 + 8*x^2 + 8*x + 22, x^4 + 26*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 8*x^3 + 24*x^2 + 2, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 8*y^3 + 24*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 + 12*x^6 + 36*x^4 + 81, [*x^4 + 12*x^2 + 2, x^4 + 2*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 16*x + 26, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 16*y + 26*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 - 2036*x^6 + 1219196*x^4 - 2471152*x^2 + 1646649, [*x^4 + 2, x^4 + 4*x^2 + 18*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 18, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 - 3540*x^6 + 7155180*x^4 - 9094467672*x^2 + 9988062452433, [*x^4 + 8*x + 6, x^4 + 10*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 16*x + 10, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 16*y + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 12*x^6 + 108*x^4 + 432*x^2 + 729, [*x^4 + 8*x + 14, x^4 + 18*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 24*x^6 + 144, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 4396*y^6 - 26264*y^5 + 91942*y^4 - 192824*y^3 + 516448*y^2 - 717200*y + 580558*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 + 348*x^6 + 40824*x^4 + 295704*x^2 + 81729, [*x^4 + 8*x + 10, x^4 + 14*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 + 60*x^6 + 792*x^4 + 3888*x^2 + 6561, [*x^4 + 4*x^2 + 14, x^4 + 30*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 16*x^2 + 16*x + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 16*y^2 + 16*y + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 436*x^6 - 36728*x^4 + 121824*x^2 - 102303, [*x^4 + 14, x^4 + 4*x^2 + 14*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^5 + 14*x^4 + 8*x^3 + 24*x^2 + 22, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 14*y^4 + 8*y^3 + 24*y^2 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 + 828*x^6 + 85176*x^4 - 50328000*x^2 + 27797387625, [*x^4 + 12*x^2 + 6, x^4 + 22*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 32*x^2 + 272, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 82*y^4 + 376*y^3 - 11272*y^2 + 21536*y + 112198*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 + 12*x^6 + 72*x^4 + 216*x^2 + 729, [*x^4 + 4*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 16*x + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 16*y + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 + 1308*x^6 - 330552*x^4 - 3289248*x^2 - 8286543, [*x^4 + 4*x^2 + 14, x^4 + 14*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 10*y^4 + 8*y^3 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 20*x^6 + 88*x^4 - 144*x^2 + 81, [*x^4 + 4*x^2 + 14, x^4 + 30*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 16, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 596*y^6 - 3464*y^5 + 9046*y^4 - 13240*y^3 + 11360*y^2 - 5392*y + 1126*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 + 12*x^6 + 2424*x^4 + 99128*x^2 + 2517561, [*x^4 + 4*x^2 + 6, x^4 + 22*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 144, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 36*y^6 - 104*y^5 + 214*y^4 - 312*y^3 + 312*y^2 - 192*y + 54*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 - 4*x^6 + 8*x^4 - 8*x^2 + 1, [*x^4 + 30, x^4 + 8*x + 10*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 10*x^4 + 8*x^3 + 8*x^2 + 22, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y^3 + 8*y^2 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 + 12*x^6 + 136*x^4 + 720*x^2 + 1225, [*x^4 + 12*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^5 + 6*x^4 + 8*x^3 + 30, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 6*y^4 + 8*y^3 + 30*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 - 276*x^6 + 9464*x^4 + 1864000*x^2 + 343177625, [*x^4 + 22, x^4 + 12*x^2 + 6*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 10*x^4 + 8*x^3 + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 10*y^4 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 - 36*x^6 + 21816*x^4 - 2676456*x^2 + 203922441, [*x^4 + 4*x^2 + 6, x^4 + 22*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 - 36*x^6 + 1224*x^4 - 19440*x^2 + 99225, [*x^4 + 12*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 40*x^6 + 16, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 1607988*y^6 - 9647816*y^5 + 24361270*y^4 - 33126456*y^3 + 25578288*y^2 - 10631088*y + 1868022*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 - 4*x^6 + 8*x^4 - 8*x^2 + 9, [*x^4 + 4*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 16*x^2 + 6, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y^3 + 16*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 + 12*x^6 + 72*x^4 + 216*x^2 + 81, [*x^4 + 30, x^4 + 8*x + 10*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 40*x^6 + 144, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 65620*y^6 - 393608*y^5 + 1320502*y^4 - 2658104*y^3 + 3622376*y^2 - 2978080*y + 1175750*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 - 116*x^6 + 4536*x^4 - 10952*x^2 + 1009, [*x^4 + 8*x + 10, x^4 + 14*], 61/16, 2*], [*2, 26, 8, 1, 8, x^8 + 40*x^6 + 464, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 1606588*y^6 - 9639416*y^5 + 31515046*y^4 - 61797560*y^3 + 77016584*y^2 - 56143072*y + 20504962*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 22*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 2*x^4 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 2*x^4 + 8*x^3 + 8*x^2 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 2*y^4 + 8*y^3 + 8*y^2 + 16*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 8*x^3 + 24*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 8*y^3 + 24*y^2 + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 2*x^4 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 30*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 26*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 14*x^4 + 8*x^3 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 14*y^4 + 8*y^3 + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x + 52*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 464, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 132*y^6 - 680*y^5 + 6038*y^4 - 19768*y^3 + 119792*y^2 - 201776*y + 924538*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 14*x^4 + 8*x^3 + 8*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 14*y^4 + 8*y^3 + 8*y^2 + 18*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 40*x^6 + 16*x^4 + 336, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 1543148*y^6 - 9258776*y^5 + 39889514*y^4 - 97833032*y^3 + 153415552*y^2 - 135855024*y + 210511806*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 36*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 336, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 148*y^6 - 776*y^5 + 6070*y^4 - 19256*y^3 + 79360*y^2 - 122192*y + 194434*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 24*y^2 + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x + 52*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 16*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 16*y + 14*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 36*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y^3 + 10*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 10*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 2*x^4 + 8*x^3 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^3 + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 14*x^4 + 8*x^3 + 16*x + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^3 + 16*y + 30*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 2*y^4 + 8*y^3 + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 2*x^4 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 24*x^6 + 336, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 129052*y^6 - 774200*y^5 + 4061302*y^4 - 11084024*y^3 + 22821400*y^2 - 25539200*y + 40474666*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 6*x^4 + 8*x^3 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y^3 + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 36*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 6*x^4 + 8*x^3 + 16*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 6*y^4 + 8*y^3 + 16*y^2 + 14*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 36*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 80, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 556*y^6 - 3224*y^5 + 10630*y^4 - 21176*y^3 + 26568*y^2 - 19296*y + 6794*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 8*y^3 + 16*y + 2*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 14*x^4 + 8*x^3 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 14*y^4 + 8*y^3 + 16*y + 2*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 8*x^3 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 8*y^3 + 6*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x + 52*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 24*x^6 + 80, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 126028*y^6 - 756056*y^5 + 2052390*y^4 - 3169336*y^3 + 2914528*y^2 - 1506448*y + 349026*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 60*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 32*x^2 + 80, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 104*y^6 - 512*y^5 + 2722*y^4 - 7624*y^3 + 10408*y^2 - 6848*y + 1762*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 16*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 2*y^4 + 8*y^3 + 16*y + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 2*x^4 + 4*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 2*x^4 + 8*x^3 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 2*y^4 + 8*y^3 + 6*], 0, [*1, 1*], 1, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x + 52*], 123/32, 2*], [*2, 26, 8, 1, 8, x^8 + 8*x^6 + 208, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 29*]*], [*2, 2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 164*y^6 - 872*y^5 + 5334*y^4 - 15672*y^3 + 43408*y^2 - 57712*y + 33482*], 0, [*1, 1*], 1, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 14*x^4 + 8*x^2 + 4*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 2, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 4*x^6 + 6*x^4 + 2, [*x^4 + 2*x^2 - 1, x^4 + 2*x^2 - 1*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 18, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 + 12*x^6 + 54*x^4 + 162, [*x^4 + 2*x^2 - 1, x^4 + 2*x^2 - 1*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 24*x^2 + 18, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 24*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 - 2020*x^6 + 6858574*x^4 + 4643216*x^2 + 3293298, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 2*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 14*x^4 + 16*x^3 + 18, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 14*y^4 + 16*y^3 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 6060*x^6 + 61727166*x^4 - 125366832*x^2 + 266757138, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 2*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 6*x^4 + 18, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 6*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 12*x^6 + 46*x^4 + 32*x^2 + 18, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 12*x^2 + 14*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 16*x + 18, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 16*y + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 + 12*x^6 + 38*x^4 + 48*x^2 + 226, [*x^8 + 4*x^7 + 14*x^4 + 4*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 14*x^4 + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 14*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 - 36*x^6 + 414*x^4 - 864*x^2 + 1458, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 12*x^2 + 14*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 16*x + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 16*y + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 36*x^6 + 342*x^4 - 1296*x^2 + 18306, [*x^8 + 4*x^7 + 14*x^4 + 4*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 10*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 36*x^4 + 16*x^2 + 8, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8308*y^6 + 242634558*y^4 - 10866504*y^2 + 132098*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 8*x + 14*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 10*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 10*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 8*x + 14*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 10*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 10*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 18*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 18*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 8*x + 14*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 2*x^4 + 16*x^3 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 2*y^4 + 16*y^3 + 8*y^2 + 10*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 8*x + 14*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 26*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 4*x^4 + 8*x^2 + 8*x + 2*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 18*x^4 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 18*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 24*x^6 + 270*x^4 - 1728*x^2 + 6642, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 26*x^4 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 26*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 360*x^6 + 32422*x^4 + 3008*x^2 + 11538, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 - 1080*x^6 + 291798*x^4 - 81216*x^2 + 934578, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 22*x^4 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 22*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 6096*x^6 + 9290646*x^4 + 897264*x^2 + 29639682, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 + 8*x^6 + 30*x^4 + 64*x^2 + 82, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 26*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 26*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 - 1672*x^6 + 5921895622*x^4 + 340000880*x^2 + 2111004018, [*x^8 + 12*x^6 + 8*x^3 + 8*x^2 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 48*x^6 + 846*x^4 - 6480*x^2 + 18306, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 30*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 30*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 2*x^4 + 2, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 5016*x^6 + 53297060598*x^4 - 9180023760*x^2 + 170991325458, [*x^8 + 12*x^6 + 8*x^3 + 8*x^2 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 - 2032*x^6 + 1032294*x^4 - 33232*x^2 + 365922, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 + 24*x^6 + 318*x^4 + 1456*x^2 + 9266, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 6*x^4 + 2, [*x^8 + 12*x^6 + 8*x^3 + 8*x^2 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 22*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 22*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], x^8 + 54*x^4 + 162, [*x^8 + 12*x^6 + 8*x^3 + 8*x^2 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 36*x^4 + 72, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 1131678*y^4 + 118098*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 + 16*x^6 + 94*x^4 + 240*x^2 + 226, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 18*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 18*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 72*x^6 + 2862*x^4 - 39312*x^2 + 750546, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], x^8 - 18*x^4 + 162, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 10*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 10*y^4 + 10*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 2*x^4 + 24*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 2*y^4 + 24*y^2 + 10*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 14*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 14*y^4 + 10*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 2*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^5 + 2*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 8, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 56*y^6 + 186*y^4 + 24*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 2*x^4 + 16*x + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 2*y^4 + 16*y + 10*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 8*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 8*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], 0, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 2*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 8*x^2 + 2, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 8*y^2 + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 300*x^6 - 356274*x^4 + 28639440*x^2 + 137645154090, [*x^4 + 2*x^2 - 9, x^4 + 2*x^2 - 9*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 22*x^4 + 16*x^2 + 26, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 22*y^4 + 16*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 - 100*x^6 - 39586*x^4 - 1060720*x^2 + 1699322890, [*x^4 + 2*x^2 - 9, x^4 + 2*x^2 - 9*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 52*x^4 + 40, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 256*y^7 + 2496*y^6 + 7992*y^5 + 8398*y^4 + 250*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 36*x^6 + 1034*x^4 + 13320*x^2 + 123370, [*x^8 + 152*x^4 + 16*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 10, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 - 108*x^6 + 9306*x^4 - 359640*x^2 + 9992970, [*x^8 + 152*x^4 + 16*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 16*x + 26, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 16*y + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 4452*x^6 + 19196154*x^4 + 57998061720*x^2 + 99880624524330, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 8*x^3 + 4*x^2 + 6*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 14*x^4 + 26, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 14*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 12*x^6 + 62*x^4 + 160*x^2 + 170, [*x^8 + 4*x^7 + 6*x^4 + 4*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 22*x^4 + 16*x^3 + 26, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 22*y^4 + 16*y^3 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 - 1484*x^6 + 2132906*x^4 - 2148076360*x^2 + 1233094129930, [*x^8 + 4*x^7 + 4*x^6 + 6*x^4 + 8*x^3 + 4*x^2 + 6*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 14*x^4 + 10, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 14*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 - 36*x^6 + 558*x^4 - 4320*x^2 + 13770, [*x^8 + 4*x^7 + 6*x^4 + 4*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 10*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 10*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 18*x^4 + 16*x + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 18*y^4 + 16*y + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 26*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 26*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 10*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 10*y^4 + 18*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 18*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 18*y^4 + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 8*x^3 + 8*x^2 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 - 216*x^6 - 5438206*x^4 + 91368720*x^2 + 10058357913370, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 12*x^4 + 104, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 - 126*y^4 + 4394*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 2*x^4 + 10, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 26*x^4 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 26*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 120*x^6 - 28735434*x^4 - 22318621200*x^2 + 809491151203290, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 22*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 6*x^4 + 10, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 22*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 14*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 - 104*x^6 + 4706*x^4 - 104320*x^2 + 1006330, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 2*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 - 112*x^6 + 23138*x^4 - 1118960*x^2 + 99950890, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 72*x^6 + 3302*x^4 + 72320*x^2 + 999770, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 12*x^4 + 8*x^3 + 8*x^2 + 6*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 18*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 18*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 336*x^6 + 208242*x^4 + 30211920*x^2 + 8096022090, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 10*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 - 40*x^6 - 3192826*x^4 + 826615600*x^2 + 9993717916090, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 22*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 22*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 22*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 336*x^6 + 208278*x^4 + 30259440*x^2 + 8096773770, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 12*x^4 + 8*x^3 + 8*x^2 + 6*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 26*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 26*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 - 216*x^6 + 29718*x^4 - 1952640*x^2 + 80981370, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 12*x^4 + 8*x^3 + 8*x^2 + 6*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 22*x^4 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 22*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 + 54*x^4 + 810, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 22*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 18*x^4 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 18*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 18*x^4 + 810, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 6*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 10*]*]*], x^8 - 112*x^6 + 23142*x^4 - 1120720*x^2 + 99960170, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 12*x^4 + 8*x^3 + 8*x^2 + 6*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 30*x^4 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 30*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 312*x^6 + 42354*x^4 + 2816640*x^2 + 81512730, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 30*x^4 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 1*], [*t + 1, y^8 + 30*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 2*x^2 + 10*]*]*], x^8 + 648*x^6 - 48943854*x^4 - 2466955440*x^2 + 814726990982970, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 63/16, 4*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 26*x^4 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 26*y^4 + 16*y + 2*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 4*x^4 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^6 + 20*x^4 + 104, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 1358*y^4 + 4056*y^2 + 4394*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 4*x^4 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 10*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 10*y^4 + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 4*x^4 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 2*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 2*y^4 + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 + 6*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 4*x^4 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 14*x^4 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 14*y^4 + 16*y + 2*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 2*x + 2*]*], [*4, [*x^4 - 2*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^3 + 10*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 2*x^4 + 30, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 2*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 + 324*x^6 + 106290*x^4 + 637632*x^2 - 163458, [*x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 6*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 60*x^4 + 16*x^2 + 56, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 12918*y^4 - 2456*y^2 + 686*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 - 108*x^6 + 11810*x^4 - 23616*x^2 - 2018, [*x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 6*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 10*x^4 + 14, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 10*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 + 60*x^6 - 882*x^4 + 1944*x^2 - 13122, [*x^4 + 2*x^2 + 3, x^4 + 2*x^2 + 3*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 10*x^4 + 30, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 10*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 20*x^6 - 98*x^4 - 72*x^2 - 162, [*x^4 + 2*x^2 + 3, x^4 + 2*x^2 + 3*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 2*x^4 + 16*x^3 + 14, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 2*y^4 + 16*y^3 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 - 12*x^6 + 18*x^4 + 432*x^2 - 162, [*x^8 + 184*x^4 + 400*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 18*x^4 + 16*x^2 + 30, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 18*y^4 + 16*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 + 4*x^6 + 2*x^4 - 16*x^2 - 2, [*x^8 + 184*x^4 + 400*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 10*x^4 + 14, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 10*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 964*x^6 + 104638*x^4 - 52920*x^2 + 204606, [*x^8 + 4*x^7 + 10*x^4 + 4*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 10*x^4 + 30, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 10*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 + 2892*x^6 + 941742*x^4 + 1428840*x^2 + 16573086, [*x^8 + 4*x^7 + 10*x^4 + 4*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 14*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 14*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 22*x^4 + 16*x + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 22*y^4 + 16*y + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^4 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 52*x^4 + 48*x^2 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 36*y^6 + 8674*y^4 - 4824*y^2 + 686*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^4 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 30*x^4 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 30*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 6*x^4 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 6*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^4 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 6*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 6*y^4 + 6*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^4 + 8*x + 6*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 14*x^4 + 16*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 14*y^4 + 16*y + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 10*x^4 + 24*x^2 + 16*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 10*y^4 + 24*y^2 + 16*y + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 16*x^3 + 8*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 40*x^6 + 382*x^4 + 288*x^2 + 366, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 6*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 2*x^4 - 2, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 6*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 152*x^6 - 468962*x^4 - 98736*x^2 - 462258, [*x^8 + 12*x^6 + 12*x^4 + 8*x^3 + 2*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 + 2*x^4 - 2, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 - 72*x^6 + 476066*x^4 - 646800*x^2 - 244178, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], x^8 - 112*x^6 + 3166*x^4 - 1872*x^2 + 2526, [*x^8 + 12*x^6 + 12*x^4 + 8*x^3 + 2*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 - 112*x^6 + 3170*x^4 - 1712*x^2 - 2018, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], x^8 + 40*x^6 + 386*x^4 - 352*x^2 - 242, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 24*x^6 + 52*x^4 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2072*y^6 + 4198*y^4 + 5320*y^2 + 1694*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 2*x^4 + 16*x + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 2*y^4 + 16*y + 22*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 2*x^4 + 8*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 2*y^4 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 8*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 8*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^6 + 52*x^4 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 - 184*y^6 + 8914*y^4 + 1176*y^2 + 686*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 2*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 2*y^4 + 6*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 24*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 24*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 6*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 10*x^4 + 22, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 10*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 + 12*x^6 + 46*x^4 - 1320*x^2 + 7350, [*x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 14*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 26*x^4 + 16*x + 6, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 26*y^4 + 16*y + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 - 36*x^6 + 414*x^4 + 35640*x^2 + 595350, [*x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 14*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 22, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 - 60*x^6 - 4158*x^4 + 10938240*x^2 + 1223534646, [*x^4 + 6*x^2 + 3, x^4 + 6*x^2 + 3*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 2*x^4 + 6, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 2*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 + 20*x^6 - 462*x^4 - 405120*x^2 + 15105366, [*x^4 + 6*x^2 + 3, x^4 + 6*x^2 + 3*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 14*x^4 + 16*x^3 + 22, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 14*y^4 + 16*y^3 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 - 676*x^6 + 144974*x^4 - 15298200*x^2 + 2059065750, [*x^8 + 56*x^4 + 400*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 22, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 + 4*x^6 + 18*x^4 + 48*x^2 + 54, [*x^8 + 40*x^4 + 528*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 2*x^4 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 - 12*x^6 + 162*x^4 - 1296*x^2 + 4374, [*x^8 + 40*x^4 + 528*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 10*x^4 + 22, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 10*y^4 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 + 2028*x^6 + 1304766*x^4 + 413051400*x^2 + 166784325750, [*x^8 + 56*x^4 + 400*], 29/8, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^5 + 6*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 6*y^4 + 30*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 12*x^6 + 14*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 14*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^4 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 22*x^4 + 24*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 22*y^4 + 24*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^4 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 18*x^4 + 16*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 18*y^4 + 16*y + 14*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 14*x^4 + 16*x + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 14*y^4 + 16*y + 30*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^4 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 22*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 22*y^4 + 30*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 60*x^4 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 264*y^7 + 3000*y^6 + 10392*y^5 + 19954*y^4 + 17808*y^3 + 34272*y^2 + 15344*y + 23086*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^2 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 4*x^6 + 14*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 14*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 8*x^4 + 8*x + 10*], 123/32, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 + 16*x^6 + 2654*x^4 + 20400*x^2 + 1680870, [*x^8 + 4*x^6 + 4*x^4 + 8*x^3 + 10*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 + 72*x^6 + 172126*x^4 - 6620400*x^2 + 12816633750, [*x^8 + 4*x^6 + 4*x^4 + 8*x^3 + 10*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 + 16*x^6 + 2658*x^4 + 21072*x^2 + 1678374, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 14*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 - 56*x^6 + 1218*x^4 - 12192*x^2 + 47574, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 14*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 6*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 6*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 - 40*x^6 - 164382*x^4 + 13228080*x^2 + 13307827446, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 + 6*]*]*], x^8 + 2*x^4 + 6, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 10*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 10*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 + 56*x^6 + 1214*x^4 + 12000*x^2 + 45750, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 30*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 + 6*]*]*], x^8 - 2*x^4 + 6, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 30*], 63/16, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 22*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 8*y^5 + 22*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 24*x^6 + 60*x^4 + 24, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 1944*y^6 + 2634*y^4 + 1896*y^2 + 726*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 14*x^4 + 8*x^2 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 14*y^4 + 8*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 22*x^4 + 8*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 22*y^4 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 14*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 2*x^4 + 8*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2*y^4 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 14*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^6 + 2*x^4 + 16*x^3 + 8*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 2*y^4 + 16*y^3 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 14*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 24*x^6 + 44*x^4 + 24, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 2664*y^6 + 7718*y^4 + 648*y^2 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 - 2*x^2 - 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 8*x^2 + 14*], 127/32, 2*], [*2, 27, 8, 1, 8, x^8 + 8*x^7 + 6*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 26*]*], [*2, 2, 3, 7/2, 4, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 6*y^4 + 30*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*x - 2*]*], [*4, [*x^4 + 2*x^2 - 2*]*]*], 0, [*x^8 + 12*x^6 + 8*x^3 + 14*], 127/32, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 6, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 - 20*x^6 + 134*x^4 - 340*x^2 + 297, [*x^4 + 6*x^2 + 2, x^4 + 4*x^2 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 4*y^4 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 9, [*x^4 - 2*x^2 + 2, x^4 + 12*x^2 + 2*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 22, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^4 + 6*x^2 + 10, x^4 + 26*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 16*x^2 + 14, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 16*y^2 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^4 + 6*x^2 + 2, x^4 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 8*x^4 + 16*x^2 + 6, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 8*y^4 + 16*y^2 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^4 + 2*x^2 + 10, x^4 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 56, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 16928*y^7 - 85704*y^6 - 177096*y^5 - 77840*y^4 + 2280544*y^3 + 13663440*y^2 + 26424832*y + 21669774*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^4 - 2*x^2 + 2, x^4 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 6, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^4 + 6*x^2 + 10, x^4 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 8*x^2 + 26, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 8*y^2 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 1001, [*x^4 + 6*x^2 + 10, x^4 + 12*x^2 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^2 + 2, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 8*y^2 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 3900*x^6 + 5692086*x^4 + 3684692700*x^2 + 892770334137, [*x^4 + 6*x^2 + 2, x^4 + 8*x + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^2 + 26, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 8*y^2 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 1212*x^6 + 547254*x^4 + 109090908*x^2 + 8108181081, [*x^4 + 2*x^2 + 10, x^4 + 8*x + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 6, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 6*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 729, [*x^4 - 2*x^2 + 2, x^4 + 12*x^2 + 2*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^2 + 16*x + 2, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 8*y^2 + 16*y + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 - 1300*x^6 + 632454*x^4 - 136470100*x^2 + 11021855977, [*x^4 + 6*x^2 + 2, x^4 + 8*x + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 16*x^2 + 22, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 16*y^2 + 22*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^4 + 2*x^2 + 10, x^4 + 26*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 14, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^4 + 6*x^2 + 2, x^4 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 14, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 - 404*x^6 + 60806*x^4 - 4040404*x^2 + 100101001, [*x^4 + 2*x^2 + 10, x^4 + 8*x + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 14, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 14*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 81081, [*x^4 + 6*x^2 + 10, x^4 + 12*x^2 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 6, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^4 + 2*x^2 + 10, x^4 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 30, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 8*y^4 + 30*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^4 + 6*x^2 + 2, x^4 + 2*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^4 + 6, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 8*y^4 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^4 + 6*x^2 + 10, x^4 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 30, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 30*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^4 - 2*x^2 + 2, x^4 + 2*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 14, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 4*y^4 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 17577, [*x^4 + 6*x^2 + 10, x^4 + 8*x^2 + 8*x + 22*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 30, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 30*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 - 2708*x^6 + 2747270*x^4 - 1237493716*x^2 + 208838963529, [*x^4 + 2*x^2 + 10, x^4 + 4*x^2 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 30, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 30*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 1423737, [*x^4 + 6*x^2 + 10, x^4 + 8*x^2 + 8*x + 22*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 104, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 - 48*y^7 + 1728*y^6 - 104*y^5 + 14976*y^3 + 1352*y^2 - 43264*y + 36842*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 8124*x^6 + 24725430*x^4 + 33412330332*x^2 + 16915956045849, [*x^4 + 2*x^2 + 10, x^4 + 4*x^2 + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^4 + 30, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 8*y^4 + 30*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^4 - 2*x^2 + 2, x^4 + 2*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 24, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 288*y^7 + 128*y^6 - 56*y^5 + 840*y^4 + 384*y^3 + 336*y^2 + 480*y + 150*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^4 + 6*x^2 + 10, x^4 + 26*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 30, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 30*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^4 + 6*x^2 + 2, x^4 + 2*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 22, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 22*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 472473, [*x^4 - 2*x^2 + 2, x^4 + 12*x^2 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 4*y^4 + 6*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 5833, [*x^4 - 2*x^2 + 2, x^4 + 12*x^2 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^2 + 18, [*32, "t", [*8, 19*]*], 32, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 8*y^2 + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 60*x^6 + 1206*x^4 + 9180*x^2 + 24057, [*x^4 + 6*x^2 + 2, x^4 + 4*x^2 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 14, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^4 - 2*x^2 + 2, x^4 + 18*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 22, [*32, "t", [*8, 20*]*], 32, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 1*], [*t + 1, y^8 + 8*y^5 + 22*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^4 + 2*x^2 + 10, x^4 + 26*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 16*x^6 + 44*x^4 + 196, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 9632*y^6 + 24152*y^5 + 68268*y^4 + 610816*y^3 + 1539312*y^2 + 167392*y + 12827482*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 - 148*x^6 + 8070*x^4 - 191956*x^2 + 1687609, [*x^4 + 2*x^2 + 6, x^4 + 4*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 60*x^4 + 96*x^2 + 100, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 32*y^7 + 848*y^6 + 5096*y^5 + 27604*y^4 + 100992*y^3 + 226736*y^2 + 289376*y + 215090*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 222345, [*x^4 + 2*x^2 - 2, x^4 + 8*x + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 120, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 6504*y^7 + 20496*y^6 - 149640*y^5 + 930720*y^4 - 8501280*y^3 + 27211560*y^2 - 34048080*y + 42167790*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 - 3604*x^6 + 4867206*x^4 - 2919243604*x^2 + 656124327001, [*x^4 - 2*x^2 - 2, x^4 + 4*x^2 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 8*y^4 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 - 34708*x^6 + 301364574*x^4 - 647627332*x^2 + 357780241, [*x^4 - 2*x^2 + 6, x^4 + 22*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 18, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 + 12*x^6 - 18*x^4 - 324*x^2 + 16929, [*x^4 + 2*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 41, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 40*y^5 + 40*y^4 + 600*y^2 - 1600*y + 1350*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 17577, [*x^4 - 2*x^2 + 6, x^4 + 12*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 108*x^6 + 6*x^4 + 44*x^2 + 25, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 11336*y^7 + 3631583224*y^6 - 18289611144*y^5 + 59093433656*y^4 - 63991803568*y^3 + 68733855736*y^2 - 4824469872*y + 700901678*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 - 788*x^6 + 232070*x^4 - 30272596*x^2 + 1476329625, [*x^4 - 2*x^2 - 2, x^4 + 4*x^2 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 108*x^6 + 6*x^4 + 44*x^2 + 121, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 - 11344*y^7 + 3630403360*y^6 - 40124519208*y^5 + 224086754960*y^4 - 703780909520*y^3 + 1259210279768*y^2 - 1229744742048*y + 550053022166*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 - 1940*x^6 + 1409414*x^4 - 454458580*x^2 + 54881037817, [*x^4 + 2*x^2 + 6, x^4 + 4*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 26, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 26*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 444*x^6 + 72630*x^4 + 5182812*x^2 + 136696329, [*x^4 + 2*x^2 + 6, x^4 + 4*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 12*x^4 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 12*y^4 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 2364*x^6 + 2088630*x^4 + 817360092*x^2 + 119582699625, [*x^4 - 2*x^2 - 2, x^4 + 4*x^2 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 26, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 20*x^6 + 126*x^4 + 196*x^2 + 657, [*x^4 + 2*x^2 - 2, x^4 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 217, [*x^4 - 2*x^2 + 6, x^4 + 12*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 24*y^2 + 14*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 2187081, [*x^4 + 2*x^2 - 2, x^4 + 8*x + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^2 + 22, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 8*y^2 + 22*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 5820*x^6 + 12684726*x^4 + 12270381660*x^2 + 4445364063177, [*x^4 + 2*x^2 + 6, x^4 + 4*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 26, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 - 1476*x^6 + 1239390*x^4 - 506398068*x^2 + 115151321169, [*x^4 - 2*x^2 - 2, x^4 + 30*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 8*x^4 + 18, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 8*y^4 + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 - 324*x^6 + 47934*x^4 - 3575988*x^2 + 128677329, [*x^4 + 2*x^2 + 6, x^4 + 22*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 16*x^2 + 26, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 16*y^2 + 26*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 492*x^6 + 137710*x^4 + 18755484*x^2 + 1421621249, [*x^4 - 2*x^2 - 2, x^4 + 30*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 26, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 26*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 10649, [*x^4 - 2*x^2 + 6, x^4 + 12*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 - 380*x^6 + 324446*x^4 + 9530452*x^2 + 72554481, [*x^4 + 2*x^2 - 2, x^4 + 30*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 10*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 - 4*x^6 - 98*x^4 + 204*x^2 + 2641, [*x^4 - 2*x^2 - 2, x^4 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 18, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 18*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 - 4*x^6 + 1518*x^4 - 3028*x^2 + 1729, [*x^4 - 2*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 26, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 26*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 12*x^6 - 882*x^4 - 5508*x^2 + 213921, [*x^4 - 2*x^2 - 2, x^4 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 16*x^2 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 16*y^2 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 1140*x^6 + 2920014*x^4 - 257322204*x^2 + 5876912961, [*x^4 + 2*x^2 - 2, x^4 + 30*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 8*y^5 + 16*y^2 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 + 12*x^6 + 13662*x^4 + 81756*x^2 + 140049, [*x^4 - 2*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 8*x^5 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^5 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 - 4*x^6 - 2*x^4 + 12*x^2 + 209, [*x^4 + 2*x^2 + 6, x^4 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 10, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 8*y^4 + 10*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 - 60*x^6 + 1134*x^4 - 5292*x^2 + 53217, [*x^4 + 2*x^2 - 2, x^4 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 24*x^2 + 16*x + 30, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 24*y^2 + 16*y + 30*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 10812*x^6 + 43804854*x^4 + 78819577308*x^2 + 53146070487081, [*x^4 - 2*x^2 - 2, x^4 + 4*x^2 + 14*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 4*x^4 + 26, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 4*y^4 + 26*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 862569, [*x^4 - 2*x^2 + 6, x^4 + 12*x^2 + 6*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 18, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 18*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 2745, [*x^4 + 2*x^2 - 2, x^4 + 8*x + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 2*], 0, [*1, 0*], 1, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 + 104124*x^6 + 2712281166*x^4 + 17485937964*x^2 + 28980199521, [*x^4 - 2*x^2 + 6, x^4 + 22*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^5 + 4*x^4 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 19*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^5 + 4*y^4 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 - 4*x^6 + 6*x^4 - 4*x^2 + 27001, [*x^4 + 2*x^2 - 2, x^4 + 8*x + 10*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 8*x^5 + 2, [*64, "t", [*8, 29*]*], 64, [*32, "t", [*8, 20*]*], [*2, 3, 7/2, 4, 17/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^5 + 2*], 0, [*1, 0*], 1, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 + 108*x^6 + 5326*x^4 + 132444*x^2 + 1588609, [*x^4 + 2*x^2 + 6, x^4 + 22*], 61/16, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^4 + 60, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 100*y^6 - 488*y^5 + 2068*y^4 - 5168*y^3 - 226664*y^2 + 462448*y + 3997126*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 12*x^4 + 60, [*x^4 + 6*x^2 + 10, x^4 + 6*x^2 + 10*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^4 + 124, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 388*y^6 - 2216*y^5 + 39796*y^4 - 144560*y^3 + 814024*y^2 - 1344752*y + 47766286*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 4*x^4 + 124, [*x^4 - 2*x^2 + 2, x^4 - 2*x^2 + 2*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^4 + 496, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 520*y^4 - 1856*y^3 + 2728*y^2 - 1808*y + 1569826*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 - 72*x^6 + 1396*x^4 - 2640*x^2 + 1148, [*x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 2*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^4 + 112, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 88*y^4 - 128*y^3 + 136*y^2 - 80*y + 586*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 - 648*x^6 + 119364*x^4 - 4432912*x^2 + 38525436, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 10*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^4 + 368, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 312*y^4 - 1024*y^3 + 1480*y^2 - 976*y + 336986*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 1944*x^6 + 1074276*x^4 + 119688624*x^2 + 3120560316, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 10*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^4 + 240, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 168*y^4 - 448*y^3 + 616*y^2 - 400*y + 36114*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 216*x^6 + 12564*x^4 + 71280*x^2 + 92988, [*x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 2*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 10*x^4 + 8*x^2 + 7, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 80*y^4 - 96*y^3 + 96*y^2 - 64*y + 26*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 10*x^4 + 8*x^2 + 7, [*x^4 + 6*x^2 + 10, x^4 + 6*x^2 + 10*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^4 + 60, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 196*y^6 - 1064*y^5 + 8516*y^4 - 27120*y^3 - 7256*y^2 + 66000*y + 4817150*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 4*x^4 + 60, [*x^4 - 2*x^2 + 2, x^4 - 2*x^2 + 2*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 40*x^4 + 240, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 1520*y^4 - 5856*y^3 + 8728*y^2 - 5808*y + 2666*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 - 2888*x^6 + 2094260*x^4 - 4182736*x^2 + 2079324, [*x^8 + 8*x^7 + 16*x^5 + 144*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^4 + 28, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 4*y^6 + 88*y^5 + 3052*y^4 - 12944*y^3 + 62056*y^2 - 97904*y + 722702*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 12*x^4 + 28, [*x^8 + 14*x^6 + 10*x^4 + 12*x^2 + 16*x + 4*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^4 + 28, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 100*y^6 - 488*y^5 + 1564*y^4 - 3152*y^3 - 23624*y^2 + 52336*y + 450118*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 4*x^4 + 28, [*x^8 + 10*x^6 + 10*x^4 + 4*x^2 + 4*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 40*x^4 + 368, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 1488*y^4 - 5728*y^3 + 8536*y^2 - 5680*y + 56642*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 16536*x^6 + 68660676*x^4 + 1387715760*x^2 + 1109108700, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 10*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^4 + 92, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 292*y^6 - 1640*y^5 + 21260*y^4 - 74256*y^3 + 216664*y^2 - 289104*y + 18468118*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 4*x^4 + 92, [*x^8 + 10*x^6 + 10*x^4 + 4*x^2 + 4*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^4 + 92, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 196*y^6 - 1064*y^5 + 6940*y^4 - 20816*y^3 - 666872*y^2 + 1372624*y + 12839646*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 12*x^4 + 92, [*x^8 + 14*x^6 + 10*x^4 + 12*x^2 + 16*x + 4*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^4 + 496, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 796*y^4 - 2960*y^3 + 4384*y^2 - 2912*y + 454598*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 8664*x^6 + 18848340*x^4 + 112933872*x^2 + 168425244, [*x^8 + 8*x^7 + 16*x^5 + 144*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^4 + 368, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 364*y^4 - 1232*y^3 + 1792*y^2 - 1184*y + 55518*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 - 5512*x^6 + 7628964*x^4 - 51396880*x^2 + 13692700, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 10*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 6*x^4 + 24*x^2 + 15, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 76*y^4 - 80*y^3 + 88*y^2 - 80*y + 46*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 - 288688*x^6 + 20837318532*x^4 - 195093701824*x^2 + 146221683004, [*x^8 + 8*x^6 + 36*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^6 + 30*x^4 + 8*x^2 + 7, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 460*y^4 - 656*y^3 + 576*y^2 - 288*y + 70*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 24*x^6 + 30*x^4 + 8*x^2 + 7, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^6 + 30*x^4 + 8*x^2 + 15, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 460*y^4 - 656*y^3 + 576*y^2 - 288*y + 78*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 24*x^6 + 30*x^4 + 8*x^2 + 15, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 20*x^4 + 8*x^2 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^5 + 20*y^4 + 8*y^2 + 14*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 1200*x^6 + 365076*x^4 + 2168640*x^2 + 3174876, [*x^8 + 16*x^2 + 36*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^6 + 2*x^4 + 31, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 432*y^4 - 544*y^3 + 400*y^2 - 160*y + 58*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 - 10608*x^6 + 29217924*x^4 - 5691442432*x^2 + 275436389916, [*x^8 + 16*x^2 + 36*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^2 + 10, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 8*y^5 + 8*y^2 + 10*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 1041187485565832*x^6 + 2787357027940203778*x^4 + 379250186823272392*x^2 + 5092453946484375, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 10, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^5 + 10*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 31824*x^6 + 262961316*x^4 + 153668945664*x^2 + 22310347583196, [*x^8 + 16*x^2 + 36*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 2, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 66451832329224*x^6 - 1080151829511306*x^4 + 379796874520*x^2 - 7419145273, [*x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 2*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 24*x^2 + 10, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 24*y^2 + 10*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 - 109520*x^6 + 2999003924*x^4 - 5997788800*x^2 + 2998438524, [*x^8 + 8*x^6 + 100*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 10, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 10*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 72105302264360*x^6 + 458282442319608550*x^4 + 1006692452990775000*x^2 + 471344437237109375, [*x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 2*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 16*x^6 + 8*x^4 + 368, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 13940*y^6 - 83528*y^5 + 393632*y^4 - 1017824*y^3 + 1659872*y^2 - 1506752*y + 972354*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 - 400*x^6 + 40564*x^4 - 80320*x^2 + 39196, [*x^8 + 16*x^2 + 36*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 48*x^2 + 40, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 158912*y^7 - 165476*y^6 - 181640*y^5 + 1275700*y^4 + 114384*y^3 - 1663640*y^2 + 70448*y + 804822*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], x^8 + 2192479750547663968019437373090658192024213644616028657038756179105118296047719756889192*x^6 + 3959098905324498472573378276824417670874483248237115528122960764721555360732724881707821344468*x^4 + 10843284784584088303641972836201471418249474591854752077122994982430841235590725668863812981808*x^2 + 2265554941747030380242121726784891479836464875278257958887204186987639249862540236950429254300, [*x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 2*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 8*x^2 + 10, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 8*y^2 + 10*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], x^8 + 328560*x^6 + 26991035316*x^4 + 161940297600*x^2 + 242873520444, [*x^8 + 8*x^6 + 100*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 16*x^3 + 24*x^2 + 16*x + 2, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 16*y^3 + 24*y^2 + 16*y + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 866064*x^6 + 187535866788*x^4 + 5267529949248*x^2 + 11843956323324, [*x^8 + 8*x^6 + 36*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^6 + 14*x^4 + 8*x^2 + 15, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 444*y^4 - 592*y^3 + 480*y^2 - 224*y + 62*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], x^8 + 24*x^6 + 14*x^4 + 8*x^2 + 15, [*x^8 + 4*x^7 + 10*x^4 + 12*x^2 + 10*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 16*x^2 + 2, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 16*y^2 + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], x^8 + 54768727870408*x^6 + 37524364901187240870*x^4 + 1440865665229036149864*x^2 + 18762396340391, [*x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 2*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 14, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^5 + 14*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 157152*x^6 + 6175528668*x^4 + 38080082016*x^2 + 59275435500, [*x^4 + 2*x^2 + 6, x^4 + 2*x^2 + 6*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 16*x^7 + 12*x^4 + 44, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 263952*y^7 - 1535068*y^6 + 3484664*y^5 - 2609656*y^4 - 3836560*y^3 + 10250752*y^2 - 8695360*y + 2683622*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 + 141832240999711066305791787421089878241820084347220156670341530962214529092126750316920864746143393895263272*x^6 + 471776113342959122623542423565993060787162014525038877806834060204360561283461894642621168002931732805117961140612*x^4 + 170068215123457218125853409219834864010378835859054056407617810632113803315563826419677955872225538811124243092964496272*x^2 + 155068709614390708566547525871240442602226553790038266202976750229458653890080557310879729042499987045527983060162335895468, [*x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 6*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^6 + 2*x^4 + 11, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 432*y^4 - 544*y^3 + 400*y^2 - 160*y + 38*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 - 96*x^6 + 3852*x^4 - 72544*x^2 + 559404, [*x^4 - 2*x^2 - 2, x^4 - 2*x^2 - 2*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 20*x^4 + 16*x^3 + 24*x^2 + 2, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 20*y^4 + 16*y^3 + 24*y^2 + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 + 121079715052936*x^6 + 805365662353436644274*x^4 + 84895932508179279389448*x^2 + 62499848359203, [*x^8 + 4*x^7 + 2*x^4 + 4*x^2 + 6*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 22*x^4 + 8*x^2 + 11, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 92*y^4 - 144*y^3 + 168*y^2 - 112*y + 42*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 - 52384*x^6 + 686169852*x^4 - 1410373408*x^2 + 731795500, [*x^4 + 2*x^2 + 6, x^4 + 2*x^2 + 6*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 24*x^4 + 14, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 24*y^4 + 14*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 + 2216090536224520*x^6 + 4349155154466210370047830*x^4 + 209470475023546411413368*x^2 + 1271373425839278643987, [*x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 14*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 16*x^7 + 60*x^4 + 44, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 + 66943824*y^7 + 733116172*y^6 - 4452180984*y^5 + 19816327780*y^4 - 50285330704*y^3 + 72588959016*y^2 - 56673268400*y + 20939468698*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 + 888791291717582794800777150487495062648999401552407243347918381568291144227239459348500119362819050100463244401254920659283481161024744*x^6 + 49130568441946887984427132729149764028342834756295469293685599493978667498342729363933910585012759913723513216052407721435613793550076866312777722868*x^4 + 420186099872575291199089817527903716356487376949406677869286144145861366500034198319181279430012744364255656856013791045915707657936188772354104540405200*x^2 + 527179320287771511136283888014627033389552173462171201052691895264902289655096682136515433276904355182130750121889970250963877479673288103240614462668012, [*x^8 + 4*x^7 + 10*x^4 + 4*x^2 + 14*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^6 + 18*x^4 + 11, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 448*y^4 - 608*y^3 + 496*y^2 - 224*y + 54*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 288*x^6 + 34668*x^4 + 1958688*x^2 + 45311724, [*x^4 - 2*x^2 - 2, x^4 - 2*x^2 - 2*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 8*x^2 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 8*y^2 + 6*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 + 288*x^6 + 33084*x^4 + 1739232*x^2 + 41203404, [*x^8 + 8*x^4 + 4*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 26*x^4 + 11, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 36*y^6 - 104*y^5 + 216*y^4 - 320*y^3 + 304*y^2 - 160*y + 46*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 - 52384*x^6 + 685874796*x^4 - 1409759968*x^2 + 641116108, [*x^8 + 24*x^4 + 36*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 6*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 148590654981368*x^6 + 40952935789989534*x^4 + 1765258477998552*x^2 + 767208125400579, [*x^8 + 24*x^4 + 784*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 10*x^4 + 11, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 36*y^6 - 104*y^5 + 200*y^4 - 256*y^3 + 208*y^2 - 96*y + 30*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 + 157152*x^6 + 6172873164*x^4 + 38063519136*x^2 + 51930404748, [*x^8 + 24*x^4 + 36*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^6 + 14*x^4 + 8*x^2 + 27, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 36*y^6 - 104*y^5 + 204*y^4 - 272*y^3 + 240*y^2 - 128*y + 58*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 8*x^6 + 14*x^4 + 8*x^2 + 27, [*x^8 + 24*x^4 + 272*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^7 + 48*x^2 + 88, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 256*y^7 + 36*y^6 - 264*y^5 + 432*y^4 - 3168*y^3 + 1728*y^2 + 2662*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 8532674620408902483981303962584812862981674485345368*x^6 + 3351221732218063576044854925978984182131369983971600012083004*x^4 + 1453286580501705303969259000059225335860255996953416215257519976496*x^2 + 546688348343740548643596126224569800837295837464945264992450146220, [*x^8 + 24*x^4 + 784*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^6 + 8*x^5 + 20*x^4 + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^5 + 20*y^4 + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 - 96*x^6 + 3676*x^4 - 64416*x^2 + 508684, [*x^8 + 8*x^4 + 4*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^6 + 8*x^5 + 14, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^5 + 14*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 160765144085272*x^6 + 1332455997743437070*x^4 + 22840538883335794712*x^2 + 103432660856280463099, [*x^8 + 24*x^4 + 272*], 29/8, 2*], [*2, 28, 8, 1, 8, x^8 + 20*x^4 + 44, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 - 260*y^6 + 1672*y^5 + 31472*y^4 - 137184*y^3 + 699232*y^2 - 1119552*y + 4631158*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 20*x^4 + 44, [*x^8 + 6*x^6 + 4*x^5 + 12*x^2 + 6*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^4 + 12, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 - 116*y^6 + 808*y^5 + 7168*y^4 - 34208*y^3 + 66448*y^2 - 62240*y + 88750*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 12*x^4 + 12, [*x^8 + 6*x^6 + 4*x^5 + 12*x^2 + 6*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^4 + 12, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 260*y^4 + 144*y^3 - 5816*y^2 + 10896*y + 32978*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 + 4*x^4 + 12, [*x^8 + 16*x^5 + 20*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 56*x^4 + 176, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 35204*y^4 - 140592*y^3 + 210832*y^2 - 140544*y + 196186*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 - 1768*x^6 + 776652*x^4 - 1688944*x^2 + 611308, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 6*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^4 + 48, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 72*y^4 - 64*y^3 + 40*y^2 - 16*y + 6*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 24*x^6 + 300*x^4 + 1808*x^2 + 4428, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 14*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 12*x^4 + 44, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 52*y^6 - 200*y^5 + 1828*y^4 - 6128*y^3 - 53000*y^2 + 117808*y + 1870818*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 + 12*x^4 + 44, [*x^8 + 16*x^5 + 20*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 4*x^4 + 44, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 148*y^6 - 776*y^5 + 4316*y^4 - 12240*y^3 - 31016*y^2 + 84528*y + 1831306*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 4*x^4 + 44, [*x^8 + 6*x^6 + 4*x^5 + 12*x^2 + 6*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 20*x^4 + 12, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 988*y^6 - 5816*y^5 + 614776*y^4 - 2420480*y^3 + 4563856*y^2 - 4302176*y + 3388126*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 + 20*x^4 + 12, [*x^8 + 16*x^5 + 84*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 28*x^4 + 12, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 3476*y^6 - 20744*y^5 + 13574108*y^4 - 54158288*y^3 + 98603560*y^2 - 88945776*y + 48151746*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 + 28*x^4 + 12, [*x^8 + 6*x^6 + 4*x^5 + 12*x^2 + 6*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 72*x^4 + 176, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 185032*y^4 - 739904*y^3 + 1109800*y^2 - 739856*y + 1103694*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 - 1768*x^6 + 786588*x^4 - 1711408*x^2 + 959500, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 14*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 56*x^4 + 48, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 17472288*y^4 - 69888928*y^3 + 104833336*y^2 - 69888880*y + 17489094*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 - 72*x^6 + 2844*x^4 - 71280*x^2 + 744876, [*x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 6*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 24*x^4 + 176, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 76*y^4 - 80*y^3 + 64*y^2 - 32*y + 18*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], x^8 - 72*x^6 + 2700*x^4 - 48816*x^2 + 358668, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 14*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 28*x^4 + 44, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 - 764*y^6 + 4696*y^5 + 170052*y^4 - 711664*y^3 + 3114232*y^2 - 4792528*y + 9959114*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 + 28*x^4 + 44, [*x^8 + 16*x^5 + 84*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 40*x^4 + 176, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 2448*y^4 - 9568*y^3 + 14296*y^2 - 9520*y + 9254*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], x^8 + 24*x^6 + 316*x^4 + 2640*x^2 + 9196, [*x^8 + 4*x^7 + 6*x^4 + 12*x^2 + 6*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 8*x^4 + 176, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 120*y^4 - 256*y^3 + 328*y^2 - 208*y + 6926*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], x^8 + 5304*x^6 + 7079292*x^4 + 46208016*x^2 + 77719500, [*x^8 + 4*x^7 + 6*x^4 + 4*x^2 + 14*], 59/16, 2*], [*2, 28, 8, 1, 8, x^8 + 104*x^4 + 48, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 15*]*], [*2, 2, 3, 7/2, 9/2*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 28*y^6 - 56*y^5 + 1662366708*y^4 - 6649466608*y^3 + 9974199856*y^2 - 6649466560*y + 1662761946*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], x^8 + 5304*x^6 + 6989868*x^4 + 45601488*x^2 + 49515948, [*x^8 + 4*x^7 + 14*x^4 + 12*x^2 + 6*], 59/16, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 16*x^5 + 8*x^2 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 16*y^5 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 8*x^4 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 8*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 8*x^4 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 8*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 8*x^2 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 8*x^2 + 16*x + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 8*y^2 + 16*y + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 8*x^2 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 8*x^2 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 8*x^4 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 8*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 28*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 28*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 12*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 12*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 16*y + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 20*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 20*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 20*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 20*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 22*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 4*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 4*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 28*x^6 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 28*y^6 + 22*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 20*x^4 + 16*x^3 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 20*y^4 + 16*y^3 + 16*y + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 16*x + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 16*y + 22*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 28*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 28*y^6 + 6*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 12*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 12*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 20*x^6 + 16*x^5 + 8*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 20*y^6 + 16*y^5 + 8*y^2 + 6*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 28*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 28*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 4*x^4 + 16*x + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 4*y^4 + 16*y + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 24*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 16*x^5 + 28*x^4 + 6, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 16*y^5 + 28*y^4 + 6*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 24*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 24*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 24*x^4 + 16*x^2 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 24*y^4 + 16*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^6 + 80*x^2 + 104, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 188*y^6 + 2448*y^4 + 12056*y^2 + 4394*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 8*x^2 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 8*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 8*x^2 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 8*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 24*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 8*x^4 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 8*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 8*x^4 + 16*x^2 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 8*y^4 + 16*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 24*x^4 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 24*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 16*x^3 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 16*y^3 + 30*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 24*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 24*y^4 + 30*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 41*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 16*x^5 + 16*x^3 + 8*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 16*y^5 + 16*y^3 + 8*y^2 + 14*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 4*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 16*x^3 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 16*y^3 + 14*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 14*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 41*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 20*x^4 + 16*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 20*y^4 + 16*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 41*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 28*x^6 + 24*x^4 + 16*x^3 + 8*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 28*y^6 + 24*y^4 + 16*y^3 + 8*y^2 + 14*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 20*x^6 + 16*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 20*y^6 + 16*y^2 + 14*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 20*x^4 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 20*y^4 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 4*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 56*x^4 + 16*x^2 + 104, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 9932*y^4 - 4304*y^2 + 4394*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 20*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 20*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 12*x^6 + 54*x^4 + 108*x^2 + 41*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 4*x^4 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 4*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 4*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 4*x^4 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 4*x^4 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 4*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 20*x^4 + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 20*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^4 + 80*x^2 + 120, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 60*y^6 + 1052*y^4 + 4400*y^2 + 6750*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^2 + 2, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^2 + 2*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 28*x^4 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 28*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 16*x^4 + 16*x^2 + 18, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 16*y^4 + 16*y^2 + 18*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 12*x^6 + 18, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^6 + 18*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 16*x^3 + 16*x + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 16*y^3 + 16*y + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 4*x^4 + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 4*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 28*x^4 + 16*x + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 28*y^4 + 16*y + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 12*x^4 + 16*x^3 + 16*x^2 + 16*x + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 12*y^4 + 16*y^3 + 16*y^2 + 16*y + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 6*x^2 - 9*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 20*x^6 + 18, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 20*y^6 + 18*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 2*x^2 - 1*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 16*x^2 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 48*y^4 + 64*y^2 + 686*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 16*x^5 + 16*x^4 + 8*x^2 + 16*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 16*y^5 + 16*y^4 + 8*y^2 + 16*y + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 32*x^5 + 88*x^4 + 48, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 112*y^7 + 19276*y^6 - 623504*y^5 + 5872528*y^4 - 13893296*y^3 + 14097016*y^2 - 6699920*y + 1247470*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 8*x^4 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 8*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 24*x^4 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 24*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 8*x^2 + 16*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^2 + 16*y + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 20*x^4 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 20*y^4 + 26*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 16*x^5 + 8*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 16*y^5 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 8*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 - 6*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 20*x^6 + 8*x^2 + 10, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 20*y^6 + 8*y^2 + 10*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 8*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 28*x^4 + 16*x + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 28*y^4 + 16*y + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 8*x^2 + 10, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 8*y^2 + 10*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 8*x^2 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 8*y^2 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 4*y^4 + 16*y + 2*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 28*x^4 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 28*y^4 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 12*x^4 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 12*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 8*x^2 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 24*x^4 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 24*y^4 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 32*x^5 + 88*x^4 + 432, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 24*y^7 + 236*y^6 - 1168*y^5 + 2004*y^4 + 5184*y^3 + 28536*y^2 + 14064*y + 2322*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 8*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 8*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 16*x^2 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 16*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 8*x^2 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 4*x^6 + 10, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^6 + 10*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 16*x^5 + 12*x^4 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 16*y^5 + 12*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 30*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 20*y^6 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 12*x^4 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 12*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 8*x^7 + 28*x^6 + 16*x^5 + 20*x^4 + 24*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 28*y^6 + 16*y^5 + 20*y^4 + 24*y^2 + 18*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 20*x^6 + 4*x^4 + 8*x^2 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 20*y^6 + 4*y^4 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 8*x^2 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 4*x^4 + 16*x^2 + 16*x + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 4*y^4 + 16*y^2 + 16*y + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 20*x^4 + 8*x^2 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 28*y^6 + 20*y^4 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 8*x^2 + 26*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 8*x^2 + 16*x + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 4*y^6 + 8*y^2 + 16*y + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 - 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 16*x^5 + 4*x^4 + 16*x + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 16*y^5 + 4*y^4 + 16*y + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 12*y^6 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 4*x^6 + 16*x^5 + 12*x^4 + 16*x^2 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 4*y^6 + 16*y^5 + 12*y^4 + 16*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*x^2 - 1*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 12*x^6 + 4*x^4 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 12*y^6 + 4*y^4 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 2*x^2 - 9*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 14*], 137/32, 2*], [*2, 29, 8, 1, 8, x^8 + 28*x^6 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 28*y^6 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*x^2 + 3*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 10*x^4 + 20*x^2 + 23, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 500*y^4 - 656*y^3 + 528*y^2 - 256*y + 82*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^3 + 16*x + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^3 + 16*y + 30*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 18*x^4 + 20*x^2 + 23, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 268*y^4 - 368*y^3 + 336*y^2 - 192*y + 74*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 8*x^2 + 30, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 8*y^2 + 30*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 16*x^5 + 8*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 16*y^5 + 8*y^2 + 14*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 14*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 4*x^4 + 26, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^4 + 26*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 8*x^2 + 6, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 8*y^2 + 6*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 16*x^7 + 16*x^5 + 56, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 2072*y^7 + 192*y^6 + 176*y^5 - 2688*y^4 + 686*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 10*x^4 + 4*x^2 + 15, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 260*y^4 - 336*y^3 + 272*y^2 - 128*y + 42*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 6*x^4 + 4*x^2 + 31, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 496*y^4 - 640*y^3 + 488*y^2 - 208*y + 70*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 30*x^4 + 4*x^2 + 7, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 280*y^4 - 416*y^3 + 392*y^2 - 208*y + 54*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 6*x^4 + 28*x^2 + 31, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 496*y^4 - 640*y^3 + 512*y^2 - 256*y + 94*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^2 + 22, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^2 + 22*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 6*x^4 + 20*x^2 + 23, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 496*y^4 - 640*y^3 + 504*y^2 - 240*y + 78*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 4*x^4 + 10, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 4*y^4 + 10*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 60, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 136*y^6 - 704*y^5 + 5296*y^4 - 16640*y^3 + 69904*y^2 - 108320*y + 235150*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 12*x^4 + 2, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^4 + 2*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^4 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^4 + 14*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 12*x^4 + 26, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^4 + 26*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 30*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 20*x^4 + 8*x^2 + 16*x + 2, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 20*y^4 + 8*y^2 + 16*y + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 24*x^4 + 16*x^2 + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 24*y^4 + 16*y^2 + 30*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y + 30*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 8*x^2 + 22, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 8*y^2 + 22*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 6*x^4 + 20*x^2 + 31, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 256*y^4 - 320*y^3 + 264*y^2 - 144*y + 70*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^3 + 8*x^2 + 6, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^3 + 8*y^2 + 6*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 26*x^4 + 4*x^2 + 7, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 276*y^4 - 400*y^3 + 368*y^2 - 192*y + 50*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^2 + 16*x + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 24*y^2 + 16*y + 14*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 4*x^4 + 16*x^3 + 24*x^2 + 18, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 4*y^4 + 16*y^3 + 24*y^2 + 18*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^4 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^4 + 14*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 14*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 12*x^4 + 10, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 12*y^4 + 10*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^2 + 30, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^2 + 30*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 20*x^6 + 14*x^4 + 4*x^2 + 23, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 48*y^6 - 176*y^5 + 384*y^4 - 512*y^3 + 416*y^2 - 192*y + 62*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^4 + 14, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 24*y^4 + 14*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 28*x^4 + 10, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 28*y^4 + 10*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 16*x^5 + 8*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 16*y^5 + 8*y^2 + 14*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 24*x^2 + 16*x + 30, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 24*y^2 + 16*y + 30*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 4*x^4 + 18, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 4*y^4 + 18*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^4 + 8*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^4 + 8*y^2 + 14*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^4 + 8*x^2 + 22, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^4 + 8*y^2 + 22*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 28*x^4 + 26, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 28*y^4 + 26*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^2 + 14*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 24*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 28*x^4 + 2, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 28*y^4 + 2*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 20*x^4 + 2, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 20*y^4 + 2*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 26*x^4 + 20*x^2 + 7, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 516*y^4 - 720*y^3 + 624*y^2 - 320*y + 82*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 16*x + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 16*x^4 + 30, [*64, "t", [*8, 30*]*], 64, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 16*y^4 + 30*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 14*x^4 + 8*x^3 + 26*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y + 6*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 22*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 6*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 16*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 22*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 10*x^4 + 8*x^3 + 16*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 6*x^4 + 12*x^2 + 7, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 256*y^4 - 320*y^3 + 256*y^2 - 128*y + 38*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y + 22*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 4*x^6 + 14*x^4 + 20*x^2 + 31, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 32*y^6 - 80*y^5 + 144*y^4 - 192*y^3 + 192*y^2 - 128*y + 70*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 16*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 22*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^2 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 16*y^2 + 22*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 10*x^4 + 8*x^3 + 16*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 22*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 10*x^4 + 8*x^3 + 16*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 16*x^6 + 16*x^5 + 88, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 24*y^7 + 1216*y^6 + 512*y^5 + 4224*y^4 + 5808*y^2 + 2662*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 16*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 16*x^5 + 32*x^4 + 24, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 24*y^7 + 368*y^6 + 192*y^5 + 1688*y^4 + 1056*y^3 + 2592*y^2 + 2064*y + 438*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 10*x^4 + 8*x^3 + 16*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^4 + 22, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^4 + 22*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 22*x^4 + 28*x^2 + 23, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 512*y^4 - 704*y^3 + 608*y^2 - 320*y + 102*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 10*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^4 + 6, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 + 8*y^7 + 8*y^4 + 6*], 0, [*-1, 0*], 3/2, 0, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 2*x^4 + 8*x^3 + 24*x^2 + 18*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 20*x^6 + 14*x^4 + 4*x^2 + 31, [*64, "t", [*8, 30*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 1*], [*t + 1, y^8 - 8*y^7 + 48*y^6 - 176*y^5 + 384*y^4 - 512*y^3 + 416*y^2 - 192*y + 70*], 0, [*-1, 0*], 3/2, 0, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 6*x^4 + 8*x^3 + 16*x^2 + 2*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 10*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 14*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^6 + 60*x^4 + 108, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 2848*y^6 - 16976*y^5 + 2068324*y^4 - 8160272*y^3 + 17726680*y^2 - 19178000*y + 11476750*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^5 + 6*x^4 + 8*x^3 + 30*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^3 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^3 + 18*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 18*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 16*x^5 + 16*x^3 + 24*x^2 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 16*y^5 + 16*y^3 + 24*y^2 + 16*y + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 16*x^5 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 16*y^5 + 16*y + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 16*x^5 + 16*x + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 16*y^5 + 16*y + 18*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 24*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 16*x^4 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 16*y^4 + 18*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 26*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 10*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 6*x^4 + 20*x^2 + 3, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 256*y^4 - 320*y^3 + 264*y^2 - 144*y + 42*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 4*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 4*y^4 + 6*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 16*x^2 + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 6*x^4 + 4*x^2 + 3, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 496*y^4 - 640*y^3 + 488*y^2 - 208*y + 42*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^2 + 18*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 40*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 16*x^5 + 12*x^4 + 16*x^2 + 16*x + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 16*y^5 + 12*y^4 + 16*y^2 + 16*y + 14*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 28*x^6 + 22*x^4 + 4*x^2 + 19, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 56*y^6 - 224*y^5 + 512*y^4 - 704*y^3 + 584*y^2 - 272*y + 74*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 16*x^3 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 16*y^3 + 26*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^5 + 6*x^4 + 8*x^3 + 30*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 16*x^2 + 16*x + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 16*y^2 + 16*y + 26*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^5 + 6*x^4 + 8*x^3 + 30*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^2 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^2 + 26*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 14*x^4 + 8*x^3 + 24*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 28*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 28*y^4 + 6*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 16*x^2 + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 16*x^5 + 24*x^4 + 88, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 24*y^7 + 192*y^6 + 512*y^5 + 468*y^4 - 3168*y^3 + 2662*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^4 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^4 + 10*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^3 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^3 + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 4*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^4 + 30*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 12*x^4 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^4 + 14*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 10*x^4 + 8*x^3 + 8*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 18*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 10*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 14*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 12, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 9960*y^6 - 59648*y^5 + 198200*y^4 - 395296*y^3 + 526408*y^2 - 421200*y + 188458*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 14*x^4 + 8*x^3 + 24*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 4*x^4 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^4 + 6*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 20*x^4 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 20*y^4 + 22*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 16*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 16*y^2 + 10*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 14*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^3 + 16*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^3 + 16*y^2 + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 20*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 20*y^4 + 30*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 10*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^4 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^4 + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 24*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 12*x^4 + 8*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 12*y^4 + 8*y^2 + 6*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 24*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 4*x^4 + 16*x + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 4*y^4 + 16*y + 6*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 12*x^4 + 16*x^3 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 12*y^4 + 16*y^3 + 14*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 10*x^4 + 8*x^3 + 8*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 4*x^4 + 16*x + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 4*y^4 + 16*y + 22*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 16*x^2 + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 26*x^4 + 4*x^2 + 3, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 276*y^4 - 400*y^3 + 368*y^2 - 192*y + 46*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 10*x^4 + 8*x^3 + 8*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 20*x^6 + 18*x^4 + 12*x^2 + 3, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 48*y^6 - 176*y^5 + 388*y^4 - 528*y^3 + 448*y^2 - 224*y + 54*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 4*x^6 + 18*x^4 + 28*x^2 + 3, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 32*y^6 - 80*y^5 + 148*y^4 - 208*y^3 + 224*y^2 - 160*y + 54*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 16*x + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^3 + 8*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^3 + 8*y^2 + 18*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 40*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 4*x^4 + 16*x^3 + 16*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 4*y^4 + 16*y^3 + 16*y^2 + 30*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 22*x^4 + 12*x^2 + 19, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 272*y^4 - 384*y^3 + 352*y^2 - 192*y + 66*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 4*x^6 + 26*x^4 + 12*x^2 + 11, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 32*y^6 - 80*y^5 + 156*y^4 - 240*y^3 + 256*y^2 - 160*y + 54*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 40*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 4*x^6 + 10*x^4 + 12*x^2 + 3, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 32*y^6 - 80*y^5 + 140*y^4 - 176*y^3 + 160*y^2 - 96*y + 30*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 14*x^4 + 8*x^3 + 24*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^6 + 16*x^2 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^6 + 16*y^2 + 16*y + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^2 + 10*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^2 + 2*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 2*x^4 + 8*x^3 + 16*x^2 + 6*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 12*x^6 + 22*x^4 + 20*x^2 + 19, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 40*y^6 - 128*y^5 + 272*y^4 - 384*y^3 + 360*y^2 - 208*y + 74*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 32*x^2 + 272*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 24*x^6 + 24*x^2 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 24*y^6 + 24*y^2 + 16*y + 2*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 4*x^6 + 10*x^4 + 8*x^3 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^6 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^6 + 26*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^5 + 6*x^4 + 8*x^3 + 30*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 12*x^4 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^4 + 22*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 40*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 12*x^4 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 12*y^4 + 30*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 14*x^4 + 8*x^3 + 24*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 56*x^6 + 60*x^4 + 44, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 91125819984*y^6 - 546754919792*y^5 + 2654640569464*y^4 - 6973529479392*y^3 + 12719974063936*y^2 - 12950902288448*y + 8334289469786*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 2*x^4 + 8*x^3 + 14*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y + 18*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 24*x^6 + 144*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 16*x^5 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 16*y^5 + 26*], 0, [*-1, 1*], 3/2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 8*y^2 + 10*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 10*x^4 + 8*x^3 + 8*x^2 + 22*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 20*x^6 + 14*x^4 + 4*x^2 + 19, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 - 8*y^7 + 48*y^6 - 176*y^5 + 384*y^4 - 512*y^3 + 416*y^2 - 192*y + 58*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 30, 8, 1, 8, x^8 + 8*x^7 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 30*]*], [*2, 3, 7/2, 4, 17/4, 19/4*], [*1, 2*], [*t + 1, y^8 + 8*y^7 + 26*], 0, [*-1, 1*], 3/2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^6 + 16*], 137/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 16*x^2 + 50, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 16*y^2 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 4*x^4 + 16*x^2 + 34, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 4*y^4 + 16*y^2 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 16*x^2 + 18, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 16*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 24*x^4 + 8*x^2 + 16*x + 46, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^4 + 8*y^2 + 16*y + 46*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 16*x^2 + 34, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 16*y^2 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 16*x^7 + 28*x^4 + 16*x^3 + 2, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^7 + 28*y^4 + 16*y^3 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 16*x^3 + 50, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 28*y^4 + 16*y^3 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 4*x^4 + 16*x^2 + 2, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 4*y^4 + 16*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 18, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 12*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 2*x^4 + 16*x + 4*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 2, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 2*x^4 + 16*x + 4*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 28*x^4 + 18, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 28*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 2*x^4 + 16*x + 4*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 2, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 12*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 2*x^4 + 16*x + 4*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 18, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 18, [*x^4 + 14, x^4 + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 2, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 2, [*x^4 + 30, x^4 + 30*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 34, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 162, [*x^4 + 30, x^4 + 30*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 50, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 1458, [*x^4 + 14, x^4 + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 12*x^4 + 16*x^3 + 2, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^5 + 12*y^4 + 16*y^3 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 16*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 16*x^3 + 50, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 20*y^4 + 16*y^3 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 8*x^7 + 14*x^4 + 4*x^2 + 8*x + 30*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 16*x^5 + 28*x^4 + 50, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 16*y^5 + 28*y^4 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 8*x^7 + 14*x^4 + 4*x^2 + 8*x + 30*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 50, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 - 15*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 24*x^2 + 16*x + 14, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^5 + 24*y^2 + 16*y + 14*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 10*x^4 + 8*x^3 + 4*x^2 + 8*x + 14*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 2, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 16*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 16*x^3 + 34, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 16*y^3 + 34*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 10*x^4 + 8*x^3 + 4*x^2 + 8*x + 14*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 18, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 - 15*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 104976*x^4 + 34992*x^2 + 2754991602, [*x^8 + 14*x^4 + 8*x^3 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^2 + 50, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^2 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 11664*x^4 - 1296*x^2 + 34012242, [*x^8 + 14*x^4 + 8*x^3 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 18, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 16*x^4 - 16*x^2 + 66, [*x^8 + 14*x^4 + 8*x^3 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^2 + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 144*x^4 + 432*x^2 + 5346, [*x^8 + 14*x^4 + 8*x^3 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 50, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 18, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 34, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 2, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 34, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 34*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 18, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 30*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 50, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 30*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 2, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 16*x^3 + 50, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^5 + 16*y^3 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 1263384*x^6 + 597396073608*x^4 + 125304235556994000*x^2 + 9838293901681952997378, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 34, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 8*x^6 + 24*x^4 + 32*x^2 + 18, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^4 + 16*x^2 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^4 + 16*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 - 216*x^6 + 122472*x^4 + 3684062736*x^2 + 16069866014466, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^7 + 8*x^4 + 16*x^3 + 16*x^2 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^7 + 8*y^4 + 16*y^3 + 16*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 72*x^6 + 13608*x^4 - 136446768*x^2 + 198393407586, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 16*x^5 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 16*y^5 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 8*x^6 + 40*x^4 - 304*x^2 + 594, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 50, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 72*x^6 + 1944*x^4 + 23328*x^2 + 104994, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 - 216*x^6 + 17496*x^4 - 629856*x^2 + 8504514, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 16*x^2 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 16*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 - 72*x^6 + 1864*x^4 - 20080*x^2 + 76626, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^4 + 16*x^2 + 50, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^4 + 16*y^2 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 - 24*x^6 + 360*x^4 + 8208*x^2 + 48114, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 34, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^3 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 24*x^6 + 504*x^4 + 4320*x^2 + 188082, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 + 3672*x^6 + 5266296*x^4 + 3479954400*x^2 + 5206633841728962, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 2, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 - 24*x^6 + 216*x^4 - 864*x^2 + 1458, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 16*x^3 + 8*x^2 + 16*x + 6, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 16*y^3 + 8*y^2 + 16*y + 6*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 + 216*x^6 + 16776*x^4 + 542160*x^2 + 6206706, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 34, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], x^8 - 8*x^6 + 56*x^4 - 160*x^2 + 2322, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 8*x^3 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^7 + 8*x^6 + 16*x^2 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^7 + 8*y^6 + 16*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 - 421128*x^6 + 66377341512*x^4 - 4640897613222000*x^2 + 121460418539283370338, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 2*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 18, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^3 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], x^8 - 1224*x^6 + 585144*x^4 - 128887200*x^2 + 64279430144802, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 18*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 24*x^2 + 50, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 28*y^4 + 24*y^2 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 24*x^2 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 28*y^4 + 24*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 20*x^4 + 8*x^2 + 50, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 20*y^4 + 8*y^2 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 8*x^2 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 8*x^2 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 24*x^2 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 24*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 20*x^4 + 8*x^2 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 20*y^4 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 16*x + 14, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^3 + 16*y + 14*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 14, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y + 14*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 8*x^2 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^7 + 16*x^5 + 56*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 62, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y + 62*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 20*x^4 + 8*x^2 + 50, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 20*y^4 + 8*y^2 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 24*x^2 + 2, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 24*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], 0, [*x^8 + 8*x^5 + 16*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 16*x + 62, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^6 + 16*y + 62*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 32*x^5 + 480, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 48*y^7 + 4200*y^6 + 136000*y^5 + 1059000*y^4 + 4014000*y^3 + 576000*y^2 - 9450000*y + 8268750*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 20*x^4 + 8*x^2 + 18, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 20*y^4 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 16*x^5 + 16*x^3 + 8*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 16*y^5 + 16*y^3 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 8*x^4 + 8*x^2 + 34, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^6 + 8*y^4 + 8*y^2 + 34*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 34, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 24*x^2 + 34, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 24*y^2 + 34*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 50, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 50*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 18*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 24*x^2 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 18*], 0, [*2, 0*], 2, 0, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 2*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 72, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 3456*y^6 + 7776*y^4 + 5832*y^2 + 1458*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 24*x^2 + 16*x + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 34, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 34*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 24*x^2 + 50, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 24*y^2 + 50*], 0, [*2, 0*], 2, 0, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], 0, [*x^8 + 60*x^4 + 96*x^2 + 100*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 10, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 26, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 12*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 32*x^3 + 24, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 256*y^7 + 22464*y^6 - 2896*y^5 + 31220*y^4 + 24464*y^3 + 4896*y^2 - 54*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 42, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 12*y^4 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 26, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 42, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 58, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 12*y^4 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 58, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], 8, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, -1, 31/8, 8*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 4*x^4 + 16*x^2 + 10, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 4*y^4 + 16*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x^3 + 24*x^2 + 36*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 20*x^4 + 16*x^2 + 26, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 20*y^4 + 16*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x^3 + 24*x^2 + 36*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 16*x^3 + 10, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 16*y^3 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x^3 + 24*x^2 + 36*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 20*x^4 + 16*x^2 + 26, [*16, "t", [*8, 7*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 20*y^4 + 16*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 4*x^6 + 6*x^4 + 16*x^3 + 24*x^2 + 36*], 31/8, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 10, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 35152*x^4 - 2704*x^2 + 308915802, [*x^8 + 52*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 58, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 2000*x^4 - 400*x^2 + 1000010, [*x^8 + 44*x^4 + 100*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 26, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 18000*x^4 + 10800*x^2 + 81000810, [*x^8 + 44*x^4 + 100*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^4 + 10, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 316368*x^4 + 73008*x^2 + 25022179962, [*x^8 + 52*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 24*x^2 + 16*x + 6, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^5 + 24*y^2 + 16*y + 6*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 2*x^4 + 12*x^2 + 8*x + 26*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 20*x^4 + 58, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 20*y^4 + 58*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 14*x^4 + 4*x^2 + 8*x + 22*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 16*x^3 + 42, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 16*y^3 + 42*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 28*x^4 + 36*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 32*x^3 + 152, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 3456*y^6 + 6912*y^5 + 21024*y^4 + 22912*y^3 + 33288*y^2 + 17328*y + 13718*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 28*x^4 + 36*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 16*x^2 + 58, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 12*y^4 + 16*y^2 + 58*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 2*x^4 + 12*x^2 + 8*x + 26*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 20*x^4 + 42, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 20*y^4 + 42*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 14*x^4 + 4*x^2 + 8*x + 6*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 10, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 14*x^4 + 4*x^2 + 8*x + 6*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 20*x^4 + 26, [*16, "t", [*8, 7*]*], 16, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 20*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 14*x^4 + 4*x^2 + 8*x + 22*], 4, 4*], [*2, 31, 8, 1, 8, x^8 + 10, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 10, [*x^8 + 10*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 26, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 26, [*x^8 + 10*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 42, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 810, [*x^8 + 10*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 58, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 2106, [*x^8 + 10*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 42, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 58, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 58*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 6*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 58, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 10, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 42, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 42*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 10, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 26, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 26, [*32, "t", [*8, 16*]*], 32, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 6*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 - 360*x^6 + 52600*x^4 - 3636000*x^2 + 100100010010, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 16*x^5 + 58, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 16*y^5 + 58*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 104*x^6 + 39208*x^4 - 1237423408*x^2 + 5429813051754, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 6*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^4 + 16*x^2 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^4 + 16*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 - 312*x^6 + 352872*x^4 + 33410432016*x^2 + 439814857192074, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 6*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 104*x^6 + 4056*x^4 + 70304*x^2 + 457002, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 58, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^3 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 7800*x^6 + 23447736*x^4 + 32127170400*x^2 + 297314818475257674, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 16*x^3 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^5 + 16*y^3 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 - 1830504*x^6 + 1255341303112*x^4 - 382260386992188016*x^2 + 43611227728285204900458, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 6*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 8*x^4 + 16*x^2 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 8*y^4 + 16*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 + 5491512*x^6 + 11298071728008*x^4 + 10321030448789076432*x^2 + 3532509445991101596937098, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 6*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 58, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 - 312*x^6 + 36504*x^4 - 1898208*x^2 + 37017162, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 8*x^4 + 16*x^2 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 8*y^4 + 16*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 - 40360*x^6 + 607254600*x^4 - 4036731276400*x^2 + 10010101101010010, [*x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 22*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^4 + 16*x^2 + 58, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^4 + 16*y^2 + 58*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 - 120*x^6 + 23400*x^4 + 108982800*x^2 + 81081810810, [*x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 22*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 10, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 40*x^6 + 600*x^4 + 4000*x^2 + 10010, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 42, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 1080*x^6 + 473400*x^4 + 98172000*x^2 + 8108100810810, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 42, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 - 120*x^6 + 5400*x^4 - 108000*x^2 + 810810, [*x^8 + 4*x^6 + 8*x^5 + 8*x^4 + 8*x^3 + 26*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 16*x^2 + 42, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 16*y^2 + 42*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 40*x^6 + 2600*x^4 - 4036400*x^2 + 1001010010, [*x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 22*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^7 + 96*x^2 + 232, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 2048*y^7 + 72*y^6 - 1392*y^5 + 1728*y^4 - 33408*y^3 + 13824*y^2 + 48778*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], x^8 + 121080*x^6 + 5465291400*x^4 + 108991744462800*x^2 + 810818189181810810, [*x^8 + 8*x^7 + 12*x^6 + 12*x^4 + 8*x^3 + 22*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 26, [*32, "t", [*8, 17*]*], 32, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^3 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], x^8 - 2600*x^6 + 2605304*x^4 - 1189895200*x^2 + 3670553314509354, [*x^8 + 8*x^7 + 4*x^6 + 8*x^3 + 8*x^2 + 10*], 67/16, 4*], [*2, 31, 8, 1, 8, x^8 + 32*x^3 + 216, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 1024*y^3 + 10368*y^2 + 34992*y + 39366*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 24*x^2 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 24*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 54, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y + 54*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 8*x^2 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 24*x^2 + 10, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 24*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 4*x^4 + 8*x^2 + 58, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 4*y^4 + 8*y^2 + 58*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 40*x^4 + 40, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 - 112*y^6 + 4180*y^4 + 600*y^2 + 250*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 4*x^4 + 8*x^2 + 42, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 4*y^4 + 8*y^2 + 42*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 8*x^2 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 4*y^4 + 8*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 16*x + 22, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 16*y + 22*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 4*x^4 + 8*x^2 + 26, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 4*y^4 + 8*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^2 + 16*x + 22, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^2 + 16*y + 22*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 16*x + 54, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^3 + 16*y + 54*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 38, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y + 38*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 24*x^2 + 42, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 12*y^4 + 24*y^2 + 42*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 22, [*64, "t", [*8, 28*]*], 64, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y + 22*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 42, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 108*x^6 + 6*x^4 + 44*x^2 + 121*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 58, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 58*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 16*x^6 + 44*x^4 + 196*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 16*x^6 + 44*x^4 + 196*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 26*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 16*x^4 + 168, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 32*y^6 + 1768*y^4 + 10584*y^2 + 18522*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 16*x + 62, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 16*y + 62*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 58, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 58*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 40, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 3456*y^6 + 4320*y^4 + 1800*y^2 + 250*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 16*x^6 + 44*x^4 + 196*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 108*x^6 + 6*x^4 + 44*x^2 + 121*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 24*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 24*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 108*x^6 + 6*x^4 + 44*x^2 + 121*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 104, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 221488*y^6 + 6727344*y^4 + 70253144*y^2 + 244568714*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 108*x^6 + 6*x^4 + 44*x^2 + 121*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 8*x^2 + 42, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 8*y^2 + 42*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 10*], 0, [*2, 1*], 2, 1, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 26*], 0, [*2, 1*], 2, 1, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], 0, [*x^8 + 16*x^6 + 44*x^4 + 196*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 16*x^3 + 14, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 16*y^3 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 24*x^6 + 540*x^4 + 4592*x^2 + 36974, [*x^4 + 12*x^2 + 6, x^4 + 12*x^2 + 6*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 14, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 2164072*x^6 + 1173604918804*x^4 + 194792790192896*x^2 + 25198916385819870, [*x^8 + 12*x^6 + 10*x^4 + 8*x^2 + 36*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 16*x^2 + 14, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 16*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 520*x^6 + 450364*x^4 - 1016178800*x^2 + 3898106740654, [*x^4 + 12*x^2 + 6, x^4 + 12*x^2 + 6*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 24*x^2 + 16*x + 26, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^5 + 24*y^2 + 16*y + 26*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 7224*x^6 + 14596052*x^4 + 820864*x^2 + 2176634430, [*x^8 + 12*x^6 + 10*x^4 + 8*x^2 + 36*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 46, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 46*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 1134, [*x^8 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 18*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 30, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 486000*x^4 + 97200*x^2 + 59049002430, [*x^4 + 2, x^4 + 2*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 46, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 46*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 5488*x^4 - 784*x^2 + 7529550, [*x^4 + 18, x^4 + 18*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 62, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 62*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 2430, [*x^8 + 12*x^6 + 6*x^4 + 4*x^2 + 8*x + 2*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 62, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 62*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 54000*x^4 - 3600*x^2 + 729000030, [*x^4 + 2, x^4 + 2*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 30, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 30, [*x^8 + 12*x^6 + 6*x^4 + 4*x^2 + 8*x + 2*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 14, [*16, "t", [*8, 8*]*], 16, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 14, [*x^8 + 2*x^4 + 8*x^3 + 12*x^2 + 8*x + 18*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 14, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 49392*x^4 + 21168*x^2 + 609893550, [*x^4 + 18, x^4 + 18*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 28*x^4 + 14, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 28*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 - 184*x^6 - 255028*x^4 + 22984864*x^2 + 19902697486, [*x^8 + 16*x^4 + 16*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 28*x^4 + 14, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 28*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 30968*x^6 + 3196473708*x^4 + 43416872616768*x^2 + 2098307979319901006, [*x^8 + 16*x^4 + 16*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 24*x^2 + 16*x + 10, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^6 + 24*y^2 + 16*y + 10*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 40*x^6 + 4436*x^4 - 17552*x^2 + 19710, [*x^8 + 4*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 20*x^4 + 16*x^2 + 14, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 20*y^4 + 16*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 1688*x^6 + 369771668*x^4 - 10306563088*x^2 + 228182847390, [*x^8 + 4*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 2256*x^6 + 1305612*x^4 + 36585216*x^2 + 268352190, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 - 728*x^6 + 209720*x^4 - 28109536*x^2 + 4051040997150, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^4 + 16*x^2 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^4 + 16*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 - 3243480*x^6 + 3942242303400*x^4 - 2128052310399975600*x^2 + 430483170965039829810030, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^7 + 16*x^6 + 16*x^3 + 16*x^2 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^7 + 16*y^6 + 16*y^3 + 16*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 56*x^6 + 6664*x^4 - 30261616*x^2 + 20668614750, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 18*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 20*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 624*x^6 + 146772*x^4 + 15419376*x^2 + 610419726, [*x^8 + 12*x^6 + 4*x^4 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 + 56*x^6 + 1176*x^4 + 10976*x^2 + 38430, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 - 208*x^6 + 16308*x^4 - 571088*x^2 + 7536046, [*x^8 + 12*x^6 + 4*x^4 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^3 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 - 3480*x^6 + 4649400*x^4 - 2821932000*x^2 + 17715356100810030, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 46, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 20*y^4 + 46*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 4*x^4 + 14, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 18*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 44*x^4 - 16*x^2 + 30, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 28*y^4 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 + 396*x^4 + 432*x^2 + 2430, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 20*y^4 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 4*x^2 + 14*]*]*], x^8 + 36*x^4 + 1134, [*x^8 + 8*x^7 + 4*x^6 + 4*x^4 + 8*x^3 + 18*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^4 + 16*x^2 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^4 + 16*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 14*]*]*], x^8 - 154392*x^6 + 8910883240*x^4 - 227861073287344*x^2 + 2178751124292198750, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 18*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 30, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 28*y^4 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 8*x + 10*]*]*], x^8 - 752*x^6 + 145068*x^4 - 1355008*x^2 + 3312990, [*x^8 + 8*x^7 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 8*x^4 + 16*x^2 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 8*y^4 + 16*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 120*x^6 + 59400*x^4 - 2919135600*x^2 + 19683729810030, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 2*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 14, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 30*]*]*], x^8 + 120*x^6 + 5400*x^4 + 108000*x^2 + 810030, [*x^8 + 8*x^7 + 12*x^6 + 8*x^5 + 8*x^3 + 22*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 30, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 16*x + 2, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 28*y^4 + 16*y + 2*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 30, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 46, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^2 + 46*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 30, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 62, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 62*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 8*x^2 + 46, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 8*y^2 + 46*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 62, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 62*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 46, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 46*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 62, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 62*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 22*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 14, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 12*x^2 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 62, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^2 + 62*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 4*x^2 + 18*]*]*], 0, [*x^8 + 8*x^5 + 4*x^4 + 6*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 46, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 46*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 14*]*], [*4, [*x^4 + 8*x + 14*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 16*x + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 16*x^3 + 24*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 20*y^4 + 16*y^3 + 24*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 10*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 16*x + 10, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^6 + 16*y + 10*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 58, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 58*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 26*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 16*x + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 16*y + 26*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 16*x + 58, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^6 + 16*y + 58*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 8*x^4 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 24*x^2 + 62, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 28*y^4 + 24*y^2 + 62*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 8*x^2 + 46, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 20*y^4 + 8*y^2 + 46*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 16*x + 26, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 16*y + 26*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 40*x^4 + 56, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 2264*y^6 + 4156*y^4 + 5992*y^2 + 350*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 8*x^2 + 62, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 28*y^4 + 8*y^2 + 62*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 42, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 42*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^6 + 8*x^5 + 16*x^2 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 8*x^2 + 14, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 8*y^2 + 14*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 8*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 8*y^2 + 30*], 0, [*-2, 0*], 3, 0, -1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 10*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 18*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 28*x^4 + 24*x^2 + 30, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^6 + 28*y^4 + 24*y^2 + 30*], 0, [*-2, 0*], 3, 0, 1, [*[*2, [*x^2 + 10*]*], [*4, [*x^4 + 26*]*]*], 0, [*x^8 + 8*x^7 + 8*x^5 + 2*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^4 + 8*x^2 + 16*x + 18, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^4 + 8*y^2 + 16*y + 18*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 + 2760*x^6 + 3457972308*x^4 - 901992960*x^2 + 2146681446, [*x^4 + 4*x^2 + 14, x^4 + 4*x^2 + 14*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 16*x^3 + 8*x^2 + 16*x + 2, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 16*y^3 + 8*y^2 + 16*y + 2*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 + 104*x^6 + 40060*x^4 + 908112*x^2 + 350519334, [*x^8 + 12*x^6 + 10*x^4 + 8*x^2 + 36*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 16*x + 18, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^2 + 16*y + 18*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 - 602210568*x^6 + 90715195541025012*x^4 - 38225576453003424*x^2 + 56916186639540774, [*x^4 + 4*x^2 + 14, x^4 + 4*x^2 + 14*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 16*x^3 + 6, [*16, "t", [*8, 8*]*], 16, [*8, "t", [*8, 1*], "<i>C</i><sub>8</sub>"*], [*3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 16*y^3 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 - 8*x^6 + 92*x^4 - 336*x^2 + 1254, [*x^8 + 12*x^6 + 10*x^4 + 8*x^2 + 36*], 31/8, 2*], [*2, 31, 8, 1, 8, x^8 + 96, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 486*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 486, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 10*x^4 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 38, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 38*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 3888*x^4 + 3888*x^2 + 3779622, [*x^8 + 6*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^7 + 16*x^6 + 24*x^2 + 16*x + 2, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^7 + 16*y^6 + 24*y^2 + 16*y + 2*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 - 264*x^6 + 17508*x^4 - 9648*x^2 + 10374, [*x^8 + 48*x^4 + 16*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 4*x^4 + 16*x^2 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 4*y^4 + 16*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 - 34968*x^6 + 455505153924*x^4 - 317015391312*x^2 + 275051764806, [*x^8 + 48*x^4 + 16*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 24, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 1782, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 10*x^4 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 54, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 191664*x^4 + 52272*x^2 + 9183774006, [*x^8 + 6*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^5 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 432*x^4 - 144*x^2 + 46662, [*x^8 + 6*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 12*x^4 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 12*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 - 24*x^6 + 4684*x^4 - 127008*x^2 + 9531654, [*x^8 + 20*x^4 + 4*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 12*x^4 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 7*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 12*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 - 1000*x^6 + 3471596*x^4 - 1331977344*x^2 + 2664297457734, [*x^8 + 20*x^4 + 4*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 6, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 6, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 10*x^4 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 384, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 8*]*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 4374*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 22, [*x^8 + 8*x^7 + 4*x^6 + 8*x^5 + 10*x^4 + 4*x^2 + 8*x + 14*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 22, [*32, "t", [*8, 15*]*], 32, [*16, "t", [*8, 6*], "<i>D</i><sub>8</sub>"*], [*2, 3, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^5 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 21296*x^4 - 1936*x^2 + 113379926, [*x^8 + 6*x^4 + 36*], 4, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 16*x^2 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 16*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 88*x^6 + 24200*x^4 - 454415984*x^2 + 1207382831974, [*x^8 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 - 9072*x^6 + 20579292*x^4 - 17678736*x^2 + 100567494, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 24*x^6 + 216*x^4 + 864*x^2 + 1302, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 16*x^5 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 16*y^5 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 - 938872*x^6 + 330122395944*x^4 - 51521841511779760*x^2 + 3011644891977508342886, [*x^8 + 4*x^6 + 8*x^4 + 8*x^3 + 8*x^2 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 8*x^4 + 16*x^2 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 8*y^4 + 16*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 + 24*x^6 + 648*x^4 - 191088*x^2 + 10125654, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 20*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 + 36*x^4 + 486, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 54, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 - 16*x^6 + 500*x^4 - 3408*x^2 + 45606, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 26*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 28*y^4 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 + 3024*x^6 + 2286588*x^4 + 654768*x^2 + 1241574, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 4*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 4*y^4 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 + 4*x^4 + 6, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^3 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 - 120*x^6 + 6264*x^4 - 159840*x^2 + 364477974, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 16*x^2 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 16*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 6*]*]*], x^8 - 5304*x^6 + 10395432*x^4 - 8920388016*x^2 + 2834545203798, [*x^8 + 12*x^6 + 8*x^5 + 8*x^3 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 + 12*x^4 + 6, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 22, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^3 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 - 1848*x^6 + 1323256*x^4 - 433799520*x^2 + 584373177519142, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 17*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 22*]*]*], x^8 + 88*x^6 + 2904*x^4 + 42592*x^2 + 234278, [*x^8 + 4*x^6 + 8*x^3 + 8*x^2 + 14*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 20*x^4 + 54, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 20*y^4 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 4*x^2 + 6*]*]*], x^8 + 48*x^6 + 4500*x^4 + 92016*x^2 + 3694086, [*x^8 + 4*x^6 + 12*x^4 + 8*x^3 + 26*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 6, [*64, "t", [*8, 26*]*], 64, [*32, "t", [*8, 16*]*], [*2, 3, 7/2, 4, 5*], [*1, 2*], [*t + 1, y^8 + 28*y^4 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 12*x^2 + 6*]*]*], x^8 + 108*x^4 + 486, [*x^8 + 8*x^7 + 4*x^6 + 12*x^4 + 8*x^3 + 10*], 67/16, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 38, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 38*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 22, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 54, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 6, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 54, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 24*x^6 + 104*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 8*x^4 + 8*x^2 + 54, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^6 + 8*y^4 + 8*y^2 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 54, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^2 + 54*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 24*x^6 + 104*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 88, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 128*y^6 + 1056*y^4 + 2904*y^2 + 2662*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^2 + 38, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^6 + 8*y^2 + 38*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^2 + 22, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 24*x^6 + 104*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 22, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 22*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 4*x^2 + 10*]*]*], 0, [*x^8 + 8*x^7 + 24*x^6 + 104*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 16*x^5 + 8*x^2 + 54, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 24*y^6 + 16*y^5 + 8*y^2 + 54*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x^2 + 8*x + 22*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 30*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^2 + 38, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^2 + 38*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 8*x^2 + 6, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 8*y^4 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^5 + 8*x^4 + 24*x^2 + 6, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 16*y^5 + 8*y^4 + 24*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 12*x^2 + 10*]*]*], 0, [*x^8 + 8*x^5 + 12*x^4 + 14*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 216, [*64, "t", [*8, 27*]*], 64, [*64, "t", [*8, 27*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 1*], [*t + 1, y^8 + 1064*y^6 + 59976*y^4 + 230040*y^2 + 257094*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 6*]*], [*4, [*x^4 + 8*x + 6*]*]*], 0, [*x^8 + 8*x^5 + 8*x^2 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 8*x^4 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 8*y^4 + 16*y + 2*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^7 + 16*x^5 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^7 + 16*y^5 + 16*y + 2*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^2 + 16*x + 50, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^2 + 16*y + 50*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^5 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 12*x^4 + 24*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 12*y^4 + 24*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 28*x^4 + 8*x^2 + 38, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 28*y^4 + 8*y^2 + 38*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 50, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 50*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^5 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 16*x^5 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^6 + 16*y^5 + 16*y + 2*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^6 + 16*x + 50, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^6 + 16*y + 50*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^5 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 34, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 34*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 28*x^4 + 8*x^2 + 6, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 28*y^4 + 8*y^2 + 6*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 18, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 18*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^5 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^4 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^4 + 16*y + 2*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y + 2*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 24*x^6 + 28*x^4 + 8*x^2 + 38, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 24*y^6 + 28*y^4 + 8*y^2 + 38*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 18*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 10*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 8*x^6 + 28*x^4 + 8*x^2 + 22, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 8*y^6 + 28*y^4 + 8*y^2 + 22*], 0, [*-2, 1*], 3, 1, -1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 141/32, 2*], [*2, 31, 8, 1, 8, x^8 + 16*x^3 + 16*x + 2, [*128, "t", [*8, 35*]*], 128, [*64, "t", [*8, 28*]*], [*2, 3, 7/2, 4, 17/4, 5*], [*1, 2*], [*t + 1, y^8 + 16*y^3 + 16*y + 2*], 0, [*-2, 1*], 3, 1, 1, [*[*2, [*x^2 + 2*]*], [*4, [*x^4 + 2*]*]*], 0, [*x^8 + 8*x^6 + 8*x^5 + 26*], 141/32, 2*]*];